SystemOrganization addCategory: #CMakeVMMaker!
SystemOrganization addCategory: #'CMakeVMMaker-Android'!
SystemOrganization addCategory: #'CMakeVMMaker-FreeBSD'!
SystemOrganization addCategory: #'CMakeVMMaker-IOS'!
SystemOrganization addCategory: #'CMakeVMMaker-Libs'!
SystemOrganization addCategory: #'CMakeVMMaker-MacOS'!
SystemOrganization addCategory: #'CMakeVMMaker-Unix'!
SystemOrganization addCategory: #'CMakeVMMaker-Windows'!

!String methodsFor: '*cmakevmmaker-extensions' stamp: 'EstebanLorenzano 7/20/2012 11:22'!
nameFormat: aDictionary 
	"format the receiver with aDictionary 
	 
	simplest example:  
	'foo {name} bar' format: {'name'->value}. 
	"
	| result stream |
	result := String new writeStream.
	stream := self readStream.

	[stream atEnd]
		whileFalse: [| currentChar | 
			currentChar := stream next.
			currentChar == ${
				ifTrue: [| expression | 
					expression := self getEnclosedExpressionFrom: stream.
					result nextPutAll: (aDictionary at: expression ifAbsent: [ 'UNDEFINED' ]) asString ]
				ifFalse: [
					currentChar == $\
						ifTrue: [
							stream atEnd
								ifFalse: [result nextPut: stream next]]
						ifFalse: [result nextPut: currentChar]]].

	^ result contents! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/21/2010 14:26'!
addExtraCMakeRules: maker
	"Add extra rules/commands to cmake configuration for building this plugin.
	By default , do nothing"! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: ''!
browseSettings

	^ CPlatformConfig browsePluginRules: self! !

!InterpreterPlugin class methodsFor: '*CMakeVMMaker' stamp: 'Igor.Stasenko 12/22/2010 01:10'!
generateFor: aCMakeVMGenerator internal: aBoolean 

	^ aCMakeVMGenerator 
		generatePlugin: self 
		internal: aBoolean
		extraRules: nil! !

Object subclass: #CMThirdpartyLibrary
	instanceVariableNames: 'gen vmGen configurationFlags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMThirdpartyLibrary commentStamp: 'IgorStasenko 6/7/2012 04:53' prior: 0!
My subclasses describing a configuration/settings necessary to build some third-party library used by VM
or by one of it's plugins.

We cannot use cmake configuration for those libraries, since most of them having own 
configuration/make scripts which build that library.

I serve as a convenience layer for building those libraries and connecting them with cmake configuration,
as well as provide necessary information, what output file(s) should be bundled with virtual machine.
!

CMThirdpartyLibrary subclass: #CMCairoBundle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMCairoBundle commentStamp: 'IgorStasenko 9/26/2012 16:14' prior: 0!
this is common superclass for defining settings for building cairo and accompanied libraries!

CMCairoBundle subclass: #CMCairo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMCairo commentStamp: 'IgorStasenko 9/26/2012 14:30' prior: 0!
This is Cairo library config for building on MacOSX!

!CMCairo class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/10/2012 01:04'!
canonicalName
	^ 'cairo'! !

!CMCairo methodsFor: 'package properties' stamp: 'IgorStasenko 10/23/2012 13:38'!
archiveMD5Sum

	^ '645b7c1421ed52260d0853e3215c1d8f'! !

!CMCairo methodsFor: 'generating actions' stamp: 'IgorStasenko 10/23/2012 15:01'!
build
	gen 
		puts:
'
add_custom_command(OUTPUT "${libcairoInstalled}"
	COMMAND ./configure --prefix=''${installPrefix}'' PKG_CONFIG="${pkgconfigPath}"
		PKG_CONFIG_PATH="${installPrefix}/lib/pkgconfig" CFLAGS=''-arch i386'' LDFLAGS=''-arch i386''
		--disable-silent-rules --disable-xlib --disable-dependency-tracking
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}" pkg-config freetype2 libpng pixman
	COMMENT "Building ${libName}"
)
'
! !

!CMCairo methodsFor: 'generating actions' stamp: 'IgorStasenko 8/3/2012 17:57'!
copyArtefacts

	self 
		copy: '${libcairoInstalled}' 
		to: '${externalModulesDir}/${libraryFileName}'
! !

!CMCairo methodsFor: 'generating actions' stamp: 'IgorStasenko 10/22/2012 17:18'!
defineAsTarget
	
	gen puts:
	'add_custom_target(${libName}
		DEPENDS pixman freetype2 "${externalModulesDir}/${libraryFileName}" 
	)'! !

!CMCairo methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:50'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" SHARED IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!CMCairo methodsFor: 'package properties' stamp: ''!
dependencies
	^ #( 'pkg-config' 'pixman' 'libpng' 'freetype2')! !

!CMCairo methodsFor: 'package properties' stamp: 'IgorStasenko 10/23/2012 13:35'!
downloadURL

	^ 'http://www.cairographics.org/releases/cairo-1.12.6.tar.xz'! !

!CMCairo methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 01:20'!
libraryFileName

	^ 'libcairo.2.dylib'! !

!CMCairo methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:13'!
setVariables
	super setVariables.
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libcairoInstalled toString: '${installPrefix}/lib/${libraryFileName}'.
		! !

!CMCairo methodsFor: 'generating actions' stamp: 'IgorStasenko 5/30/2013 14:55'!
unpack
	"produce commands for unpacking the library archive.
	
	the output of this command should use a directory
	${workDir}/${libName}
	where the unpacked library sources will be located.
	
	see #setVariables method for understanding what variables used here
	
	NOTE: had to override since cairo uses 7z compression
	"

	gen set: #unpackTarget toString: '${libSourcesDir}/touch.cmake'.
	
	gen puts:
'add_custom_command(OUTPUT "${unpackTarget}"
		COMMAND tar -Jxf "${archiveFileName}"  
		COMMAND touch "${unpackTarget}"
		COMMENT "Unpacking ${libName} ... "
	)
'.
! !

!CMCairo methodsFor: 'package properties' stamp: 'IgorStasenko 10/23/2012 13:53'!
unpackedDirName
	^ 'cairo-1.12.6'! !

CMCairo subclass: #CMWin32Cairo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32Cairo class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:05'!
supports: aConfig
	^  aConfig platformName  = 'win32' ! !

!CMWin32Cairo methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/23/2012 15:02'!
build
" Note: echo  #define _SSIZE_T_DEFINED 1 >> config.h
there just for a workaround of bug in cairo,
which fails the build it when building some unrelared utils. It does not affects library build, but i don't know how to tell it to not bother
building everything but just library
"


	gen 
		puts:
'
add_custom_command(OUTPUT "${libcairoInstalled}"
	COMMAND ./configure --prefix=''${installPrefix}'' PKG_CONFIG="${pkgconfigPath}"
		PKG_CONFIG_PATH="${installPrefix}/lib/pkgconfig" CFLAGS="-m32 -march=pentium4 -I${installPrefix}/include" LDFLAGS="-m32 -march=pentium4 -L${installPrefix}/lib"
		--disable-silent-rules --disable-xlib --disable-dependency-tracking

	COMMAND echo "#define _SSIZE_T_DEFINED 1" >> config.h
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}" pkg-config freetype2 libpng pixman
	COMMENT "Building ${libName}"
)
'
! !

!CMWin32Cairo methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/23/2012 13:35'!
libraryFileName

	^ 'libcairo-2.dll'! !

!CMWin32Cairo methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/23/2012 15:06'!
setVariables
	super setVariables.
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libcairoInstalled toString: '${installPrefix}/bin/${libraryFileName}'.
		! !

!CMCairoBundle class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/26/2012 14:32'!
canonicalName
	^ nil! !

!CMCairoBundle class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:05'!
supports: aConfig
	"right now, Mac only"
	^  aConfig platformName  = 'iOS' ! !

!CMCairoBundle methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:12'!
macOSXBuildFlags
	^ 'CFLAGS=''-m32 -march=pentium4'' LDFLAGS=''-m32 -march=pentium4"'! !

!CMCairoBundle methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:12'!
win32BuildFlags
	^ 'CFLAGS=''-m32 -march=pentium4'' LDFLAGS=''-m32 -march=pentium4"'! !

CMCairoBundle subclass: #CMLibPng
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMLibPng class methodsFor: 'as yet unclassified' stamp: ''!
canonicalName
	^ 'libpng'! !

!CMLibPng methodsFor: 'package properties' stamp: 'IgorStasenko 9/18/2012 16:28'!
archiveMD5Sum

	^ '39a35257cd888d29f1d000c2ffcc79eb'! !

!CMLibPng methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 01:30'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${libpngInstalled}"
	COMMAND ./configure --prefix=''${installPrefix}'' PKG_CONFIG="${pkgconfigPath}"
		PKG_CONFIG_PATH="${installPrefix}/lib/pkgconfig" CFLAGS=''-arch i386'' LDFLAGS=''-arch i386''
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}" pkg-config
	COMMENT "Building ${libName}"
)
'
! !

!CMLibPng methodsFor: 'generating actions' stamp: 'IgorStasenko 6/9/2012 23:29'!
copyArtefacts

	gen puts:
'add_custom_command(
	OUTPUT "${externalModulesDir}/${libraryFileName}"
	COMMAND cp ${libpngInstalled} ${externalModulesDir}/${libraryFileName}
	DEPENDS "${libpngInstalled}"
)'! !

!CMLibPng methodsFor: 'generating actions' stamp: 'IgorStasenko 10/24/2012 16:49'!
defineAsTarget
	
	gen puts:
	'add_custom_target(${libName}
		DEPENDS "${externalModulesDir}/${libraryFileName}"
	)'! !

!CMLibPng methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:50'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" SHARED IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!CMLibPng methodsFor: 'package properties' stamp: ''!
dependencies
	^ #( 'pkg-config' )! !

!CMLibPng methodsFor: 'package properties' stamp: 'IgorStasenko 9/18/2012 16:28'!
downloadURL
	^ 'ftp://ftp.simplesystems.org/pub/libpng/png/src/history/libpng12/libpng-1.2.49.tar.gz'
! !

!CMLibPng methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 01:21'!
libraryFileName

	^ 'libpng12.0.dylib'! !

!CMLibPng methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:13'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libpngInstalled toString: '${installPrefix}/lib/${libraryFileName}'.
		! !

!CMLibPng methodsFor: 'package properties' stamp: ''!
unpackedDirName
	^ 'libpng-1.2.49'! !

CMLibPng subclass: #CMWin32LibPng
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32LibPng class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:05'!
supports: aConfig
	^  aConfig platformName  = 'win32' ! !

!CMWin32LibPng methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/22/2012 17:02'!
build

"LIBS=-L${installPrefix}/lib"
	gen 
		puts:
'
add_custom_command(OUTPUT "${libpngInstalled}"
	COMMAND ./configure --prefix=''${installPrefix}'' CFLAGS="-m32 -march=pentium4 -I${installPrefix}/include" CPPFLAGS="-m32 -I${installPrefix}/include" LDFLAGS="-m32 -march=pentium4 -L${installPrefix}/lib" 
	COMMAND make
	COMMAND make install
	COMMAND cp "${installPrefix}/lib/libpng.dll.a" "${installPrefix}/lib/libpng12.dll.a"
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}" pkg-config
	COMMENT "Building ${libName}"
)
'
! !

!CMWin32LibPng methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/24/2012 16:49'!
defineAsTarget
	
	gen puts:
	'add_custom_target(${libName}
		DEPENDS zlib "${externalModulesDir}/${libraryFileName}"
	)'! !

!CMWin32LibPng methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 15:37'!
dependencies
	^ #( 'pkg-config' 'zlib')! !

!CMWin32LibPng methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/22/2012 15:24'!
downloadURL
	^ 'ftp://ftp.simplesystems.org/pub/libpng/png/src/history/libpng12/libpng-1.2.49.tar.gz'
! !

!CMWin32LibPng methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/22/2012 17:17'!
libraryFileName

	^ 'libpng-3.dll'! !

!CMWin32LibPng methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 18:32'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libpngInstalled toString: '${installPrefix}/bin/${libraryFileName}'.
		! !

CMCairoBundle subclass: #CMPixman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMPixman class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/10/2012 00:52'!
canonicalName
	^ 'pixman'! !

!CMPixman methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 00:53'!
archiveMD5Sum

	^ '6563b6400b9fa23b47fd52105faf72b4'! !

!CMPixman methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 01:30'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${libpixmanInstalled}"
	COMMAND ./configure --prefix=''${installPrefix}'' PKG_CONFIG="${pkgconfigPath}"
		PKG_CONFIG_PATH="${installPrefix}/lib/pkgconfig" CFLAGS=''-arch i386'' LDFLAGS=''-arch i386''
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}" pkg-config
	COMMENT "Building ${libName}"
)
'
! !

!CMPixman methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 00:57'!
copyArtefacts

	gen puts:
'add_custom_command(
	OUTPUT "${externalModulesDir}/${libraryFileName}"
	COMMAND cp ${libpixmanInstalled} ${externalModulesDir}/${libraryFileName}
	DEPENDS "${libpixmanInstalled}"
)'! !

!CMPixman methodsFor: 'generating actions' stamp: 'IgorStasenko 10/22/2012 17:19'!
defineAsTarget
	
	gen puts:
	'add_custom_target(${libName}
		DEPENDS libpng "${externalModulesDir}/${libraryFileName}" 
	)'! !

!CMPixman methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:50'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" SHARED IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!CMPixman methodsFor: 'package properties' stamp: 'IgorStasenko 6/11/2012 00:46'!
dependencies
	^ #( 'pkg-config' 'libpng')! !

!CMPixman methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 00:52'!
downloadURL

	^ 'http://www.cairographics.org/releases/pixman-0.26.0.tar.gz'! !

!CMPixman methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 00:54'!
libraryFileName

	^ 'libpixman-1.0.dylib'! !

!CMPixman methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:13'!
setVariables
	super setVariables.
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libpixmanInstalled toString: '${installPrefix}/lib/${libraryFileName}'.
		
	! !

!CMPixman methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 00:52'!
unpackedDirName
	^ 'pixman-0.26.0'! !

CMPixman subclass: #CMWin32Pixman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32Pixman class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:05'!
supports: aConfig
	^  aConfig platformName  = 'win32' ! !

!CMWin32Pixman methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/22/2012 13:33'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${libpixmanInstalled}"
	COMMAND ./configure --prefix=''${installPrefix}'' PKG_CONFIG="${pkgconfigPath}"
		PKG_CONFIG_PATH="${installPrefix}/lib/pkgconfig" CFLAGS="-m32 -march=pentium4 -I${installPrefix}/include" LDFLAGS="-m32 -march=pentium4" LIBS="-L${installPrefix}/lib"
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}" pkg-config
	COMMENT "Building ${libName}"
)
'
! !

!CMWin32Pixman methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/22/2012 13:38'!
libraryFileName 
	^ 'libpixman-1-0.dll'! !

!CMWin32Pixman methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/22/2012 13:34'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libpixmanInstalled toString: '${installPrefix}/bin/${libraryFileName}'.
		! !

CMCairoBundle subclass: #CMPkgConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMPkgConfig commentStamp: 'IgorStasenko 6/9/2012 21:48' prior: 0!
this will build a pkg-config package, required to built cairo
!

!CMPkgConfig class methodsFor: 'as yet unclassified' stamp: ''!
canonicalName
	^ 'pkg-config'! !

!CMPkgConfig methodsFor: 'package properties' stamp: 'IgorStasenko 6/9/2012 22:00'!
archiveMD5Sum

	^ 'd922a88782b64441d06547632fd85744'! !

!CMPkgConfig methodsFor: 'generating actions' stamp: ''!
build
	gen 
		puts: '
add_custom_command(OUTPUT "${pkgConfigBinary}"
	COMMAND ./configure --prefix=''${installPrefix}'' CFLAGS=''-arch i386'' LDFLAGS=''-arch i386''
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
	COMMENT "Building ${libName}"
)
'
! !

!CMPkgConfig methodsFor: 'generating actions' stamp: ''!
copyArtefacts
	"do nothing.. "! !

!CMPkgConfig methodsFor: 'generating actions' stamp: 'IgorStasenko 10/22/2012 17:15'!
defineAsTarget
	
	gen puts: '
add_custom_target(${libName} 
	DEPENDS "${pkgConfigBinary}"
	)
'

! !

!CMPkgConfig methodsFor: 'generating actions' stamp: 'IgorStasenko 6/9/2012 22:24'!
defineGlobalTargets

	"none"
	vmGen
		set: #installPrefix toString: '${thirdpartyDir}/out';
		set: #pkgconfigPath toString: '${installPrefix}/bin/pkg-config'
		! !

!CMPkgConfig methodsFor: 'package properties' stamp: ''!
downloadURL

	^ 'http://pkgconfig.freedesktop.org/releases/pkg-config-0.23.tar.gz'! !

!CMPkgConfig methodsFor: 'generating actions' stamp: ''!
setVariables

	super setVariables.
	
	gen set: #pkgConfigBinary toString: '${installPrefix}/bin/pkg-config'! !

!CMPkgConfig methodsFor: 'package properties' stamp: 'IgorStasenko 6/9/2012 21:59'!
unpackedDirName

	^ 'pkg-config-0.23'! !

CMPkgConfig subclass: #CMWin32PkgConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32PkgConfig commentStamp: '<historical>' prior: 0!
- use 0.27.1 version from official source, which builds on windows

http://pkgconfig.freedesktop.org/releases/pkg-config-0.27.1.tar.gz

- ./configure --with-internal-glib -!

!CMWin32PkgConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 15:04'!
supports: aConfig
	^  aConfig platformName  = 'win32' ! !

!CMWin32PkgConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 14:44'!
archiveMD5Sum 
	^ '5392b4e3372879c5bf856173b418d6a2'! !

!CMWin32PkgConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 14:49'!
build
	gen 
		puts: '
add_custom_command(OUTPUT "${pkgConfigBinary}"
	COMMAND ./configure --prefix="${installPrefix}" --with-internal-glib CFLAGS="-m32 -march=pentium4" LDFLAGS="-m32 -march=pentium4"
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
	COMMENT "Building ${libName}"
)
'
! !

!CMWin32PkgConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 17:55'!
defineGlobalTargets

	"none"
	vmGen
		set: #installPrefix toString: '${thirdpartyDir}/out';
		set: #pkgconfigPath toString: '${installPrefix}/bin/pkg-config.exe'
		! !

!CMWin32PkgConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 14:47'!
downloadURL 
	^ 'http://pkgconfig.freedesktop.org/releases/pkg-config-0.27.1.tar.gz'! !

!CMWin32PkgConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 15:31'!
setVariables

	super setVariables.
	
	gen set: #pkgConfigBinary toString: '${installPrefix}/bin/pkg-config.exe'! !

!CMWin32PkgConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 14:48'!
unpackedDirName

	^ 'pkg-config-0.27.1'! !

CMThirdpartyLibrary subclass: #CMFreetype2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMFreetype2 commentStamp: 'IgorStasenko 6/7/2012 02:50' prior: 0!
This is a configuration for building freetype2 library!

!CMFreetype2 class methodsFor: 'accessing' stamp: ''!
canonicalName
	^ 'freetype2'! !

!CMFreetype2 methodsFor: 'package properties' stamp: 'IgorStasenko 6/7/2012 17:04'!
archiveMD5Sum

	^ 'c15f6dc8ed190d67b89ae09aaf7896b4'! !

!CMFreetype2 methodsFor: 'generating actions' stamp: 'EstebanLorenzano 7/9/2012 12:29'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${ft2config}"
	COMMAND ./configure --prefix=''${installPrefix}'' ', self configurationFlags, '
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
)
add_custom_command(OUTPUT "${ft2libInstalled}"
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${ft2config}"
	COMMENT "Building ${libName}"
)
'
! !

!CMFreetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 8/3/2012 17:58'!
copyArtefacts

	self 
		copy: '${ft2libInstalled}' 
		to: '${externalModulesDir}/${libraryFileName}'.! !

!CMFreetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 6/8/2012 02:13'!
defineAsTarget

	gen puts:
	
'
add_custom_target(${libName} 
	DEPENDS ${externalModulesDir}/${libraryFileName}
	)
'

! !

!CMFreetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 6/10/2012 02:50'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" SHARED IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!CMFreetype2 methodsFor: 'package properties' stamp: ''!
downloadURL
	^ 'http://ftp.igh.cnrs.fr/pub/nongnu/freetype/freetype-2.4.9.tar.gz'
! !

!CMFreetype2 methodsFor: 'accessing' stamp: 'IgorStasenko 6/7/2012 22:46'!
includeDir
	"see setVariables"

" `<prefix>/include/freetype2' must be in your current inclusion path "


	^ '"${thirdpartyDir}/out/include" "${thirdpartyDir}/out/include/freetype2"'! !

!CMFreetype2 methodsFor: 'package properties' stamp: ''!
libraryFileName
	^ 'libfreetype.6.dylib'! !

!CMFreetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 6/8/2012 23:21'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #freetype2_includeDir toString: '${installPrefix}/include';
		set: #libraryFileName to: self libraryFileName;
		set: #freetype2_location toString: '${externalModulesDir}/${libraryFileName}';
		set: #ft2config toString: '${libSourcesDir}/builds/unix/config.status';
	 	set: #ft2libInstalled toString: '${installPrefix}/lib/${libraryFileName}'! !

!CMFreetype2 methodsFor: 'package properties' stamp: ''!
unpackedDirName

	^ 'freetype-2.4.9'! !

CMFreetype2 subclass: #CMOSXFreetype2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

CMOSXFreetype2 subclass: #CMIOSFreetype2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMIOSFreetype2 class methodsFor: 'testing' stamp: 'EstebanLorenzano 2/28/2013 12:56'!
supports: aConfig 
	"just for iPhone"

	^ (self platformName = aConfig platformName) 
		and: [ aConfig isKindOf: StackIPhoneConfig ]! !

!CMIOSFreetype2 methodsFor: 'generating actions' stamp: 'EstebanLorenzano 8/7/2012 16:24'!
copyArtefacts

	gen puts:
'add_custom_command(
	OUTPUT "${externalModulesDir}/${libraryFileName}"
	DEPENDS "${ft2libInstalled}"
)'! !

!CMIOSFreetype2 methodsFor: 'generating actions' stamp: 'EstebanLorenzano 8/7/2012 14:23'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self libraryFileName.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" STATIC IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!CMIOSFreetype2 methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/28/2013 12:53'!
includeDir
	"see setVariables"

" `<prefix>/include/freetype2' must be in your current inclusion path "

	^ '"${thirdpartyDir}/freetype2/freetype-2.4.9/include"'! !

!CMIOSFreetype2 methodsFor: 'package properties' stamp: 'EstebanLorenzano 8/7/2012 16:06'!
libraryFileName 
	^'libfreetype.a'! !

!CMIOSFreetype2 methodsFor: 'exports' stamp: 'EstebanLorenzano 8/7/2012 16:24'!
targetForLinking
	"Answer a target or path to library to link with, which can be used by 
	external plugins or VM module"

	^ '${ft2libInstalled}/', self libraryFileName! !

!CMOSXFreetype2 class methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/1/2012 12:01'!
platformName 
	^'iOS'! !

!CMOSXFreetype2 class methodsFor: 'testing' stamp: 'EstebanLorenzano 2/28/2013 12:55'!
supports: aConfig 
	"just for iPhone"

	^ (super supports: aConfig) 
		and: [ (aConfig isKindOf: StackIPhoneConfig) not ]! !

CMFreetype2 subclass: #CMWin32Freetype2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32Freetype2 commentStamp: '<historical>' prior: 0!
Some overrides to make freetype build on windows:

Two artifacts to copy:

libfreetype.dll.a
libfreetype-6.dll

the first one is used at link time with FTPlugin to 
designate the exported symbols of .dll as well as .dll file name.

The second one is ready to use library produced by freetype makefiles.

We pass

 -march=i686

instead of

 -arch i386

to freetype configure, because MSYS GCC on windows don't understands the -arch option.
!

!CMWin32Freetype2 class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/1/2012 16:36'!
platformName 
	^'win32'! !

!CMWin32Freetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 8/1/2012 17:36'!
copyArtefacts

	gen puts:
'add_custom_command(
	OUTPUT "${externalModulesDir}/${libraryFileName}"
	COMMAND cp "${ft2libInstalled}" "${externalModulesDir}"
	COMMAND cp "${ft2binInstalled}" "${externalModulesDir}"
	DEPENDS "${ft2libInstalled}"
)'! !

!CMWin32Freetype2 methodsFor: 'settings' stamp: 'IgorStasenko 8/1/2012 16:48'!
defaultConfigurationFlags 
	^#(
		'CFLAGS=''-march=i686''' 
		'LDFLAGS=''-march=i686''')! !

!CMWin32Freetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 8/1/2012 19:24'!
defineGlobalTargets
	| var |
	var := self canonicalName , '_LIB'.
	vmGen set: var toString: self targetForLinking.
"
define a library as imported one
and make it depend from it's build target
"
	vmGen
		puts: 
('add_library("{1}" STATIC IMPORTED GLOBAL)
	set_target_properties("{1}" PROPERTIES IMPORTED_LOCATION "{1}")
add_dependencies("{1}" "{2}")
' format: { '${',var, '}' . self buildTarget }
).

	vmGen cmd: 'add_dependencies' params:
		vmGen moduleName , ' ' , self buildTarget! !

!CMWin32Freetype2 methodsFor: 'package properties' stamp: 'IgorStasenko 8/1/2012 17:49'!
libraryFileName
	^ 'libfreetype.dll.a'! !

!CMWin32Freetype2 methodsFor: 'generating actions' stamp: 'IgorStasenko 8/1/2012 17:51'!
setVariables
	super setVariables.
	
"add include path"
	gen 
		set: #freetype2_includeDir toString: '${installPrefix}/include';
		set: #libraryFileName to: self libraryFileName;
		set: #freetype2_location toString: '${externalModulesDir}/${libraryFileName}';
		set: #ft2config toString: '${libSourcesDir}/builds/unix/config.status';
	 	set: #ft2libInstalled toString: '${installPrefix}/lib/${libraryFileName}';
	 	set: #ft2binInstalled toString: '${installPrefix}/bin/libfreetype-6.dll'.
		! !

CMThirdpartyLibrary subclass: #CMOpenSSL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMOpenSSL class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 18:01'!
canonicalName
	^ 'openssl'! !

CMOpenSSL subclass: #CMWin32OpenSSL
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32OpenSSL class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 14:27'!
platformName 
	^'win32'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 15:11'!
archiveMD5Sum
	"answer the MD5 checksum (in string) for downloaded library archive 
	(to check that downloaded file is not corrupt).
	
	You can take this sum by issuing:
	  md5 filename
	from command line
	"
	^ 'ae412727c8c15b67880aef7bd2999b2e'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/25/2012 16:08'!
build

	gen 
		puts:
'
add_custom_command(OUTPUT "${libSourcesDir}/Makefile"
	COMMAND ./config shared --prefix=''${installPrefix}'' 
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
)

add_custom_command(OUTPUT "${installPrefix}/bin/libeay32.dll" "${installPrefix}/bin/ssleay32.dll"
	COMMAND make
	COMMAND make install
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${libSourcesDir}/Makefile"
	COMMENT "Building ${libName}"
)
'
! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 18:20'!
configurationFlags
	^ 'shared'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/28/2012 18:39'!
copyArtefacts 

	self copy: '${installPrefix}/bin/libeay32.dll' to: '${externalModulesDir}/libeay32.dll'.
	self copy: '${installPrefix}/bin/ssleay32.dll' to: '${externalModulesDir}/ssleay32.dll'.
"	self copy: '${installPrefix}/lib/libssl.dll.a' to: '${externalModulesDir}/libssl.dll.a'.
	self copy: '${installPrefix}/lib/libcrypto.dll.a' to: '${externalModulesDir}/libcrypto.dll.a'.
"
"
'libcrypto.dll.a' 'libssl.dll.a'.
"! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 9/28/2012 14:41'!
defineAsTarget 
	
	gen puts:
	'add_custom_target(', self buildTarget , '
		DEPENDS 
		"${externalModulesDir}/libeay32.dll"
		"${externalModulesDir}/ssleay32.dll"
	)'
	
		"${externalModulesDir}/${libraryFileName}"
! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 12:55'!
defineGlobalTargets 

! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 14:33'!
downloadURL 
	^'http://www.openssl.org/source/openssl-1.0.1c.tar.gz'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 18:08'!
includeDir

	^ '"${thirdpartyDir}/out/include"'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 18:31'!
libraryFileName
	^ 'libssl.dll.a'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 18:31'!
setVariables 
	super setVariables.
	
	gen
		set: #libraryFileName to: self libraryFileName;
		set: #libInstalled to: '${installPrefix}/lib/${libraryFileName}'! !

!CMWin32OpenSSL methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/3/2012 15:12'!
unpackedDirName
	^ 'openssl-1.0.1c'! !

!CMThirdpartyLibrary class methodsFor: 'accessing' stamp: ''!
canonicalName
	"answer the library canonical name, like 
		'freetype2'
		or 'cairo' 
		etc.
		
	Note , this method is used to find the corresponding library
	from all subclasses of CMThirdpartyLibrary	
	"
	^ self subclassResponsibility! !

!CMThirdpartyLibrary class methodsFor: 'instance creation' stamp: 'EstebanLorenzano 8/1/2012 11:56'!
named: aName config: aCPlatformConfig

	^ (self allSubclasses detect: [:cls | 
		cls canonicalName = aName and: [ cls supports: aCPlatformConfig ] ])
		new! !

!CMThirdpartyLibrary class methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/1/2012 11:52'!
platformName 
	^nil! !

!CMThirdpartyLibrary class methodsFor: 'testing' stamp: 'EstebanLorenzano 8/1/2012 11:56'!
supports: aConfig
	"default implementation"
	^ self platformName = aConfig platformName ! !

!CMThirdpartyLibrary methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 5/30/2013 14:33'!
archiveFileName
	^ self downloadURL asUrl fileName ! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: 'IgorStasenko 6/7/2012 03:17'!
archiveMD5Sum
	"answer the MD5 checksum (in string) for downloaded library archive 
	(to check that downloaded file is not corrupt).
	
	You can take this sum by issuing:
	  md5 filename
	from command line
	"
	^ self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: ''!
build

	self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: ''!
buildTarget
	^ self canonicalName! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: 'IgorStasenko 6/7/2012 03:35'!
canonicalName
	"answer the library canonical name, like 
		'freetype2'
		or 'cairo' 
		etc"
	^ self class canonicalName! !

!CMThirdpartyLibrary methodsFor: 'settings' stamp: 'EstebanLorenzano 7/31/2012 09:07'!
configurationFlags 
	^(configurationFlags 
		ifNil: [ self defaultConfigurationFlags ])
		reduce: [ :a :b | a, ' ', b]! !

!CMThirdpartyLibrary methodsFor: 'settings' stamp: 'EstebanLorenzano 7/31/2012 09:07'!
configurationFlags: aCollection
	configurationFlags := aCollection
	! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: 'IgorStasenko 8/3/2012 18:35'!
copy: src to: dest

	| str |

	
	str := 'add_custom_command( OUTPUT "{2}"
	COMMAND cp "{1}" "{2}"
	DEPENDS "{1}"
	)' format: {src. dest }.
	
	gen puts: str! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: ''!
copyArtefacts

	self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'settings' stamp: 'EstebanLorenzano 7/31/2012 09:07'!
defaultConfigurationFlags 
	^#(
		'CFLAGS=''-arch i386''' 
		'LDFLAGS=''-arch i386''')! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: ''!
defineAsTarget

	self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: ''!
defineGlobalTargets
	self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: 'IgorStasenko 6/10/2012 02:12'!
dependencies
	^ #()! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: 'IgorStasenko 5/30/2013 15:21'!
download

	"Produce output to download library archive.
	By default, we use .tgz extension.. since it is most often used by OSS.
	Note, that we check if file is already present, to not download it every time
	we build"	
	
	gen puts:
'if (NOT EXISTS "${workDir}/${archiveFileName}")
	Message("Downloading  ',self fileServerURL,'${archiveFileName}")

	FILE(DOWNLOAD
		', self fileServerURL , self archiveFileName ,'
	 	"${workDir}/${archiveFileName}"
		STATUS downloadStatus
		SHOW_PROGRESS
	)
	
	LIST(GET downloadStatus 0 downloadError)
	if (NOT downloadError EQUAL 0)
		Message("File is missing on file server (', self fileServerURL,'), downloading from official repository...")
		FILE(DOWNLOAD
			${url}
		 	"${workDir}/${archiveFileName}"
			STATUS downloadStatus
			SHOW_PROGRESS
			EXPECTED_MD5 ${md5sum}
		)
		LIST(GET downloadStatus 0 downloadError)
	endif ()
	if (NOT downloadError EQUAL 0)
		message(FATAL_ERROR "Cannot find/download the source file from:" ${url})
	endif ()
		
	
endif ()
'! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: 'IgorStasenko 6/7/2012 02:55'!
downloadURL
	"answer the url where given library can be downloaded from"
	^ self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'settings' stamp: 'IgorStasenko 5/30/2013 13:31'!
fileServerURL
	"Base url to file server where all external libs sources stored"
	^'http://files.pharo.org/vm/src/lib/'! !

!CMThirdpartyLibrary methodsFor: 'generating cmake file' stamp: 'IgorStasenko 6/8/2012 04:24'!
generate

	gen message: 'Configuring thirdparty package: ', self canonicalName.
	
	self 
		setVariables;
		download;
		unpack;
		build;
		copyArtefacts;
		defineAsTarget.! !

!CMThirdpartyLibrary methodsFor: 'generating cmake file' stamp: 'IgorStasenko 10/23/2012 14:11'!
generateFor: aVMGenerator

	| libDir stream contents |
	
	vmGen := aVMGenerator.
	
	gen := CMakeGenerator new
		output: (String new writeStream).
	
	libDir := (aVMGenerator thirdpartyDir / self canonicalName) assureExistence.

	stream := String new writeStream.
	
	self generate.

	stream nextPutAll: (vmGen config fixLineEndsOf: gen output contents).

	contents := stream contents. 
	
	(self isFile: (libDir fullNameFor: gen outputFileName)  hasContents: contents) ifFalse: [
		"contents changed, update the file. Because fucking cmake will force rebuild everything if we change its modification date
		without changing its contents"
		(libDir forceNewFileNamed: gen outputFileName) nextPutAll: contents; close.
		].
	

	vmGen addSubdirectory:  vmGen thirdpartyDirName , '/' , self canonicalName.
	self defineGlobalTargets.
	! !

!CMThirdpartyLibrary methodsFor: 'generating cmake file' stamp: 'IgorStasenko 10/23/2012 14:04'!
isFile: aFileName hasContents: aString

	| newContents old |
	
	newContents := false.
	
	old := FileStream oldFileOrNoneNamed: aFileName.
	
	old ifNil: [ ^ false ].
	
	^ [ old contents = aString ] ensure: [ old close ]! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: ''!
libraryFileName
	"answer the built library file name"

	self subclassResponsibility! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: 'IgorStasenko 5/30/2013 14:36'!
setVariables

	gen
		set: #libName toString: self canonicalName;
		set: #workDir toString: '${thirdpartyDir}/${libName}';
		set: #unpackedDirName toString: self unpackedDirName;
		set: #libSourcesDir toString: '${workDir}/${unpackedDirName}';
		set: #url toString: self downloadURL;
		set: #md5sum toString: self archiveMD5Sum;
		set: #archiveFileName toString: self archiveFileName;
		set: #installPrefix toString: '${thirdpartyDir}/out'.! !

!CMThirdpartyLibrary methodsFor: 'exports' stamp: 'IgorStasenko 6/9/2012 03:53'!
targetForLinking
	"Answer a target or path to library to link with, which can be used by 
	external plugins or VM module"

	^ '${externalModulesDir}/', self libraryFileName! !

!CMThirdpartyLibrary methodsFor: 'generating actions' stamp: 'IgorStasenko 5/30/2013 14:54'!
unpack
	"produce commands for unpacking the library archive.
	
	the output of this command should use a directory
	${workDir}/${libName}
	where the unpacked library sources will be located.
	
	see #setVariables method for understanding what variables used here
	"

	gen set: #unpackTarget toString: '${libSourcesDir}/touch.cmake'.
	
	gen puts:
'add_custom_command(OUTPUT "${unpackTarget}"
		COMMAND tar -xzf "${archiveFileName}" 
		COMMAND touch "${unpackTarget}"
		COMMENT "Unpacking ${libName} ... "
	)
'.
! !

!CMThirdpartyLibrary methodsFor: 'package properties' stamp: 'IgorStasenko 6/7/2012 03:43'!
unpackedDirName
	"answer the directory name, which is created after unpacking
	downloaded archive i.e.
	
	the archive downloaded from 
	
	http://ftp.igh.cnrs.fr/pub/nongnu/freetype/freetype-2.4.9.tar.gz
	
	if untarred, will create
	freetype-2.4.9
	subdirectory. But since there is no conventions, it could be anything,
	so we should specify it here, so build system will know where to look for unpacked files"

	^ self subclassResponsibility! !

CMThirdpartyLibrary subclass: #CMWin32ZLib
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Libs'!

!CMWin32ZLib class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 15:37'!
canonicalName 
	^ 'zlib'! !

!CMWin32ZLib class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/18/2012 15:38'!
supports: aConfig
	^  aConfig platformName  = 'win32' ! !

!CMWin32ZLib methodsFor: 'package properties' stamp: 'EstebanLorenzano 5/14/2013 19:20'!
archiveMD5Sum
	"answer the MD5 checksum (in string) for downloaded library archive 
	(to check that downloaded file is not corrupt).
	
	You can take this sum by issuing:
	  md5 filename
	from command line
	"
	^ '44d667c142d7cda120332623eab69f40'! !

!CMWin32ZLib methodsFor: 'generating actions' stamp: 'IgorStasenko 10/18/2012 18:01'!
build

'	COMMAND ./configure --prefix="${installPrefix}" --archs="-arch i386" '.
	
	gen 
		puts: '
add_custom_command(OUTPUT "${libzInstalled}"
	COMMAND make -fwin32/Makefile.gcc 
	COMMAND make install -fwin32/Makefile.gcc prefix="${installPrefix}" INCLUDE_PATH="${installPrefix}/include" LIBRARY_PATH="${installPrefix}/lib" BINARY_PATH="${installPrefix}/bin" SHARED_MODE=1
	WORKING_DIRECTORY "${libSourcesDir}"
	DEPENDS "${unpackTarget}"
	COMMENT "Building ${libName}"
)
'
! !

!CMWin32ZLib methodsFor: 'generating actions' stamp: 'IgorStasenko 10/18/2012 16:00'!
copyArtefacts

	self 
		copy: '${libzInstalled}' 
		to: '${externalModulesDir}/${libraryFileName}'
! !

!CMWin32ZLib methodsFor: 'generating actions' stamp: 'IgorStasenko 10/18/2012 16:04'!
defineAsTarget 
	
	gen puts:
	'add_custom_target(', self buildTarget , '
		DEPENDS 
		"${externalModulesDir}/${libraryFileName}"
	)'
	
		"${externalModulesDir}/${libraryFileName}"
! !

!CMWin32ZLib methodsFor: 'generating actions' stamp: 'IgorStasenko 10/18/2012 15:59'!
defineGlobalTargets 
! !

!CMWin32ZLib methodsFor: 'package properties' stamp: 'EstebanLorenzano 5/14/2013 19:18'!
downloadURL 
	^ 'http://zlib.net/zlib-1.2.8.tar.gz'! !

!CMWin32ZLib methodsFor: 'package properties' stamp: 'IgorStasenko 10/18/2012 15:57'!
libraryFileName
	^ 'zlib1.dll'! !

!CMWin32ZLib methodsFor: 'generating actions' stamp: 'IgorStasenko 10/18/2012 17:35'!
setVariables
	super setVariables.
	gen 
		set: #libraryFileName to: self libraryFileName;
		set: #libzInstalled toString: '${installPrefix}/bin/${libraryFileName}'.
		! !

!CMWin32ZLib methodsFor: 'package properties' stamp: 'EstebanLorenzano 5/14/2013 19:51'!
unpackedDirName
	^ 'zlib-1.2.8'! !

Object subclass: #CMakeGenScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeGenScripts commentStamp: 'Igor.Stasenko 12/30/2010 09:53' prior: 0!
This class is a collection of scripts for generating both
C source files (using VMMaker) and Cmake files.!

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:54'!
fileout: aString to: aFileName

	" put that file to ../codegen-scripts directory "
	
 	(FileStream forceNewFileNamed: aFileName) 
		nextPutAll: aString;
		close.
	! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:53'!
fileoutLoaderScript
"self fileoutLoaderScript"


	" put that file to ../codegen-scripts directory "
	
	self fileout: self loaderScript to: self loaderScriptName.! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'GuillermoPolito 6/17/2013 15:27'!
generateCocoaVM
	| platformDirectoryName |
	"B3DAcceleratorPlugin"
	"Not using it right now"
	platformDirectoryName := (FileSystem workingDirectory parent directoryNamed: 'platforms') fullName.
	VMMaker default
		platformRootDirectoryName: platformDirectoryName;
		sourceDirectoryName: platformDirectoryName , '/iOS/vm/src';
		internal:
				#(#ADPCMCodecPlugin #B3DEnginePlugin #BalloonEnginePlugin #BitBltSimulation #BMPReadWriterPlugin #ClipboardExtendedPlugin #DeflatePlugin #DSAPlugin #FFIPlugin #FFTPlugin #FilePlugin #FloatArrayPlugin #GeniePlugin #HostWindowPlugin #JPEGReaderPlugin #JPEGReadWriter2Plugin #KlattSynthesizerPlugin #LargeIntegersPlugin #Matrix2x3Plugin #MacMenubarPlugin #MiscPrimitivePlugin #NewsqueakIA32ABIPlugin #ObjectiveCPlugin #RePlugin #SecurityPlugin #SocketPlugin #SoundCodecPlugin #SoundGenerationPlugin #SoundPlugin #StarSqueakPlugin #SurfacePlugin #UUIDPlugin #DropPlugin)
			external: #(#UnixOSProcessPlugin);
		generateMainVM;
		generateExternalPlugins.	"Gnuifier"
	(Gnuifier on: (platformDirectoryName , '/iOS/vm/src/vm') asFileReference pathName) gnuify! !

!CMakeGenScripts class methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 6/17/2013 15:12'!
generateCogMacOS
	" generate sources for Stack Interpreter of Mac OS"

	| top |
	top := FileSystem workingDirectory parent.
	VMMaker
		generate: CoInterpreter
		to: (top / 'src') fullName
		platformDir: (top / 'platforms') fullName
		excluding:
			#(#BrokenPlugin #IA32ABIPluginSimulator #SlangTestPlugin #TestOSAPlugin #FFIPlugin #ReentrantARMFFIPlugin #ReentrantFFIPlugin #ReentrantPPCBEFFIPlugin).
	CogMacOSConfig generate! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'GuillermoPolito 6/17/2013 15:12'!
generateCogSources
	" self generateCogSources "

	" generate sources for CoInterpreter"

	| top |
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	top := FileSystem workingDirectory parent.
	VMMaker
		generate: CoInterpreter
		and: StackToRegisterMappingCogit
		to: (top / 'src') fullName
		platformDir: (top / 'platforms') fullName
		excluding:
			#(#BrokenPlugin #IA32ABIPluginSimulator #SlangTestPlugin #TestOSAPlugin #FFIPlugin #ReentrantARMFFIPlugin #ReentrantFFIPlugin #ReentrantPPCBEFFIPlugin #NewsqueakIA32ABIPlugin #NewsqueakIA32ABIPluginAttic)! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'Igor.Stasenko 1/28/2011 15:59'!
generateCogSources: config
	" self generateCogSources "

	" generate sources for CoInterpreter"

	| top src |
	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
	top := config topDir.				
	src := config srcDir assureExistence fullName.
	
	VMMaker
		generate: CoInterpreter
		and: StackToRegisterMappingCogit
		to: src
		platformDir: ( top / 'platforms') fullName
		excluding:#(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
					FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin NewsqueakIA32ABIPlugin
					 NewsqueakIA32ABIPluginAttic).
! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'GuillermoPolito 6/17/2013 15:12'!
generateCogSourcesEmm40
	" self generateCogSourcesEmm40 "

	" generate sources for CoInterpreter"

	| top |
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	top := FileSystem workingDirectory parent.
	VMMaker
		generate: CoInterpreter
		and: StackToRegisterMappingCogit
		to: (top / 'src') fullName
		platformDir: (top / 'platforms') fullName
		excluding:
			#(#BrokenPlugin #IA32ABIPluginSimulator #SlangTestPlugin #TestOSAPlugin #FFIPlugin #ReentrantARMFFIPlugin #ReentrantFFIPlugin #ReentrantPPCBEFFIPlugin #NewsqueakIA32ABIPlugin #NewsqueakIA32ABIPluginAttic)! !

!CMakeGenScripts class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/22/2011 23:16'!
generateStackMacOS
	" generate sources for Stack Interpreter of Mac OS"
	self generateStackSources.
		
	StackMacOSConfig generate.

	! !

!CMakeGenScripts class methodsFor: 'sources generation' stamp: 'GuillermoPolito 6/17/2013 15:12'!
generateStackSources
	" generate sources for Stack Interpreter of Mac OS"

	| top |
	top := FileSystem workingDirectory parent.
	VMMaker
		generate: StackInterpreter
		to: (top / 'src') fullName
		platformDir: (top / 'platforms') fullName
		excluding:
			#(#BrokenPlugin #IA32ABIPluginSimulator #SlangTestPlugin #TestOSAPlugin #FFIPlugin #ReentrantARMFFIPlugin #ReentrantFFIPlugin #ReentrantPPCBEFFIPlugin)! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'IgorStasenko 4/12/2011 13:24'!
loaderScript

"
Gofer new
	squeaksource: 'MetacelloRepository';
	package: 'ConfigurationOfCog';
	load.
	
((Smalltalk at: #ConfigurationOfCog) project
	version: '1.7') load.

(Smalltalk saveAs: 'generator.image') ifFalse: [
				 Smalltalk snapshot: false andQuit: true]
"

" i put it into comment to avoid double quoting "

^  thisContext  method methodNode comment first

! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/28/2011 10:53'!
loaderScriptName
	^ 'LoadVMMaker.st'! !

!CMakeGenScripts class methodsFor: 'scripts generation' stamp: 'Igor.Stasenko 1/27/2011 12:19'!
mcPackage: name
	
	|pkg|
	pkg := MCWorkingCopy allManagers detect: [:ea | ea packageName = name ].
	
	^ pkg ancestry ancestorString , '.mcz'
	! !

!CMakeGenScripts methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/30/2010 09:52'!
seeClassSide! !

Object subclass: #CMakeGenerator
	instanceVariableNames: 'output'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeGenerator commentStamp: 'Igor.Stasenko 12/24/2010 02:53' prior: 0!
a base class for generating cmake files.
Mainly provides a helper methods of cmake commands api.!

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:15'!
addDefinitions: aString
	^ self cmd: 'add_definitions' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'IgorStasenko 6/7/2012 22:33'!
addDependency: aName

	self cmd: 'list'
		params: 'APPEND ', self moduleName , '_dependencies ' , aName.
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 16:58'!
addExternalLibraries: libs

	libs do: [:each | self addExternalLibrary: each ]! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'IgorStasenko 6/4/2011 17:01'!
addExternalLibrary: aLibrary 

	self cmd: 'list'
		params: 'APPEND LINKLIBS ' , aLibrary .
		
"	self cmd: 'target_link_libraries' 
		params: self moduleName , ' ' , aLibrary.
"	
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/19/2011 10:22'!
addFrameworks: aCollection 
	"for mac only "
	aCollection
		do: [:each | 
			self cmd: 'find_library' params:  each , '_FMWK ', each.
			self addExternalLibrary: '${', each , '_FMWK}' ]! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 1/10/2011 19:45'!
addProperty: propertyString value: valueString 
	self puts: 'set_target_properties(' , self moduleName , ' PROPERTIES ' , propertyString , ' "' , valueString, '")'
! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 13:14'!
addSource: aFileName

	^ self addSources: { aFileName }! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 12:09'!
addSources: aFileNames

	^ self addSources: aFileNames prefixed: ''! !

!CMakeGenerator methodsFor: 'sources management' stamp: 'Igor.Stasenko 12/23/2010 13:16'!
addSources: aFileNames prefixed: aPrefix

	| names |
	names := aFileNames inject: '' into: [:res :each | res , ' "' , aPrefix, each, '"' ].
	
	self puts: 'list(APPEND sources ', names , ')'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:16'!
addSubdirectory: aDir

	^ self cmd: 'add_subdirectory' qparams: aDir. 
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 1/10/2011 19:46'!
addXCodeProperty: propertyString value: valueString 
	self 
		addProperty: 'XCODE_ATTRIBUTE_' , propertyString 
		value: valueString
! !

!CMakeGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 1/14/2011 18:56'!
captureOutputDuring: aBlock
	| old result |
	
	old := output.
	output :=  String new writeStream.
	
	aBlock value.
	
	result := output.
	output := old.
	
	^ result contents! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:18'!
cmd: cmdName params: aString

	output nextPutAll: cmdName;
		nextPut: $(;
		nextPutAll: aString;
		nextPut: $);
		cr
! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:18'!
cmd: cmdName qparams: aString
	"quoted params"
	output nextPutAll: cmdName;
		nextPutAll: '("';
		nextPutAll: aString;
		nextPutAll: '")';
		cr
! !

!CMakeGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 12/21/2010 19:02'!
generate
	self subclassResponsibility.! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 1/15/2011 14:53'!
include: aFileName
	^ self cmd: 'include' params: aFileName! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:19'!
includeDirectories: aString
	^ self cmd: 'include_directories' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'IgorStasenko 7/6/2012 16:39'!
linkDirectories: aString
	^ self cmd: 'link_directories' params: aString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:24'!
message: aString
	
	self cmd: 'message' qparams: aString.! !

!CMakeGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName
	self subclassResponsibility! !

!CMakeGenerator methodsFor: 'accessing' stamp: ''!
output
	^ output! !

!CMakeGenerator methodsFor: 'accessing' stamp: ''!
output: aStream

	output := aStream! !

!CMakeGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/20/2010 01:55'!
outputFileName
	^ 'CMakeLists.txt'! !

!CMakeGenerator methodsFor: 'as yet unclassified' stamp: 'DamienCassou 5/14/2013 15:36'!
printHeader
	
	self puts: '# This is automatically generated file using ', self configurationName, ' on ',
		Date current asString, ' ' , Time current asString;
		puts: 'cmake_minimum_required(VERSION 2.6.2)'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:19'!
project: aProjectName
	self cmd: 'project' qparams: aProjectName
! !

!CMakeGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/20/2010 01:36'!
puts: aString
	output nextPutAll: aString; cr! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/24/2010 02:20'!
set: variableName to: aValueString

	self cmd: 'set' params: variableName , ' ' , aValueString! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'Igor.Stasenko 12/20/2010 03:09'!
set: variableName toString: aValueString

	^ self set: variableName to: '"', (aValueString copyReplaceAll: '"' with: '\"'), '"'! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'NicolasPasserini 3/30/2011 14:48'!
setTargetProperties: properties 
	self cmd: 'set_target_properties' params: self moduleName, ' PROPERTIES ', properties ! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 3/23/2011 14:11'!
setTargetProperty: propertyString to: aString
	self 
		cmd: 'set_target_properties'
		params: (String streamContents: [ :stream |
			stream 
				nextPutAll: self moduleName;
				nextPutAll: ' PROPERTIES ';
				nextPutAll: propertyString;
				space;  
				nextPutAll: aString ])! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'EstebanLorenzano 3/23/2011 14:12'!
setTargetProperty: propertyString toAll: aCollection
	^self 
		setTargetProperty: propertyString 
		to: (String streamContents: [ :stream | 
			aCollection 
				do: [ :each | stream nextPutAll: each ]
				separatedBy: [ stream nextPut: $, ] ])! !

!CMakeGenerator methodsFor: 'cmake commands' stamp: 'IgorStasenko 5/7/2011 00:47'!
setTargetProperty: propertyString toString: aString
	self 
		cmd: 'set_target_properties'
		params: (String streamContents: [ :stream |
			stream 
				nextPutAll: self moduleName;
				nextPutAll: ' PROPERTIES ';
				nextPutAll: propertyString;
				space;
				nextPut: $";  
				nextPutAll: (aString copyReplaceAll: '"' with: '\"');
				nextPut: $"
				 ])! !

CMakeGenerator subclass: #CMakePluginGenerator
	instanceVariableNames: 'plugin vmGen internal extraRules doNotGenerate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakePluginGenerator commentStamp: 'Igor.Stasenko 12/25/2010 04:21' prior: 0!
I am using for generating CMakeLists.txt (cmake config files) for specific plugin.
The direct use of my instances is not recommended.
Use CMakeVMGenerator and appropriate configuration to generate both VM and plugins cmake config files.!

CMakePluginGenerator subclass: #CMakeAndroidPluginGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Android'!

!CMakeAndroidPluginGenerator methodsFor: 'sources management' stamp: 'golubovsky 7/29/2011 22:27'!
addCrossSources: sources

	^ self addSources: sources prefixed: '$(pluginCross)/'
! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 20:59'!
addDefinitions: aString
	output 
		nextPutAll: ('COG_CFLAGS += ', aString); 
		cr
! !

!CMakeAndroidPluginGenerator methodsFor: 'sources management' stamp: 'golubovsky 7/29/2011 22:42'!
addSources: aFileNames prefixed: aPrefix

	| names |
	names := aFileNames inject: '' into: [:res :each | res ,  aPrefix, each, ' ' ].
	self append: #LOCAL_SRC_FILES with: names.
! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 20:59'!
addSubdirectory: aDir

	^ self include: ('$(buildDir)/', aDir, '/', self outputFileName).
! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 12/27/2011 21:37'!
append: variableName with: aValueString

	output 
		nextPutAll: (variableName, ' += ', aValueString); 
		cr
! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 22:55'!
generate

	| name |
	output := String new writeStream.

	name := plugin moduleName.
	self printHeader.
	
	self 
		set: #pluginName to: name;
		set: #pluginSrc to: '$(srcPluginsDir)/', name;
		set: #pluginCross to: '$(crossDir)/plugins/', name;
		set: #pluginPlatform to: '$(targetPlatform)/plugins/', name.
		
	self addDefinitions: '-DSQUEAK_BUILTIN_PLUGIN'.
	
	self addSources: { name , '.c' } prefixed: '$(pluginSrc)/'.

	self includeDirectories: '-I$(pluginSrc) -I$(pluginCross) -I$(targetPlatform)/plugins/$(pluginName)'.

	self addDefinitions: vmGen config compilerFlags.

	" perform config's configureXYZ: message to apply per-plugin custom rules, if any "
	
	vmGen config configurePlugin: plugin with: self.
	
	extraRules ifNotNil: [ extraRules value: self ].
	
	vmGen config extraPluginSettings: self.
	
	self saveFile.! !

!CMakeAndroidPluginGenerator methodsFor: 'plugins' stamp: 'golubovsky 7/29/2011 20:59'!
generatePlugin: aPlugin internal: aBoolean extraRules: aBlock
	doNotGenerate := false.
	internal := aBoolean.
	plugin := aPlugin.
	vmGen := CMakeAndroidGenerator.
	extraRules := aBlock.
		
	^ self generate! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 20:59'!
include: aFileName
	output 
		nextPutAll: ('include ', aFileName); 
		cr
! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 20:59'!
includeDirectories: aString
	output 
		nextPutAll: ('COG_INCLUDE_DIRS += ', aString); 
		cr
! !

!CMakeAndroidPluginGenerator methodsFor: 'sources management' stamp: 'golubovsky 7/29/2011 20:59'!
includeDirs

	^ '-I$(crossDir)/vm -I$(srcVMDir) -I$(targetPlatform)/vm -I$(buildDir)'.! !

!CMakeAndroidPluginGenerator methodsFor: 'accessing' stamp: 'golubovsky 7/29/2011 21:04'!
outputFileName
	"override this to set the file name to create"
	^ 'cogsources.mk'! !

!CMakeAndroidPluginGenerator methodsFor: 'submakefile creation' stamp: 'golubovsky 7/29/2011 20:59'!
printHeader
	
	self puts: '# This is automatically generated file using ', self configurationName, ' on ',
		Date current asString, ' ' , Time current asString.
! !

!CMakeAndroidPluginGenerator methodsFor: 'plugins' stamp: 'golubovsky 7/29/2011 20:59'!
processInternalPlugins

	| libs |
	libs := OrderedCollection new.

	config internalPlugins collect: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: true.
		gen doNotGenerate ifFalse: [
			libs add: plugin moduleName.
			self addSubdirectory: plugin moduleName.
			 ].
		].
	
	self generateExportsH: libs.
! !

!CMakeAndroidPluginGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 20:59'!
set: variableName to: aValueString

	output 
		nextPutAll: (variableName, ' := ', aValueString); 
		cr
! !

!CMakeAndroidPluginGenerator methodsFor: 'accessing' stamp: 'golubovsky 7/29/2011 20:59'!
sources

	self set: #coreSources to: 
		(self append: '$(srcVMDir)/' toAll: config coreSources).
		
	self set: #platformVMSources to: 
		(self append: '$(targetPlatform)/vm/' toAll: config platformSources).
	
	
	self set: #crossVMSources to: 
		(self append: '$(crossDir)/vm/' toAll: config crossSources).
		
	self set: #extraSources to: config extraSources.
	
	^ '$(coreSources) $(crossVMSources) $(platformVMSources) $(extraSources)'! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 14:38'!
addCrossSources: sources

	^ self addSources: sources prefixed: '${pluginCross}/'
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/4/2011 16:57'!
addExternalLibrary: aLibrary 

	self isInternal ifTrue: [
		vmGen addExternalLibrary: aLibrary  
		]
	ifFalse: [ super addExternalLibrary: aLibrary ]
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 12:51'!
addPlatformSources: sources

	^ self addSources: sources prefixed: '${pluginPlatform}/'
! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 09:52'!
config
	^ vmGen config! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:44'!
configurationName
	^ vmGen configurationName! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/27/2010 14:00'!
doNotGenerate

	"Forcely exclude plugin form build. Use this method only for debugging purposes.
	
	Front-end users should simply specify different list of plugins for building VM,
	effectively excluding any unwanted stuff "
	
	^doNotGenerate! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/27/2010 13:59'!
doNotGenerate: aValue

	"Forcely exclude plugin form build. Use this method only for debugging purposes.
	
	Front-end users should simply specify different list of plugins for building VM,
	effectively excluding any unwanted stuff "
	
	doNotGenerate := aValue! !

!CMakePluginGenerator methodsFor: 'code generation' stamp: 'IgorStasenko 10/3/2012 13:40'!
generate

	| name |
	output := String new writeStream.

	name := plugin moduleName.
#(	vmGen config setGlobalOptions: self.
	
	self 
		printHeader;
		project: name;
		"include directories generated for build"
		include: '../directories.cmake'.
	
	self set: 'CMAKE_CONFIGURATION_TYPES' to: 'Release'.
).

	self message: (internal ifTrue: [ 'Adding internal plugin: '] ifFalse: ['Adding external plugin: '])  , name.

	self 
		set: #pluginName toString: name;
		set: #pluginSrc toString: '${srcPluginsDir}/', name;
		set: #pluginCross toString: '${crossDir}/plugins/', name;
		set: #pluginPlatform toString: '${targetPlatform}/plugins/', name.

	"clear LINKLIBS variable"
	self set: #LINKLIBS to: ''.		
	
	internal 
		ifTrue: [ self puts: 'add_definitions(-DSQUEAK_BUILTIN_PLUGIN)'].
	
	self addSources: { name , '.c' } prefixed: '${pluginSrc}/'.

	" default include directories for plugin "
	self includeDirectories: '${pluginSrc} ${pluginCross} ${targetPlatform}/plugins/${pluginName}'.
	
	"Not needed because there are already there (inherited from main configuration)"
	"self addDefinitions: vmGen config compilerFlags."

	" perform config's configureXYZ: message to apply per-plugin custom rules, if any "
	
	vmGen config configurePlugin: plugin with: self.
	
	extraRules ifNotNil: [ extraRules value: self ].
	
	" generate a static lib for internal plugin, or shared for external"
	internal ifTrue: [
		self cmd: 'add_library' params:  name , ' STATIC ${sources}'.
	] ifFalse: [
		self cmd: 'add_library' params: name , ' SHARED ${sources}'.
		
	"	self cmd: 'set_property' params: 'TARGET ' , name , ' PROPERTY LINK_FLAGS -bundle'"
	].

	vmGen config extraPluginSettings: self.
	
	self isExternal ifTrue: [
		self cmd: 'target_link_libraries'
			params: self moduleName , ' ${LINKLIBS}'.
		].
	
	" see senders of #linkFlags "
	self 
		cmd: 'set_property' 
		params: 'TARGET ', name, ' PROPERTY LINK_FLAGS "${linkFlags}"'.
	
	"set dependencies"
	self puts: 'IF (',self moduleName , '_dependencies)'.
	
	self cmd: 'add_dependencies'
		params: name , ' ${', self moduleName , '_dependencies}'.
	
	self puts: 'ENDIF (',self moduleName , '_dependencies)'.
	self saveFile.! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/27/2010 14:02'!
generate: aPlugin for: aCMakeVMGenerator internal: aBoolean extraRules: aBlock

	doNotGenerate := false.
	internal := aBoolean.
	plugin := aPlugin.
	vmGen := aCMakeVMGenerator.
	extraRules := aBlock.
		
	^ self generate! !

!CMakePluginGenerator methodsFor: 'testing' stamp: 'Igor.Stasenko 12/29/2010 15:42'!
isExternal
	^ internal not! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/29/2010 15:42'!
isInternal
	^ internal! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName 
	^plugin moduleName! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: ''!
plugin
	^ plugin! !

!CMakePluginGenerator methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/4/2011 22:21'!
saveFile
	
	(((vmGen config dirFrom: vmGen buildDir) / plugin moduleName) assureExistence forceNewFileNamed: self outputFileName) 
		nextPutAll: (self config fixLineEndsOf: output contents); close.
! !

!CMakePluginGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 01:07'!
vmGenerator
	"Make it accessible from plugin generator side"
	^ vmGen! !

CMakeGenerator subclass: #CMakeVMGenerator
	instanceVariableNames: 'internalPlugins externalPlugins config'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CMakeVMGenerator commentStamp: 'Igor.Stasenko 12/25/2010 04:25' prior: 0!
I am generating a cmake configuration file (CMakeLists.txt)
for building a Squeak Virtual Machine.

Usage: 

CMakeVMGenerator new generate: CogMacOSConfig

or

CMakeVMGenerator new generate: (CogMacOSConfig new setOption: ... ; yourself)

you can provide any valid configuration instead of CogMacOSConfig for build. 

Generator creating a '../build' directory (relative to current one)
and placing config files there.
Also, it expects that appropriate VM (re)sources can be found simplarily:
  ../platforms
  ../src
 but these settings are just default ones and could be changed in config
 (see senders of #topDir #buildDir and #srcDir )

Generator and cmake configs are designed so, that any file-system operations are performed in
<build> directory.
So, if you want to build multiple VMs , using same generated sources, but different configs, you can simply
use different build directories.

!

CMakeVMGenerator subclass: #CMakeAndroidGenerator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Android'!

!CMakeAndroidGenerator commentStamp: 'golubovsky 7/27/2011 22:49' prior: 0!
This class inherits from CMakeGenerator and provides the same generation facilities as its parent, but output is more adjusted to the Android NDK requirements.!

!CMakeAndroidGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/28/2011 21:51'!
addDefinitions: aString
	output 
		nextPutAll: ('COG_CFLAGS += ', aString); 
		cr
! !

!CMakeAndroidGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 06:31'!
addSubdirectory: aDir

	^ self include: ('$(buildDir)/', aDir, '/', self outputFileName).
! !

!CMakeAndroidGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/29/2011 22:38'!
append: variableName with: aValueString

	output 
		nextPutAll: (variableName, ' += ', aValueString); 
		cr
! !

!CMakeAndroidGenerator methodsFor: 'code generation' stamp: 'golubovsky 7/30/2011 09:12'!
generate

	"override this method to produce gmake syntax"
	
	output := String new writeStream.
		
	self printHeader.

	config setupDirectories: self.
		
	config preferredIncludes 
		do: [ :each | self includeDirectories: each ].
	self includeDirectories: self includeDirs.	
	config standardIncludes 
		do: [:each | self includeDirectories: each ].

	self addDefinitions: config compilerFlags.

	config extraVMSettings: self.
	
	self append: #LOCAL_SRC_FILES with: self sources.
		
	self processInternalPlugins.	
	config setExtraTargetProperties: self.
	
	self saveFile.
	! !

!CMakeAndroidGenerator methodsFor: 'plugins' stamp: 'golubovsky 7/29/2011 21:00'!
generatePlugin: aPlugin internal: aBoolean extraRules: aBlock
	" this method called back from plugin"
	^ CMakeAndroidPluginGenerator new
		generate: aPlugin for: self internal: aBoolean extraRules: aBlock! !

!CMakeAndroidGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/28/2011 21:45'!
include: aFileName
	output 
		nextPutAll: ('include ', aFileName); 
		cr
! !

!CMakeAndroidGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/28/2011 21:43'!
includeDirectories: aString
	output 
		nextPutAll: ('COG_INCLUDE_DIRS += ', aString); 
		cr
! !

!CMakeAndroidGenerator methodsFor: 'sources management' stamp: 'golubovsky 7/28/2011 21:39'!
includeDirs

	^ '-I$(crossDir)/vm -I$(srcVMDir) -I$(targetPlatform)/vm -I$(buildDir)'.! !

!CMakeAndroidGenerator methodsFor: 'accessing' stamp: 'golubovsky 7/28/2011 06:10'!
outputFileName
	"override this to set the file name to create"
	^ 'cogsources.mk'! !

!CMakeAndroidGenerator methodsFor: 'submakefile creation' stamp: 'golubovsky 7/28/2011 06:13'!
printHeader
	
	self puts: '# This is automatically generated file using ', self configurationName, ' on ',
		Date current asString, ' ' , Time current asString.
! !

!CMakeAndroidGenerator methodsFor: 'plugins' stamp: 'golubovsky 7/29/2011 20:47'!
processInternalPlugins

	| libs |
	libs := OrderedCollection new.

	config internalPlugins collect: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: true.
		gen doNotGenerate ifFalse: [
			libs add: plugin moduleName.
			self addSubdirectory: plugin moduleName.
			 ].
		].
	
	self generateExportsH: libs.
! !

!CMakeAndroidGenerator methodsFor: 'gmake commands' stamp: 'golubovsky 7/28/2011 21:25'!
set: variableName to: aValueString

	output 
		nextPutAll: (variableName, ' := ', aValueString); 
		cr
! !

!CMakeAndroidGenerator methodsFor: 'accessing' stamp: 'golubovsky 7/28/2011 23:15'!
sources

	self set: #coreSources to: 
		(self append: '$(srcVMDir)/' toAll: config coreSources).
		
	self set: #platformVMSources to: 
		(self append: '$(targetPlatform)/vm/' toAll: config platformSources).
	
	
	self set: #crossVMSources to: 
		(self append: '$(crossDir)/vm/' toAll: config crossSources).
		
	self set: #extraSources to: config extraSources.
	
	^ '$(coreSources) $(crossVMSources) $(platformVMSources) $(extraSources)'! !

!CMakeVMGenerator class methodsFor: 'code generation' stamp: 'EstebanLorenzano 1/10/2011 19:52'!
generate: aConfigOrClass  
	^self new 
		generate: aConfigOrClass;
		yourself  ! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 15:33'!
append: aString toAll: list
	"flatten the list, adding prefix for each element"
	^ list inject: '' into: [:result :each | result, ' ', aString, each ].! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/18/2011 14:56'!
buildDir
	^ config buildDir! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:54'!
config
	^ config! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:44'!
configurationName
	^ config class name! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 02:04'!
executableName
	^ 'Squeak'! !

!CMakeVMGenerator methodsFor: 'code generation' stamp: 'EstebanLorenzano 2/15/2013 16:44'!
generate
	| intPlugins extPlugins |
			
	output := String new writeStream.
	
	config setGlobalOptions: self.
	
	self 
		printHeader;
		project: config executableName.

	config setGlobalOptionsAfterDetermineSystem: self.

	config setupDirectories: self.
	
	self message: '${CMAKE_MODULE_PATH}'.
	self set: 'CMAKE_CONFIGURATION_TYPES' to: 'Release'.

	config preferredIncludes 
		do: [ :each | self includeDirectories: each ].
	self includeDirectories: self includeDirs.	
	config standardIncludes 
		do: [:each | self includeDirectories: each ].

	self addDefinitions: config compilerFlags.

	config extraVMSettings: self.
	
	self puts: 'add_executable(' , config executableName, ' ', config executableType, ' ' , self sources , ')'.
	
	intPlugins := self generatePluginConfigs: config internalPlugins internal: true.
	extPlugins := self generatePluginConfigs: config externalPlugins internal: false.
	
	self processThirdpartyLibraries.
	
	self processPlugins:  intPlugins, extPlugins.

	config setExtraTargetProperties: self.
	
	self cmd: 'target_link_libraries'
		params: self moduleName , ' ${LINKLIBS}'.

	config postBuildActions: self.
	
	self saveFile.
	self generateBuildScript.! !

!CMakeVMGenerator methodsFor: 'code generation' stamp: 'Igor.Stasenko 12/24/2010 02:06'!
generate: aConfigOrClass
	
	config := aConfigOrClass isBehavior ifTrue: [ aConfigOrClass new ] ifFalse: [aConfigOrClass].
	^ self generate! !

!CMakeVMGenerator methodsFor: 'build script' stamp: 'IgorStasenko 9/3/2012 16:52'!
generateBuildScript

	(self buildDir forceNewFileNamed: 'build.sh') nextPutAll: (config fixLineEndsOf: config buildScript); close.
	! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 11:53'!
generateExportsH: libs
	| content |
	content := String streamContents: [:str |
	
		str nextPutAll: '/* This is automatically generated file using CVMMaker on ',
			Date current asString, ' ' , Time current asString , ' */'; cr.
		
		str nextPutAll: 
'extern sqExport vm_exports[];
extern sqExport os_exports[];
'.
		libs do: [:each | 
			str nextPutAll: 'extern sqExport ', each ,'_exports [];'; cr ].
		
		str cr; nextPutAll: 'sqExport *pluginExports[] = {
	vm_exports,
	os_exports,
'.

		libs do: [:each | 
			str nextPutAll:  each ,'_exports,'; cr ].
	
		str nextPutAll: 'NULL
};'

	].

	(self buildDir forceNewFileNamed: 'sqNamedPrims.h') nextPutAll: (config fixLineEndsOf: content); close.
	! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 01:13'!
generatePlugin: aPlugin internal: aBoolean extraRules: aBlock
	" this method called back from plugin"
	^ CMakePluginGenerator new
		generate: aPlugin for: self internal: aBoolean extraRules: aBlock! !

!CMakeVMGenerator methodsFor: 'processing plugins' stamp: 'IgorStasenko 6/8/2012 00:21'!
generatePluginConfigs: plugins internal: bool
	"Answers a collection of CMakePluginGenerator instances"
	
	^ plugins collect: [:each | | plugin |
		plugin := Smalltalk at: each.
		plugin generateFor: self internal: bool.
	].
	
! !

!CMakeVMGenerator methodsFor: 'processing plugins' stamp: ''!
generatePluginsSource: plugins internal: bool

	plugins do: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: bool.
	].
	
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/23/2010 11:57'!
includeDirs

	^ '${crossDir}/vm ${srcVMDir} ${targetPlatform}/vm ${buildDir}'.! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/22/2010 00:14'!
internalPlugins: intList externalPlugins: extList

	internalPlugins := intList.
	externalPlugins := extList.! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/10/2011 19:43'!
moduleName 
	^config executableName! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:47'!
platformName
	^ config platformName
! !

!CMakeVMGenerator methodsFor: 'processing plugins' stamp: 'Igor.Stasenko 12/29/2010 15:31'!
processExternalPlugins

	config externalPlugins do: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: false.
		gen doNotGenerate ifFalse: [
			self addSubdirectory: plugin moduleName.
			]
	].
	
! !

!CMakeVMGenerator methodsFor: 'processing plugins' stamp: 'Igor.Stasenko 12/29/2010 15:20'!
processInternalPlugins

	| libs |
	libs := OrderedCollection new.

	config internalPlugins collect: [:each | | plugin gen |
		plugin := Smalltalk at: each.
		gen := plugin generateFor: self internal: true.
		gen doNotGenerate ifFalse: [
			libs add: plugin moduleName.
			self addSubdirectory: plugin moduleName.
			 ].
		].
	
	self cmd: 'target_link_libraries' params:  config executableName , ' ' ,
		(libs inject: '' into: [:res :ea | res, ' ' , ea ]) .

	self generateExportsH: libs.
! !

!CMakeVMGenerator methodsFor: 'processing plugins' stamp: ''!
processInternalPlugins: pluginGenerators

	| libs |
	libs := OrderedCollection new.

	pluginGenerators do: [:gen |
		gen doNotGenerate ifFalse: [
			libs add:  gen plugin moduleName.
			self addSubdirectory:  gen plugin moduleName.
			 ].
		].

	self cmd: 'target_link_libraries' params:  config executableName , ' ' ,
		(libs inject: '' into: [:res :ea | res, ' ' , ea ]) .

	self generateExportsH: libs.
! !

!CMakeVMGenerator methodsFor: 'processing plugins' stamp: 'IgorStasenko 6/8/2012 19:58'!
processPlugins: pluginGenerators

	| libs |
	libs := OrderedCollection new.

	pluginGenerators do: [:gen |
		gen doNotGenerate ifFalse: [
			gen isInternal ifTrue: [
				libs add:  gen plugin moduleName ]
			ifFalse: [
				"make main module to depend on external plugin, just to make sure it is built before main module built"
				self cmd: 'add_dependencies' params: config executableName, ' ' , gen plugin moduleName
				].
			self addSubdirectory:  gen plugin moduleName.
			 ].
		].

	self cmd: 'target_link_libraries' params:  config executableName , ' ' ,
		(libs inject: '' into: [:res :ea | res, ' ' , ea ]) .

	self generateExportsH: libs.
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: ''!
processThirdpartyLibraries

	config thirdpartyLibs do: [:each |
		each generateFor: self ]

! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/15/2011 14:54'!
saveFile
	
	config write: output contents toFile: (self outputFileName).
	! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 1/3/2011 08:09'!
setupMacros: gen
	self config cMakeMacros
		ifNotNil: [ :macros | gen puts: macros ]! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/18/2011 10:44'!
sources

	self set: #coreSources to: 
		(self append: '${srcVMDir}/' toAll: config coreSources).
		
	self set: #platformVMSources to: 
		(self append: '${targetPlatform}/vm/' toAll: config platformSources).
	
	
	self set: #crossVMSources to: 
		(self append: '${crossDir}/vm/' toAll: config crossSources).
		
	self set: #extraSources to: config extraSources.
	
	^ '${coreSources} ${crossVMSources} ${platformVMSources} ${extraSources}'! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 20:09'!
targetPropertyAt: aPropName put: aValue
	"set target's properties"
	
	self cmd: 'set_property' params: 'TARGET ', config executableName , 
	' PROPERTY ', aPropName , ' ' , aValue.
! !

!CMakeVMGenerator methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 12/24/2010 20:13'!
targetPropertyAt: aPropName qput: aValue
	"set target's properties, put value in quotes"
	
	^ self targetPropertyAt: aPropName put: (aValue copyReplaceAll: '"' with: '\"').! !

!CMakeVMGenerator methodsFor: 'thirdparty libs' stamp: 'IgorStasenko 6/7/2012 18:17'!
thirdpartyDir
	^ self buildDir / self thirdpartyDirName! !

!CMakeVMGenerator methodsFor: 'thirdparty libs' stamp: ''!
thirdpartyDirName
	^ 'thirdParty'! !

!CMakeVMGenerator methodsFor: 'accessing' stamp: 'GuillermoPolito 6/17/2013 15:30'!
topDir
	| dir |
	dir := self config topDir ifNil: [ FileSystem workingDirectory parent ].
	dir isString
		ifTrue: [ ^dir asFileReference ].
	^ dir! !

Object subclass: #CPlatformConfig
	instanceVariableNames: 'topDir buildDir srcDir platformsDir outputDir internalPlugins externalPlugins pluginsDir externalLibs thirdpartyLibs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker'!

!CPlatformConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:29' prior: 0!
Base class, defining some common properties and behavior for all kinds of VM build configurations. These classes are used to generate the VM sources and the CMMake files. 

Notice that this configuration classes expect that you have download the "platofroms code" which is in Gitorious: https://gitorious.org/cogvm
You can load it executing: git clone git://gitorious.org/cogvm/blessed.git

Once that is done it should have created a directory /blessed. In order to get all the directories by default, place this image under /blessed/image 

To generate a sources/build configuration use one of my subclasses with:
<config> generate.   - to generate a build configuration
<config> generateWithSources - to generate VMMaker sources and then build configuration.

Once you do that, go to /blessed/build and execute:  cmake .    or cmake -G"MSYS Makefiles" if you are in Windows 

Since some plugins require extra settings (like additional source files etc), there is two ways to add that:

- add custom rules on plugin class side:

PluginClass>>generateFor: aCMakeVMGenerator internal: aBoolean 

	^ aCMakeVMGenerator 
		generatePlugin: self 
		internal: aBoolean
		extraRules: [:maker |   ... your rules come here ... ]
		
- define rules by adding #configure<PluginClass>: method in config class (see my 'plugin extra rules' category)

The last one is more compact and also avoids inter-package dependency, so you can load and use
CMakeVMMaker even if some 3rd-party plugins are not loaded into image.


Links of interest:

Official Cog Website: http://www.mirandabanda.org/cog
Official Cog Blog: http://www.mirandabanda.org/cogblog
Cog issue tracker: http://code.google.com/p/cog
Cog Wiki: http://code.google.com/p/cog/w/list
Cog binaries: http://www.mirandabanda.org/files/Cog/VM
Cog binaries in Pharo Hudson server: https://pharo-ic.lille.inria.fr/hudson/view/Cog
Cog SVN branch: http://squeakvm.org/svn/squeak/branches/Cog
VM mailing list: http://lists.squeakfoundation.org/mailman/listinfo/vm-dev
VM-beginners mailing list: http://lists.squeakfoundation.org/mailman/listinfo/vm-beginners
Guide step by step about how to build the Cog VM using CMakeVMMaker and Git: http://code.google.com/p/cog/wiki/Guide



!

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 6/5/2012 01:56'!
browsePluginRules: aPlugin
	
	| nm |
	(nm := aPlugin) isSymbol ifFalse: [
		nm := aPlugin name.
		].
	
	SystemNavigation default browseAllImplementorsOf: ('configure' , nm, ':' ) asSymbol
	! !

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 00:59'!
generate

	^ self new generate! !

!CPlatformConfig class methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 00:58'!
generateWithSources

	^ self new generateSources; generate.
! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 05:01'!
addExternalPlugin: aPluginName

	| plugins |
	plugins := self externalPlugins.
	(self internalPlugins includes: aPluginName) ifTrue: [
		self error: 'Cannot add plugin ', aPluginName , ' as external, because it is already included as internal one'
		].
	(plugins includes: aPluginName) ifFalse: [ externalPlugins := externalPlugins copyWith: aPluginName ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 04:58'!
addExternalPlugins: aPluginNames

	aPluginNames do: [:each | self addExternalPlugin: each ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 05:01'!
addInternalPlugin: aPluginName

	| plugins |
	plugins := self internalPlugins.

	(self externalPlugins includes: aPluginName) ifTrue: [
		self error: 'Cannot add plugin ', aPluginName , ' as internal, because it is already included as external one'
		].
	
	(plugins includes: aPluginName) ifFalse: [ internalPlugins := internalPlugins copyWith: aPluginName ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 04:58'!
addInternalPlugins: aPluginNames

	aPluginNames do: [:each | self addInternalPlugin: each ]! !

!CPlatformConfig methodsFor: 'thirdparty libs' stamp: 'IgorStasenko 9/26/2012 16:13'!
addThirdpartyLibrary: libName
	| libs lib |
	
	libs := self thirdpartyLibs.
	
	lib :=  libs 
		detect: [:each | each canonicalName = libName ] 
		ifNone: [ nil ].
		
	lib ifNil: [ 
		lib := (CMThirdpartyLibrary named: libName config: self).
			"add dependencies first, so thirpartyLibs collection will be naturally dependency sorted"
			lib dependencies do: [:dep | self addThirdpartyLibrary: dep ].
			libs add: lib ].

	^ lib! !

!CPlatformConfig methodsFor: 'directories' stamp: 'MarianoMartinezPeck 4/12/2011 21:56'!
buildDir
	
	^ buildDir ifNil: [ buildDir := (self topDir / self buildDirName) assureExistence ].
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/4/2011 23:04'!
buildDir: anObject
	"Set the value of buildDir"

	buildDir := self dirFrom: anObject! !

!CPlatformConfig methodsFor: 'directories' stamp: 'MarianoMartinezPeck 4/12/2011 21:56'!
buildDirName
	^ 'build'
! !

!CPlatformConfig methodsFor: 'build script' stamp: 'IgorStasenko 9/18/2012 17:56'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!bash

cmake .
make

'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 08:09'!
cMakeMacros
	^nil	! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:30'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ nil! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:15'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	maker 
		addCrossSources: #( 'sqOpenGLRenderer.c' ) 
	
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/27/2010 14:00'!
configureBochsIA32Plugin: maker

	"this stuff is not ready for use yet" 
	
" 	maker addCrossSources:
		#( 'sqBochsIA32Plugin.cpp'  )

"
	maker doNotGenerate:true! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/22/2011 20:26'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"
	maker addCrossSources: #('TriBoxStub.c').! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:17'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	" it is incomplete right now, because in Cog this plugin are not used anymore"
	maker doNotGenerate: true.
	maker addCrossSources: #('sqFFIPlugin.c').! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/14/2011 14:42'!
configureFT2Plugin: maker 
	"extra rules for FT2Plugin"

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:17'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	maker addCrossSources: #( 'sqFilePluginBasicPrims.c').
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/5/2011 01:49'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].
	
	"On *nix & mac with -DNO_ISNAN "
	maker puts:'
if (${WIN32})
	add_definitions(-Werror-implicit-function-declaration)	
else(${WIN32})
	add_definitions(-DNO_ISNAN)
endif (${WIN32})'.

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:18'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:32'!
configureIA32ABIPlugin: maker
	"extra rules for IA32ABIPlugin"

	maker addCrossSources:
		#( 'ia32abicc.c')
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:18'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:34'!
configureJPEGReadWriter2Plugin: maker 
	"extra rules for JPEGReadWriter2Plugin"

maker addCrossSources: #(
'Error.c'
'jcapimin.c'
'jcapistd.c'
'jccoefct.c'
'jccolor.c'
'jcdctmgr.c'
'jchuff.c'
'jcinit.c'
'jcmainct.c'
'jcmarker.c'
'jcmaster.c'
'jcomapi.c'
'jcparam.c'
'jcphuff.c'
'jcprepct.c'
'jcsample.c'
'jctrans.c'
'jdapimin.c'
'jdapistd.c'
'jdatadst.c'
'jdatasrc.c'
'jdcoefct.c'
'jdcolor.c'
'jddctmgr.c'
'jdhuff.c'
'jdinput.c'
'jdmainct.c'
'jdmarker.c'
'jdmaster.c'
'jdmerge.c'
'jdphuff.c'
'jdpostct.c'
'jdsample.c'
'jdtrans.c'
'jerror.c'
'jfdctflt.c'
'jfdctfst.c'
'jfdctint.c'
'jidctflt.c'
'jidctfst.c'
'jidctint.c'
'jidctred.c'
'jmemdatadst.c'
'jmemdatasrc.c'
'jmemmgr.c'
'jmemnobs.c'
'jquant1.c'
'jquant2.c'
'jutils.c'
) 
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/15/2011 15:38'!
configureMpeg3Plugin: maker
	"extra rules for Mpeg3Plugin"

	maker includeDirectories: '${pluginCross}/libmpeg ${pluginCross}/libmpeg/audio ${pluginCross}/libmpeg/video'.

	maker addCrossSources: 
		#( 
		'libmpeg/bitstream.c' 
		'libmpeg/changesForSqueak.c'
		'libmpeg/audio/dct.c'
		'libmpeg/video/getpicture.c'
		'libmpeg/audio/header.c'
		'libmpeg/video/headers.c'
		'libmpeg/video/idct.c'
		'libmpeg/audio/layer1.c'
		'libmpeg/audio/layer2.c'
		'libmpeg/audio/layer3.c'
		'libmpeg/libmpeg3.c'
		'libmpeg/video/macroblocks.c'
		'libmpeg/video/mmxtest.c'
		'libmpeg/video/motion.c'
		'libmpeg/mpeg3atrack.c'
		'libmpeg/audio/mpeg3audio.c'
		'libmpeg/mpeg3demux.c'
		'libmpeg/mpeg3io.c'
		'libmpeg/mpeg3title.c'
		'libmpeg/video/mpeg3video.c'
		'libmpeg/mpeg3vtrack.c'
		'libmpeg/video/output.c'
		'libmpeg/audio/pcm.c'
		'libmpeg/video/reconstruct.c'
		'libmpeg/video/seek.c'
		'libmpeg/video/slice.c'
		
		'libmpeg/audio/synthesizers.c'
		'libmpeg/audio/tables.c'
		'libmpeg/video/vlc.c'
	).
	
	
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/29/2010 15:41'!
configurePlugin: aPlugin with: generator

	^ self perform: ( 'configure' , aPlugin name , ':' ) asSymbol with: generator.
	! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:37'!
configureRePlugin: maker 
	"extra rules for RePlugin"

	maker addCrossSources: #(
		'pcre.c' 'study.c' 'get.c' 'chartables.c').
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/15/2011 17:25'!
configureReentrantIA32FFIPlugin: maker
	"extra rules for ReentrantIA32FFIPlugin"
	
	maker addCrossSources: #(
		'sqFFIPlugin.c' 'sqFFITestFuncs.c' 'sqManualSurface.c'
	).

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 14:19'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:40'!
configureSoundCodecPlugin: maker 
	"extra rules for SoundCodecPlugin"

	maker addCrossSources:
		#( 'sqSoundCodecPluginBasicPrims.c' )


! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 8/9/2011 14:39'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/25/2010 03:41'!
configureSurfacePlugin: maker 
	"extra rules for SurfacePlugin"

	maker set: #sources toString: ''. "remove default source file"
	maker addCrossSources: #('SurfacePlugin.c')


! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 23:40'!
configureThreadedIA32FFIPlugin: maker
	"extra rules for ThreadedIA32FFIPlugin"
	
	maker addCrossSources: #(
		'sqFFIPlugin.c' 'sqFFITestFuncs.c' 'sqManualSurface.c'
	).

! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:23'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
! !

!CPlatformConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/31/2010 01:12'!
configureUnixOSProcessPlugin: maker
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	
	
	
	"THIS IS UGLY AND LAME!!!!!! "
	maker set: #linkFlags toString: '-undefined dynamic_lookup'! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:03'!
coreSources
	^#()! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 10:52'!
crossSources 
	^#(
			'sqHeapMap.c'
			'sqTicker.c'
			'sqExternalSemaphores.c'
			'sqNamedPrims.c'
			'sqVirtualMachine.c'
		)! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:19'!
defaultExternalPlugins
	self shouldBeImplemented ! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
defaultInternalPlugins
	self shouldBeImplemented ! !

!CPlatformConfig methodsFor: 'utils' stamp: 'GuillermoPolito 6/17/2013 15:34'!
dirFrom: aStringOrDir
	^ aStringOrDir isString
		ifTrue: [ aStringOrDir asFileReference ]
		ifFalse: [ aStringOrDir ]! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 12/25/2010 03:48'!
doesNotUnderstand: aMessage
	" ignore configureXYZ: messages "

	| sel  |
	sel := aMessage selector.
	
	((sel beginsWith: 'configure') and: [
		(sel indexOf: $: ) = sel size ] ) ifTrue: [ ^ self ].
	
	^ super doesNotUnderstand: aMessage! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 19:53'!
executableName
	"default one"
	^ 'Squeak'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 22:44'!
executableType
	^ ''! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:16'!
externalPlugins
	^ externalPlugins ifNil: [ externalPlugins := self defaultExternalPlugins ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
externalPlugins: aColl

	externalPlugins := aColl! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/15/2011 15:34'!
extraPluginSettings: maker
	"override in subclasses to apply extra settings for all plugins targets"! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:04'!
extraSources
	^''! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 12/23/2010 11:54'!
fixLineEndsOf: string
	^ string ! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 00:52'!
frameworks
	"leave empty for all platforms but Mac OS"
	^ #()! !

!CPlatformConfig methodsFor: 'public' stamp: 'IgorStasenko 3/5/2011 14:17'!
generate
	^ CMakeVMGenerator generate: self ! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 11/19/2012 15:48'!
generateSources
	"Generate whole VM + plugins sources"
	| maker |

	self validateSourcesPresent.
	self prepareForGeneration.
	
	"suppress questions and deprecation warnings during generation "
	[[
		
		maker := self prepareVMMaker.
	
		maker interpreterClass: self interpreterClass.
		self cogitClass ifNotNil: [:cg | 
			maker cogitClass: cg.
			"this is ugly, before VMMaker will be fixed to initialize stuff properly"
			Cogit initializeCompilationWithConstantsOptions: Dictionary new.
			cg initializeWithOptions: (maker instVarNamed: 'optionsDictionary')
		].
		
		maker generateEntire

	] on: ProvideAnswerNotification do: [:ex | ex resume: true ]]
	on: Deprecation do: [:ex | ex resume ].
	
	
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 2/16/2011 11:26'!
generateStackSources
	" generate sources for Stack Interpreter"

	StackInterpreter initialize.
	
	VMMaker
		generate: StackInterpreter
		to: self srcDir fullName
		platformDir: self platformsDir fullName
		excluding: #(BrokenPlugin IA32ABIPluginSimulator SlangTestPlugin TestOSAPlugin
			FFIPlugin ReentrantARMFFIPlugin ReentrantFFIPlugin ReentrantPPCBEFFIPlugin).! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 5/10/2011 14:09'!
generateVMOnlySources
	"Generate source code for VM only, without plugins"
	| maker |

	self validateSourcesPresent.
	self prepareForGeneration.
	
	"suppress questions and deprecation warnings during generation "
	[[
		
		maker := self prepareVMMaker.
	
		maker interpreterClass: self interpreterClass.
		self cogitClass ifNotNil: [:cg | maker cogitClass: cg ].

	
		maker generateMainVM

	] on: ProvideAnswerNotification do: [:ex | ex resume: true ]]
	on: Deprecation do: [:ex | ex resume ].
	

! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:16'!
internalPlugins
	^ internalPlugins ifNil: [ internalPlugins := self defaultInternalPlugins ]! !

!CPlatformConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 1/4/2011 03:18'!
internalPlugins: aColl

	internalPlugins := aColl! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:25'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'testing' stamp: 'Igor.Stasenko 12/30/2010 22:29'!
isLittleEndian
	"default is true. Override if necessary"
	^ true! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/20/2011 14:16'!
linkFlags 
	^''! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:26'!
outputDir: anObject
	"Set the value of outputDir"

	outputDir := anObject! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 22:00'!
outputDirName
	^ 'results'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/1/2012 11:49'!
platformName
	"override in subclass"
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:03'!
platformSources
	^#()! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:54'!
platformsDir 
	"Answer the value of srcDir"

	^ platformsDir ifNil: [ platformsDir := (self topDir / self platformsDirName) fullName ]
	! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 03:37'!
platformsDir: anObject
	"Set the value of platformsDir"

	platformsDir := anObject! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:54'!
platformsDirName
	^ 'platforms'! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 12:03'!
pluginsDir 
	^pluginsDir
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/14/2011 16:48'!
pluginsDir: aStringOrDir
	"Set the value of topDir"

	pluginsDir := self dirFrom: aStringOrDir.
	! !

!CPlatformConfig methodsFor: 'utils' stamp: ''!
postBuildActions: maker

	" override to add custom rules after all targets is defined "! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:14'!
preferredIncludes
	^#()! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:28'!
prepareForCogGeneration.
	"make sure these classes are initialized properly "	
	CogRTLOpcodes initialize.
	CogIA32Compiler initialize.
	
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:26'!
prepareForGeneration
	self subclassResponsibility ! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:35'!
prepareForStackVMGeneration
	"make sure these classes are initialized properly "	
		
	StackInterpreter initialize
! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/19/2011 13:20'!
prepareVMMaker

	| maker allPlugins |
	
	"In CogVMs (in contrast to Interpreter VM) the generated sources are platform independent, therefore Cross is ok"
	maker := VMMaker forPlatform: 'Cross'.
	
	maker sourceDirectoryName: self srcDir.
	maker platformRootDirectoryName: self platformsDir.
	
	
	allPlugins := self internalPlugins , self externalPlugins.
	
	"touch plugins to force their source generation unconditionally"
	allPlugins do: [:name | (Smalltalk globals at: name) touch ].
	
	" Why we put all plugins as external?   Because the generated sources are not different whether the plugins were defined as internal or external. VMMaker used to need this to to generate plugins.int and plugins.ext files. But since this is achieved in another way with CMakeVMMaker, there is no different at all to put all plugins as internal or as external."
	maker externalModules addAll:  allPlugins.
	
	^ maker! !

!CPlatformConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/15/2011 17:00'!
setExtraTargetProperties: maker

! !

!CPlatformConfig methodsFor: 'utils' stamp: ''!
setGlobalOptions: maker

	"set any CMake global options, before declaring a project in cmake file"
	! !

!CPlatformConfig methodsFor: 'utils' stamp: 'EstebanLorenzano 2/15/2013 16:47'!
setGlobalOptionsAfterDetermineSystem: maker

	"set any CMake global options, right after declare project and determine running system. 
	 This is sometimes necesary to override cmake settings"
	! !

!CPlatformConfig methodsFor: 'directories' stamp: 'EstebanLorenzano 4/9/2013 11:33'!
setupDirectories: gen
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil: [self buildDir fullName] );
			set: #thirdpartyDir toString: '${buildDir}/thirdParty';
			set: #platformsDir toString: self platformsDir;
			set: #srcDir toString: self srcDir;
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: self outputDir.
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:49'!
srcDir
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := (self topDir / self srcDirName) assureExistence fullName ]! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/4/2011 22:00'!
srcDir: aStringOrDir
	"Set the value of topDir"

	srcDir :=  aStringOrDir.
	! !

!CPlatformConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:49'!
srcDirName
	^ 'src'! !

!CPlatformConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 11:04'!
standardIncludes 
	^#()! !

!CPlatformConfig methodsFor: 'thirdparty libs' stamp: 'IgorStasenko 6/7/2012 16:57'!
thirdpartyLibs
	^ thirdpartyLibs ifNil: [ thirdpartyLibs := OrderedCollection new ].
! !

!CPlatformConfig methodsFor: 'directories' stamp: 'GuillermoPolito 6/17/2013 15:12'!
topDir
	^ topDir ifNil: [ topDir := FileSystem workingDirectory parent ]! !

!CPlatformConfig methodsFor: 'directories' stamp: 'GuillermoPolito 6/17/2013 15:30'!
topDir: pathString
	topDir := pathString asFileReference.
	topDir assureExistence! !

!CPlatformConfig methodsFor: 'source generation' stamp: 'GuillermoPolito 6/17/2013 12:11'!
validateSourcesPresent
	| sources |
	sources := Smalltalk openSources: SmalltalkImage current sourcesName forImage: SmalltalkImage current imageName.
	
	((sources == nil or: [sources atEnd])
			and: [ SmalltalkImage current checkSourcesFileAvailability])
		ifTrue: [
		self error: 'VM source code cannot be generated without .sources file'.
	]		! !

!CPlatformConfig methodsFor: 'directories' stamp: 'GuillermoPolito 6/17/2013 15:30'!
write: aContents toFile: aFileName
	"write a file to current output directory (buildDir).
	use line end convention appropriate for config platform"

	| bldDir |
	bldDir := self buildDir.
	bldDir isString
		ifTrue: [ bldDir := bldDir asFileReference ].
	bldDir assureExistence.
	bldDir forceNewFileNamed: aFileName do: [ :stream | stream nextPutAll: (self fixLineEndsOf: aContents) ]! !

CPlatformConfig subclass: #CogFamilyUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogFamilyUnixConfig commentStamp: 'IgorStasenko 4/27/2012 19:21' prior: 0!
This is an abstract class for all Cog VMs for Unix. 

For ALSA sound driver you need to install a 

 - libasound2
 - libasound2-dev

For UUID you might also need: 

- uuid-dev
 packages  

For SSL Plugins you need libssl & development headers:

sudo apt-get install openssl
sudo apt-get install libssl-dev


Fore more information, check the class comments of all the superclasses.
!

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:45'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "', self linkFlags , '"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 8/15/2011 10:36'!
addDriver: name sources: aSources generator: cmakeGen externalLibs: extLibs

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			addExternalLibraries: extLibs;
			cmd: 'target_link_libraries' params: name , ' ${LINKLIBS}';
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS -m32' 
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 7/7/2011 16:09'!
addVMDrivers: maker
"
libICE
ICE is the Inter Client Exchange protocol, part of X11

libSM
session management library for X11

"
	 self 
		addDriver: 'vm-display-null' 
		sources: #( 
			'${targetPlatform}/vm-display-null/sqUnixDisplayNull' )
		generator: maker
		externalLibs: #();
		
		
		addDriver: 'vm-display-X11' 
		sources: #( 
			'${targetPlatform}/vm-display-X11/sqUnixX11'
			'${targetPlatform}/vm-display-X11/sqUnixMozilla' )
		generator: maker
		
		"-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'"
		externalLibs: #( SM ICE GL X11 nsl dl);
		

		addDriver: 'vm-sound-ALSA' 
		sources: #( 
			'${targetPlatform}/vm-sound-ALSA/sqUnixSoundALSA' )
		generator: maker
		externalLibs: #();

		addDriver: 'vm-sound-null' 
		sources: #( 
			'${targetPlatform}/vm-sound-null/sqUnixSoundNull' )
		generator: maker
		externalLibs: #().
	
"
vm-display-null
	vm-display-X11
	vm-sound-ALSA
	vm-sound-null"! !

!CogFamilyUnixConfig methodsFor: 'build script' stamp: 'EstebanLorenzano 3/8/2013 14:12'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!bash

if [ !! -e vmVersionInfo.h ]; then
	../codegen-scripts/extract-commit-info.sh
fi
cmake .
make

'! !

!CogFamilyUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags
	^ self subclassResponsibility! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/16/2011 01:28'!
configureAsynchFilePlugin: maker

	maker addPlatformSources:
	#( 
		'sqUnixAsynchFile.c'
	)

! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 14:29'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.
	
	maker 
		addPlatformSources: #( 'sqUnixOpenGL.c' ) 
		
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:50'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'. 
	maker addPlatformSources: #( 'sqUnixDragDrop')
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/14/2011 15:07'!
configureFT2Plugin: maker 
	"extra rules for FT2Plugin" 
	
	maker addExternalLibraries: #('freetype' ).
	
	"
	ft2build.h. says: 
	<prefix>/include/freetype2' must be in your current inclusion path "
	maker includeDirectories:  '/usr/include/freetype2'! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/16/2011 01:59'!
configureFileCopyPlugin: maker
	"extra rules for DropPlugin"

	maker addPlatformSources: #( 'sqUnixFileCopyPlugin')
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:31'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker addPlatformSources: #( 'sqUnixFile')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: ''!
configureInternetConfigPlugin: maker
	super configureInternetConfigPlugin: maker.
	maker addPlatformSources: #( 'sqUnixInternetConfiguration' )! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:34'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 'sqUnixJoystickTablet' )
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/7/2011 17:09'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin:  maker.
	
	maker addPlatformSources: #( 'sqUnixLocale.c')
	! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:37'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  

	"requires ALSA"

	maker addPlatformSources: #( 'sqUnixMIDI')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:38'!
configureSecurityPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqUnixSecurity')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:40'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"
	
	maker addPlatformSources: #( 'sqUnixSerial')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:41'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
	
	maker addPlatformSources: #( 'sqUnixSocket')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/16/2011 01:42'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"
	
	maker addPlatformSources: #( 'sqUnixSound')! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: ''!
configureSqueakSSLPlugin: maker 
	"extra rules for SqueakSSLPlugin"
	
	maker addPlatformSources: #( 'sqUnixOpenSSL.c').
	
	maker addExternalLibraries: #('ssl' ).
	! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/15/2011 17:56'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	
	maker includeDirectories: '/usr/include/uuid'.
	
	maker addPlatformSources:
		#( 'sqUnixUUID.c')


! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 16:25'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${crossDir}/plugins/SocketPlugin'.
	
	maker addDefinitions: '-DSQAIO_H=\"sqaio.h\"'
! !

!CogFamilyUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 16:11'!
extraPluginSettings: maker

	maker isExternal ifTrue: [
		"copy lib to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' to: '${outputDir}' 
	].
! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/18/2011 10:48'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.
	
	maker cmd: 'add_custom_command' params: 'OUTPUT ',
		versionC , '
		COMMAND ${platformsDir}/unix/config/verstamp ',versionC,' gcc
		COMMENT "Generating version.c"
	'.
	
	! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'Igor.Stasenko 1/18/2011 10:16'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!CogFamilyUnixConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 1/4/2011 02:37'!
frameworks
	^ #()! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:46'!
linkFlags
	 ^ '-lSM -lICE -ldl -lGL -lpthread -lm -lnsl -lX11'! !

!CogFamilyUnixConfig methodsFor: 'directories' stamp: 'MarianoMartinezPeck 4/12/2011 22:00'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!CogFamilyUnixConfig methodsFor: 'as yet unclassified' stamp: 'Igor.Stasenko 1/4/2011 02:38'!
platformName
	^ 'unix'! !

!CogFamilyUnixConfig methodsFor: 'utils' stamp: 'IgorStasenko 2/9/2011 19:04'!
setExtraTargetProperties: maker


	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'dl'  "dynamic loader"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	self addVMDrivers: maker.! !

CogFamilyUnixConfig subclass: #CogUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:31' prior: 0!
Base and concrete configuration for building a CogVM on Unix platform(s).

Usage: 
CogUnixConfig generateWithSources
or
CogUnixConfig generate   "if VMMaker sources already there"


Fore more information, check the class comments of all the superclasses.
!

CogUnixConfig subclass: #CogFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD'!

!CogFreeBSDConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is the base and concrete configuration for building Cog VM on FreeBSD platform(s).

Fore more information, check the class comments of all the superclasses.
!

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 05:08'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			includeDirectories: '${targetPlatform}/plugins/B3DAcceleratorPlugin';
			includeDirectories: '${crossDir}/plugins/B3DAcceleratorPlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-pthread -lm"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 21:09'!
addVMDrivers: maker

	 self 
		addDriver: 'vm-display-null' 
		sources: #( 
			'${targetPlatform}/vm-display-null/sqUnixDisplayNull' )
		generator: maker;
		
		addDriver: 'vm-display-X11' 
		sources: #( 
			'${targetPlatform}/vm-display-X11/sqUnixX11'
			'${targetPlatform}/vm-display-X11/sqUnixMozilla' )
		generator: maker;
		
		addDriver: 'vm-sound-null' 
		sources: #( 
			'${targetPlatform}/vm-sound-null/sqUnixSoundNull' )
		generator: maker.
	
"
vm-display-null
	vm-display-X11
	vm-sound-null"! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 04:57'!
compilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ super compilerFlags, ' -I/usr/local/include'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/26/2011 20:45'!
compilerFlagsDebug

	^ '-g3 -O0 -msse2 -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=1 -DNOEXECINFO'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/26/2011 20:47'!
compilerFlagsRelease

	^ '-g0 -O2 -msse2  -DNDEBUG -DITIMER_HEARTBEAT=1 
	-DNO_VM_PROFILE=1 -DDEBUGVM=0 -DNOEXECINFO'
! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 21:22'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define HAVE_INTERP_H 1

/* package options */

#define USE_X11 1
#define USE_X11_GLX 1
/* #undef       USE_QUARTZ */
/* #undef       USE_QUARTZ_CGL */
/* #undef       USE_RFB */

/* libraries */

/* #undef       HAVE_LIBX11 */
#define HAVE_LIBXEXT 1
#define HAVE_LIBDL 1
/* #undef       HAVE_DYLD */
/* #undef       HAVE_LIBFFI */
/* #undef       HAVE_ICONV */

/* #undef       USE_AUDIO_NONE */
/* #undef       USE_AUDIO_SUN */
/* #undef       USE_AUDIO_NAS */
/* #undef       USE_AUDIO_OSS */
/* #undef       USE_AUDIO_MACOSX */
/* #undef       OSS_DEVICE */

/* header files */

#define HAVE_UNISTD_H 1
/* #undef       NEED_GETHOSTNAME_P */

#define HAVE_DIRENT_H 1
/* #undef       HAVE_SYS_NDIR_H */
/* #undef       HAVE_SYS_DIR_H */
/* #undef       HAVE_NDIR_H */
#define HAVE_DLFCN_H 1
/* #undef       HAVE_ICONV_H */

#define HAVE_SYS_TIME_H 1
#define TIME_WITH_SYS_TIME 1

#define HAVE_SYS_FILIO_H 1

/* #undef       HAVE_SYS_AUDIOIO_H */
/* #undef       HAVE_SUN_AUDIOIO_H */

/* #undef       HAVE_PTY_H */
/* #undef       HAVE_UTIL_H */
#define HAVE_LIBUTIL_H 1
/* #undef       HAVE_STROPTS_H */

#define HAVE_GL_GL_H 1
/* #undef       HAVE_OPENGL_GL_H */

/* #undef       NEED_SUNOS_H */


#define HAVE_UUID_H
/* system calls/library functions */

#define AT_EXIT atexit

#define HAVE_TZSET 1

#define HAVE_OPENPTY 1
/* #undef       HAVE_UNIX98_PTYS */

#define HAVE_SNPRINTF 1
/* #undef       HAVE___SNPRINTF */

#define HAVE_MMAP 1

/* #undef       HAVE_DYLD */

#define HAVE_LANGINFO_CODESET 1

#define HAVE_ALLOCA 1
/* #undef       HAVE_ALLOCA_H */

#define HAVE_UNSETENV 1

#define HAVE_NANOSLEEP 1

/* widths of primitive types */

#define SIZEOF_INT 4
#define SIZEOF_LONG 4
#define SIZEOF_LONG_LONG 8
#define SIZEOF_VOID_P 4

/* structures */

#define HAVE_TM_GMTOFF 1
#define HAVE_TIMEZONE 1

/* typedefs */

/* #undef       size_t */
/* #undef       socklen_t */

#define squeakInt64 long long

/* architecture */

#define OS_TYPE "unix"

#define VM_HOST "i386-freebsd8.2"
#define VM_HOST_CPU "i386"
/* #undef       VM_HOST_VENDOR */
#define VM_HOST_OS "freebsd8.2"
#define VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef       WORDS_BIGENDIAN */
/* #undef       DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef       DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR "/usr/X11R6/lib"

/* avoid dependencies on glibc2.3 */

/* #undef HAVE_FEATURES_H */

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/25/2011 18:13'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations
	# 3/25/11 - DSG Removed -mno-fused-madd
	since FreeBSD will not support > GCC42"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].
	
	"On *nix & mac with -DNO_ISNAN "
	maker puts:'
if (${WIN32})
	add_definitions(-Werror-implicit-function-declaration)	
else(${WIN32})
	add_definitions(-DNO_ISNAN)
endif (${WIN32})'.

! !

!CogFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'DavidGraham 3/26/2011 03:36'!
setExtraTargetProperties: maker


	maker addExternalLibraries: 
		#(
			'm'  "math lib"
			'pthread' "posix threads" 
		).
		
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	self addVMDrivers: maker.! !

CogFreeBSDConfig subclass: #CogMTFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD'!

!CogMTFreeBSDConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for FreeBSD. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTFreeBSDConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/23/2011 15:34'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=1'	
	! !

!CogMTFreeBSDConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/23/2011 15:34'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTFreeBSDConfig methodsFor: 'sources' stamp: 'IgorStasenko 3/23/2011 15:34'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTFreeBSDConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/23/2011 15:34'!
defaultExternalPlugins

	^ #(
		B3DAcceleratorPlugin
		UUIDPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UnixOSProcessPlugin ?? "
	)! !

!CogMTFreeBSDConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:34'!
executableName
	^ 'CogMTVM'! !

!CogMTFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:34'!
interpreterClass
	^ CoInterpreterMT! !

CogFreeBSDConfig subclass: #StackFreeBSDConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-FreeBSD'!

!StackFreeBSDConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a StackVM for FreeBSD.

Fore more information, check the class comments of all the superclasses.
!

!StackFreeBSDConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/23/2011 15:37'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackFreeBSDConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/23/2011 15:37'!
interpreterClass
	^ StackInterpreter! !

!StackFreeBSDConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

CogUnixConfig subclass: #CogMTUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogMTUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Unix. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTUnixConfig methodsFor: 'compiler flags' stamp: 'NicolasPasserini 3/30/2011 17:02'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=1 -m32' 	
	! !

!CogMTUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/19/2011 23:56'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTUnixConfig methodsFor: 'sources' stamp: 'IgorStasenko 3/19/2011 23:56'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTUnixConfig methodsFor: 'plugins' stamp: 'NicolasPasserini 3/30/2011 17:19'!
defaultExternalPlugins

	^ #(
		B3DAcceleratorPlugin
		"UUIDPlugin"
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UnixOSProcessPlugin ?? "
	)! !

!CogMTUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!CogMTUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/19/2011 23:56'!
interpreterClass
	^ CoInterpreterMT! !

CogUnixConfig subclass: #CogOnDebian64Config
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogOnDebian64Config commentStamp: 'LaurentLaffont 8/15/2011 15:30' prior: 0!
Used to build 32 bit Cog on Debian 64 bits.

You need to prepare Debian this way:

apt-get install ia32-libs libc6-dev-i386 gcc-multilib g++-multilib

ln -s /usr/lib32/libSM.so.6 /usr/lib32/libSM.so
ln -s /usr/lib32/libICE.so.6 /usr/lib32/libICE.so
ln -s /usr/lib32/libGL.so.1 /usr/lib32/libGL.so
ln -s /usr/lib32/libX11.so.6 /usr/lib32/libX11.so

Then you can go on CogOnDebian64Config generateWithSources.

!

!CogOnDebian64Config methodsFor: 'accessing' stamp: 'LaurentLaffont 8/15/2011 08:44'!
commonCompilerFlags 
	^ super commonCompilerFlags , ' -L/usr/lib32'! !

!CogOnDebian64Config methodsFor: 'accessing' stamp: 'LaurentLaffont 8/15/2011 08:36'!
linkFlags 
	^ super linkFlags , ' -L/usr/lib32'! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:38'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'NicolasPasserini 3/30/2011 14:08'!
commonCompilerFlags

	"Common compiler flags
	
	
	LSB_FIRST=1 means that target platform is little endian. 
	set it to 0 for big-endian platforms
	
	"
	
	^ ' -DLSB_FIRST=1 -DUSE_GLOBAL_STRUCT=0 -DCOGMTVM=0 -m32' 	
	! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:55'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' ,self compilerFlagsRelease! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/26/2011 20:45'!
compilerFlagsDebug

	^ '-g3 -O0 -msse2 -D_GNU_SOURCE -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DDEBUGVM=1'

! !

!CogUnixConfig methodsFor: 'compiler flags' stamp: 'EstebanLorenzano 3/13/2013 18:10'!
compilerFlagsRelease
"
THIS FLAGS ARE CRASHING COMPILER 
-fschedule-insns2 
-fschedule-insns 

THIS FLAGS ARE CRASHING VM
-ftree-pre  
-fcaller-saves 

THIS FLAGS ARE WORKING 
-O1 -fthread-jumps -falign-functions -falign-jumps -falign-loops -falign-labels -fcrossjumping -fcse-follow-jumps -fcse-skip-blocks -fdelete-null-pointer-checks -fdevirtualize -fexpensive-optimizations -fgcse -fgcse-lm -finline-small-functions -findirect-inlining -fipa-sra -foptimize-sibling-calls -fpeephole2 -fregmove -freorder-blocks -frerun-cse-after-loop -freorder-functions  -fsched-interblock -fsched-spec -fstrict-aliasing -fstrict-overflow  -ftree-switch-conversion -ftree-vrp

THIS IS LIKE: -O2 -fno-tree-pre -fno-caller-saves 

"

	^ '-g0 -O2 -fno-tree-pre -fno-caller-saves -msse2 -D_GNU_SOURCE -DNDEBUG -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DDEBUGVM=0'! !

!CogUnixConfig methodsFor: 'headers generation' stamp: 'IgorStasenko 3/15/2011 17:54'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/7/2011 17:10'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogUnixConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/19/2013 14:14'!
defaultExternalPlugins
	^ #(
		B3DAcceleratorPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		"UUIDPlugin"
		"UnixOSProcessPlugin ?? "	
		JPEGReaderPlugin 
		JPEGReadWriter2Plugin 			
		RePlugin
		InternetConfigPlugin
	)! !

!CogUnixConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/19/2013 14:14'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		ADPCMCodecPlugin 
		AsynchFilePlugin 
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin 
		CroquetPlugin 
		DeflatePlugin  "ZipPlugin"
		DropPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		IA32ABIPlugin "IA32ABI"
		JoystickTabletPlugin 
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		MIDIPlugin 
		MiscPrimitivePlugin 
		Mpeg3Plugin  	
		SecurityPlugin 
		SerialPlugin 
		SocketPlugin 
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin	
		LocalePlugin
		)! !

!CogUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogUnixConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 16:15'!
extraPluginSettings: maker
	super extraPluginSettings: maker.  
	maker set: #linkFlags toString: '${linkFlags} -m32'
! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/18/2011 10:45'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'version.c'! !

!CogUnixConfig methodsFor: 'headers generation' stamp: 'Igor.Stasenko 1/15/2011 14:55'!
generateConfigH
	"will fix that later"
	self write: self configH toFile: 'config.h'! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:37'!
interpreterClass
	^ CoInterpreter! !

!CogUnixConfig methodsFor: 'accessing' stamp: 'NicolasPasserini 3/30/2011 16:48'!
linkFlags 
	^ super linkFlags , ' -m32'! !

!CogUnixConfig methodsFor: 'sources' stamp: 'Igor.Stasenko 1/16/2011 00:53'!
platformSources
	"files added from platform/unix/vm dir "
	^ #(
	'aio.c'
	'debug.c'
"	'dlfcn-dyld.c'
	'mac-alias.c' "
	'osExports.c'
	'sqUnixCharConv.c'
"	'sqUnixEvent.c' "
	'sqUnixExternalPrims.c'
	'sqUnixHeartbeat.c'
	'sqUnixMain.c'
	'sqUnixMemory.c'
	'sqUnixThreads.c'
	'sqUnixVMProfile.c'
	)! !

!CogUnixConfig methodsFor: 'source files' stamp: 'IgorStasenko 2/9/2011 20:21'!
preferredIncludes
	^ #( '${targetPlatform}/plugins/B3DAcceleratorPlugin')
	! !

!CogUnixConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!CogUnixConfig methodsFor: 'utils' stamp: 'NicolasPasserini 3/30/2011 16:40'!
setExtraTargetProperties: maker

	maker setTargetProperties: 'LINK_FLAGS "-m32"'.
		
	maker puts: 'set_source_files_properties( ${srcVMDir}/cogit.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -momit-leaf-frame-pointer -mno-rtd -mno-accumulate-outgoing-args")'.
		
	
	maker 
		cmd: 'set_source_files_properties'
		params: ' ${targetPlatform}/vm/sqUnixHeartbeat.c PROPERTIES 
		COMPILE_FLAGS "-O1 -fno-omit-frame-pointer -mno-rtd -mno-accumulate-outgoing-args"'.
						
	super setExtraTargetProperties: maker.
! !

CogUnixConfig subclass: #CogUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogUnixDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
THis is a concrete class which generates a DEBUG CogVM for Unix systems. This VM is normally known as a debug CogVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.


Fore more information, check the class comments of all the superclasses.
!

!CogUnixDebugConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

CogUnixConfig subclass: #CogUnixNoGLConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!CogUnixNoGLConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
A slightly modified configuration, which avoids linking with openGL libraries.


Fore more information, check the class comments of all the superclasses.
!

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/4/2011 12:41'!
addDriver: name sources: aSources generator: cmakeGen

	| cfg srcs |
	
	srcs := aSources inject: '' into: [:res :each | res , ' "', each, '"' ].
	cfg := cmakeGen
		captureOutputDuring: [
			cmakeGen printHeader;
			project: name;
			include: '../directories.cmake';
		
			message: 'Adding module: ', name;
			
			addDefinitions:  self compilerFlags;
			addDefinitions: '-fPIC -DPIC';
			set: #sources to: srcs;
			cmd: 'add_library' params: name, ' SHARED ${sources}'; 
			includeDirectories: '${crossDir}/plugins/FilePlugin';
			set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir;
			cmd: 'set_target_properties' params: name , ' PROPERTIES PREFIX "" SUFFIX "" 
			LINK_FLAGS "-lSM -lICE -ldl -lpthread -lm -lnsl -lX11"'
	].
	
		
	self write: cfg toFile: ((self buildDir / name) assureExistence / cmakeGen outputFileName) fullName.
	cmakeGen addSubdirectory:  name.
	! !

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/4/2011 12:39'!
configH
	" right now its like  that "
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1

#undef	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */
#define	HAVE_DLFCN_H 1
#define	HAVE_ICONV_H 1

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#undef	HAVE_GL_GL_H 1
#undef	HAVE_OPENGL_GL_H 

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!CogUnixNoGLConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/13/2012 14:12'!
defaultExternalPlugins
	"Removed the B3DAcceleratorPlugin since we don't have OpenGL bindings here"
	^ (super defaultExternalPlugins copyWithout: #B3DAcceleratorPlugin)
! !

CogUnixConfig subclass: #StackEvtUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackEvtUnixConfig commentStamp: 'golubovsky 7/7/2011 22:38' prior: 0!
This is a concrete class which generates an event-driven StackVM for Unix.

Usage: 
StackEvtUnixConfig generateWithSources

An event-driven Stack VM is an experiment to make VM return to the host process each time it asks for an event.
If there are events to process, the host resumes VM, otherwise VM does not get control until any event is available.

Fore more information, check the class comments of all the superclasses.
!

!StackEvtUnixConfig methodsFor: 'as yet unclassified' stamp: 'golubovsky 7/7/2011 22:36'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackEvtUnixConfig methodsFor: 'as yet unclassified' stamp: 'golubovsky 7/11/2011 23:46'!
crossSources
	"answer the same set of source files except that sqTicker.c is dropped"

  ^ super crossSources select: [ :file | (file = 'sqTicker.c') not ].

! !

!StackEvtUnixConfig methodsFor: 'accessing' stamp: 'golubovsky 7/8/2011 18:37'!
executableName
	"the name of the VM executable"
	^ 'EventVM'.! !

!StackEvtUnixConfig methodsFor: 'source generation' stamp: 'golubovsky 7/9/2011 21:24'!
interpreterClass
	^ StackEvtInterpreter! !

!StackEvtUnixConfig methodsFor: 'as yet unclassified' stamp: 'golubovsky 7/11/2011 23:44'!
platformSources
	"answer the same set of source files except that sqUnixMain.c is replaced with sqUnixEvtMain.c,
	sqUnixHeartbeat.c is replaced with sqUnixEvtBeat.c"

  ^ super platformSources collect: [ :file | (file = 'sqUnixMain.c') 
											ifTrue: 'sqUnixEvtMain.c'  
											ifFalse: [(file = 'sqUnixHeartbeat.c') 
												ifTrue: 'sqUnixEvtBeat.c'
												ifFalse: file]
											].

! !

!StackEvtUnixConfig methodsFor: 'source generation' stamp: 'golubovsky 7/7/2011 22:36'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

StackEvtUnixConfig subclass: #StackEvtUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackEvtUnixDebugConfig methodsFor: 'compiler flags' stamp: 'golubovsky 7/18/2011 23:04'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

CogUnixConfig subclass: #StackUnixConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackUnixConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is a concrete class which generates a StackVM for Unix.

Usage: 
StackInterpreterUnixConfig generateWithSources


Fore more information, check the class comments of all the superclasses.
!

!StackUnixConfig methodsFor: 'sources' stamp: 'IgorStasenko 2/10/2011 11:24'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackUnixConfig methodsFor: 'accessing' stamp: 'IgorStasenko 7/7/2011 13:12'!
executableName
	^ 'StackVM'! !

!StackUnixConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:35'!
interpreterClass
	^ StackInterpreter! !

!StackUnixConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

StackUnixConfig subclass: #StackUnixDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackUnixDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is a concrete class which generates a DEBUG StackVM for Unix systems. This VM is normally known as a debug StackVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.


Fore more information, check the class comments of all the superclasses.
!

!StackUnixDebugConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 2/12/2011 21:56'!
compilerFlags

	^  self commonCompilerFlags, ' ' ,self compilerFlagsDebug! !

StackUnixDebugConfig subclass: #StackUnixDebugFixedVerSIConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Unix'!

!StackUnixDebugFixedVerSIConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:32' prior: 0!
This is done specifically to track down the instability issues of Cog VM on UNIX


Fore more information, check the class comments of all the superclasses.
!

!StackUnixDebugFixedVerSIConfig methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/26/2011 20:46'!
compilerFlagsDebug

	^ '-g3 -O0 -msse2 -save-temps -D_GNU_SOURCE -DITIMER_HEARTBEAT=1 -DNO_VM_PROFILE=1 -DCOGMTVM=0 -DDEBUGVM=1'

! !

!StackUnixDebugFixedVerSIConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 2/10/2011 19:43'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	
	"output a fake version.c file"
	
	self write:
'int vm_serial= 1;
char *vm_date= "<HERE IS SUPPOSED TO BE THE DATE>";
char *cc_version= "<HERE IS SUPPOSED TO BE gcc VERSION>";
char *ux_version= "<FAKE FROZEN VERSION FOR DEBUGGING PURPOSES>";
'
	toFile: 'version.c'.
! !

CPlatformConfig subclass: #CogFamilyWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogFamilyWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is an abstract class and it is the root configuration for building all types of Cog VMs on MS-Windows platform.


What you need to get started:

Download and install Msys, with C/C++ compiler support:
	http://www.mingw.org/wiki/msys
	
Download and install Git:
	http://code.google.com/p/msysgit/
	

///
Optional: add git to the PATH variable:

Add path to git for msys:
Control panel -> System -> System Properies / Advanced  [ Environment Variables ]

There should be already:
C:\Program Files\Git\cmd

add:

C:\Program Files\Git\bin

/// For automated builds, add SQUEAKVM environment variable and set it to the full path to squeak executable.

(Control panel -> System -> System Properies / Advanced  [ Environment Variables ])

in windows shell you can use it then to run squeak: %SQUEAKVM%  , and in mingw bash shell, use $SQUEAKVM

/// Install CMake:
http://www.cmake.org/cmake/resources/software.html

(during installation, in install options , make sure that you choose to add CMake to PATH)


Note, to run cmake under msys shell, you have to explicitly specify the msys makefiles generator, because default one is MS:

cmake . -G"MSYS Makefiles"


Fore more information, check the class comments of all the superclasses.
!

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 3/8/2013 14:13'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!bash

if [ !! -e vmVersionInfo.h ]; then
	../codegen-scripts/extract-commit-info.sh
fi
cmake -G "MSYS Makefiles" .
make

'! !

!CogFamilyWindowsConfig methodsFor: 'compiler flags' stamp: 'EstebanLorenzano 4/25/2012 08:58'!
commonCompilerFlags
	"omit -ggdb2 to prevent generating debug info"
	"Some flags explanation: 
	
	STACK_ALIGN_BYTES=16 is needed in mingw and FFI (and I suppose on other modules too).
	DALLOCA_LIES_SO_USE_GETSP=0 Some compilers return the stack address+4 on alloca function, 
	then FFI module needs to adjust that. It is NOT the case of mingw.
	For more information see this thread: http://forum.world.st/There-are-something-fishy-with-FFI-plugin-td4584226.html
	"
	^ '-march=pentium4 -mwindows -D_MT -msse2 -mthreads -mwin32 -mno-rtd -mms-bitfields -mno-accumulate-outgoing-args ', self winVer ,
	' -DWIN32 -DWIN32_FILE_SUPPORT -DNO_ISNAN -DNO_SERVICE -DNO_STD_FILE_SUPPORT ',
	'-DLSB_FIRST -DVM_NAME="', self executableName,'" -DX86 ',
	'-DSTACK_ALIGN_BYTES=16 -DALLOCA_LIES_SO_USE_GETSP=0 '! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:07'!
configureAsynchFilePlugin:  maker 
	"extra rules for AsynchFilePlugin "

	super configureAsynchFilePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32AsyncFilePrims.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:20'!
configureB3DAcceleratorPlugin:  maker 
	"extra rules for B3DAcceleratorPlugin "

	super configureB3DAcceleratorPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32DualB3DX.c' 'sqWin32D3D.c' 'sqWin32OpenGL.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:23'!
configureCroquetPlugin:  maker 
	"extra rules for CroquetPlugin "

	super configureCroquetPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32CroquetPlugin.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:06'!
configureDropPlugin:  maker 
	"extra rules for DropPlugin "

	super configureDropPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Drop')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 8/1/2012 23:26'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |
	
"	maker isExternal ifFalse: [
		self error: 'building internal FT2Plugin is not supported yet'  	
	].
"
	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.

	"link plugin with freetype lib"
	maker addExternalLibrary: lib targetForLinking.
	maker includeDirectories: lib includeDir.

! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 01:53'!
configureFilePlugin: maker 
	
	super configureFilePlugin: maker.
	
	maker addPlatformSources:
		#( 'sqWin32FilePrims.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:12'!
configureHostWindowPlugin:    maker 
	"extra rules for HostWindowPlugin "

	super configureHostWindowPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32HostWindowPlugin.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:03'!
configureJoystickTabletPlugin:  maker 
	
	super configureJoystickTabletPlugin:  maker.
	
	maker addPlatformSources:
		#( 'sqWin32Joystick.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:10'!
configureLocalePlugin:   maker 
	"extra rules for LocalePlugin "

	super configureLocalePlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32Locale.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:09'!
configureMIDIPlugin:  maker 
	"extra rules for MIDIPlugin "

	super configureMIDIPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32MIDI.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:24'!
configureMpeg3Plugin:  maker 
	"extra rules for Mpeg3Plugin "

	super configureMpeg3Plugin:  maker.
	
	maker addDefinitions: '-DNOPTHREADS'.

	maker addPlatformSources: #( 'sqOpenFile.c')! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:05'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqWin32Security')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:13'!
configureSerialPlugin:     maker 
	"extra rules for SerialPlugin "

	super configureSerialPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32SerialPort.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 02:08'!
configureSocketPlugin:  maker 
	"extra rules for SocketPlugin "

	super configureSocketPlugin:  maker.
	
	maker addPlatformSources: #( 'sqWin32NewNet.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 10/3/2012 13:06'!
configureSqueakSSLPlugin: maker
	| lib |
	maker addPlatformSources: #('sqUnixOpenSSL.c').
	
	lib := self addThirdpartyLibrary: 'openssl'.

	maker includeDirectories: lib includeDir.
	maker linkDirectories: '${outputDir}'.
	
	maker addExternalLibraries: 
		#( 
			'libeay32.dll' 
			'ssleay32.dll'
		).
		
	maker addDependency: lib buildTarget
! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 01:49'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"
	
	maker addPlatformSources:
		#( 'sqWin32UUID.c')


! !

!CogFamilyWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/7/2011 06:45'!
configureWin32OSProcessPlugin: maker 
	"extra rules for Win32OSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${crossDir}/plugins/SocketPlugin'.
! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:26'!
executableType
	^ 'WIN32'! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/1/2012 16:55'!
externalModulesDir
	"answer the location in VM bundle, where plugins and rest of dynamic libs will be copied,
	"
	^ '${outputDir}'! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:29'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String crlf! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 19:55'!
msysPathFor: aPath
	| path |
	
	path := aPath.
	
	path := path copyReplaceAll: '\' with: '/'.
	
	^ path " copyReplaceAll: '\' with: '\\'"! !

!CogFamilyWindowsConfig methodsFor: 'directories' stamp: 'IgorStasenko 7/6/2011 21:08'!
outputDir

	"the directory where built binaries will be stored"

	^ outputDir ifNil: [ outputDir := self msysPathFor: (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 16:51'!
platformName
	^ 'win32'! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 8/1/2012 17:04'!
setupDirectories: gen
	"we have to override that, because we need to convert windoze paths to msys ones"
	| dirsInclude |
	
	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir toString: (self msysPathFor: self topDir fullName); 
			set: #buildDir toString: (self buildDir ifNil: ['${topDir}/build'] ifNotNil:[ self msysPathFor: self buildDir fullName ]);
			set: #thirdpartyDir toString: '${buildDir}/thirdparty';
			set: #platformsDir toString: (self msysPathFor: self platformsDir);
			set: #srcDir toString: (self msysPathFor: self srcDir);
			set: #srcPluginsDir toString: (pluginsDir ifNil: [ '${srcDir}/plugins' ]);
			set: #srcVMDir toString: '${srcDir}/vm';
			set: #platformName toString: self platformName;
			set: #targetPlatform to: '${platformsDir}/${platformName}';
			set: #crossDir toString: '${platformsDir}/Cross';
			set: #platformVMDir toString: '${targetPlatform}/vm';
			set: #outputDir toString: (self msysPathFor: self outputDir).
	].

	self write: dirsInclude toFile: 'directories.cmake'.
	
	gen include: 'directories.cmake'.
	
	gen set: #externalModulesDir toString: self externalModulesDir.
! !

!CogFamilyWindowsConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/16/2011 18:15'!
winVer
	"Set minimum version to WindowsXP (see /cygwin/usr/include//w32api/w32api.h)"
	
	^ '-D_WIN32_WINNT=0x0501 -DWINVER=0x0501'! !

CogFamilyWindowsConfig subclass: #CogWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is a concrete configuration for building a CogVM on Win32 platform.

Built artifacts are placed in ${build}/results dir.
Note, that executable contains debug info. Stript it (using strip command) before packaging for distribution.


Fore more information, check the class comments of all the superclasses.
!

CogWindowsConfig subclass: #CogMTWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogMTWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Win32. This VM is normally known as CogMTVM.


Fore more information, check the class comments of all the superclasses.
!

!CogMTWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/17/2011 23:35'!
compilerFlags
	^ super compilerFlags, ' -DCOGMTVM=1'! !

!CogMTWindowsConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/17/2011 23:33'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/17/2011 23:38'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/17/2011 23:38'!
defaultExternalPlugins

	^ #(
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!CogMTWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:25'!
executableName
	^ 'CogMTVM'! !

!CogMTWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:37'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

!CogWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:30'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 10/3/2012 11:47'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' , self compilerFlagsRelease! !

!CogWindowsConfig methodsFor: 'plugins' stamp: ''!
compilerFlagsDebug
	"Define NDEBUG for production to exclude asserts "
	^ '-g3 -O0 -march=pentium4 -momit-leaf-frame-pointer -maccumulate-outgoing-args -funroll-loops  -DDEBUGVM=1'! !

!CogWindowsConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 4/5/2012 17:14'!
compilerFlagsRelease
	"Define NDEBUG for production to exclude asserts "
	^ '-g0 -O2 -march=pentium4 -momit-leaf-frame-pointer -maccumulate-outgoing-args -funroll-loops ',
	'-DNDEBUG -DDEBUGVM=0'! !

!CogWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/16/2011 16:53'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogWindowsConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/24/2012 00:30'!
defaultExternalPlugins

	^ #(
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
	
		"Win32OSProcessPlugin"
	)! !

!CogWindowsConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/24/2012 00:26'!
defaultInternalPlugins

	^ #(
	
ADPCMCodecPlugin 
AsynchFilePlugin
B3DAcceleratorPlugin 
BalloonEnginePlugin "B2DPlugin" 
BitBltSimulation "BitBltPlugin"
BMPReadWriterPlugin 
CroquetPlugin 
DeflatePlugin  "ZipPlugin"
DropPlugin 
DSAPlugin "DSAPrims" 
FFTPlugin 
FilePlugin 
FloatArrayPlugin 
FloatMathPlugin 
HostWindowPlugin 
IA32ABIPlugin "IA32ABI"
JoystickTabletPlugin 
JPEGReaderPlugin 
JPEGReadWriter2Plugin 
KlattSynthesizerPlugin "Klatt"
LargeIntegersPlugin "LargeIntegers"
LocalePlugin 
Matrix2x3Plugin 
MIDIPlugin 
MiscPrimitivePlugin 
Mpeg3Plugin 
RePlugin 
SecurityPlugin 
SerialPlugin 
SocketPlugin 
SoundCodecPlugin "SoundCodecPrims"
SoundGenerationPlugin 
StarSqueakPlugin 
SurfacePlugin 
UUIDPlugin
	)! !

!CogWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/17/2011 02:02'!
externalLibraries
	
	^ #( 
		ddraw dinput opengl32 wsock32 comdlg32 ole32 winmm
		version wininet user32 gdi32 psapi kernel32 crtdll dsound secur32
	).! !

!CogWindowsConfig methodsFor: 'plugins' stamp: 'IgorStasenko 7/6/2011 21:09'!
extraPluginSettings: maker


	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: '${outputDir}'.
		
		maker cmd: 'set_target_properties' params:  maker moduleName , ' PROPERTIES PREFIX "" '
	]! !

!CogWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/25/2011 22:08'!
extraSources

	^ 
	'${resources}'! !

!CogWindowsConfig methodsFor: 'settings' stamp: 'IgorStasenko 3/25/2011 22:24'!
extraVMSettings: maker

	| res |
	
	res := '"${buildDir}/resource.o"'.
	
	self write: self resourceFile toFile: 'Cog.rc'.
		
	maker cmd: 'add_custom_command' params: 'OUTPUT ', res ,
	'
		COMMAND 	windres --include-dir ${targetPlatform}/misc -D_WIN32 -i ${buildDir}/Cog.rc -o ', res , '
		COMMENT "Generating resource file..."
	'.
	
	maker set:  #resources to: res.
	
	maker includeDirectories: '${targetPlatform}/third-party/dx9sdk/Include'.
	! !

!CogWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:23'!
iconFileName
	^ 'Cog.ico'! !

!CogWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:27'!
interpreterClass
	^ CoInterpreter! !

!CogWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/16/2011 16:58'!
platformSources
	"files added from platform/win32/vm dir "
	^ #(
		'sqWin32Alloc.c'
		'sqWin32Directory.c'
		'sqWin32Heartbeat.c'
		'sqWin32Service.c'
		'sqWin32VMProfile.c'
		'sqWin32Args.c'
		'sqWin32Exports.c'
		'sqWin32Intel.c'
		'sqWin32Stubs.c'
		'sqWin32Window.c'
		'sqWin32Backtrace.c'
		'sqWin32ExternalPrims.c'
		'sqWin32PluginSupport.c'
		'sqWin32Threads.c'
		'version.c'
		'sqWin32DirectInput.c'
		'sqWin32GUID.c'
		'sqWin32Prefs.c'
		'sqWin32Utils.c'
	)! !

!CogWindowsConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration! !

!CogWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:22'!
resourceFile

	^ self resourceFileTemplate
		copyReplaceAll: '@ICON@' with: self iconFileName! !

!CogWindowsConfig methodsFor: 'resources' stamp: 'IgorStasenko 3/25/2011 22:22'!
resourceFileTemplate

	^ '
#ifdef _WIN32
1                       ICON    DISCARDABLE     "@ICON@"
2                       ICON    DISCARDABLE     "@ICON@"
3                       ICON    DISCARDABLE     "@ICON@"
#endif
'! !

!CogWindowsConfig methodsFor: 'utils' stamp: 'IgorStasenko 4/5/2012 18:01'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

"	maker puts: 'set_source_files_properties(${srcVMDir}/cogit.c PROPERTIES COMPILE_FLAGS -O1)'."
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O1)'
! !

CogWindowsConfig subclass: #CogWindowsDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!CogWindowsDebugConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 11:44'!
compilerFlags
	"depends on config ..."
	^ self commonCompilerFlags, ' ' , self compilerFlagsDebug! !

!CogWindowsDebugConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 10/3/2012 11:45'!
setExtraTargetProperties: maker

	maker addExternalLibraries: self externalLibraries.
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: '${outputDir}'.

! !

CogWindowsConfig subclass: #StackWindowsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Windows'!

!StackWindowsConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is a configuration for building StackVM on Win32 platform.


Fore more information, check the class comments of all the superclasses.
!

!StackWindowsConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/17/2011 02:51'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackWindowsConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/17/2011 02:52'!
executableName
	^ 'StackVM'! !

!StackWindowsConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 00:36'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ StackInterpreter! !

!StackWindowsConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration! !

CPlatformConfig subclass: #MacOSConfig
	instanceVariableNames: 'resourcesDir'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!MacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:33' prior: 0!
This is an abstract class for all Mac Carbon configurations. It is intended to share code between different concrete implementations. 

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).


Fore more information, check the class comments of all the superclasses.
!

MacOSConfig subclass: #CocoaIOSConfig
	instanceVariableNames: 'generateForRelease'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is an abstract class for all Mac Cocoa configurations. It is intended to share code between different concrete implementations. 

Fore more information, check the class comments of all the superclasses.
!

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleExecutable
	^ self executableName ! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:10'!
CFBundleGetInfoString
	^ self CFBundleShortVersionString
! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/3/2011 20:17'!
CFBundleIconFile
	"An application icon"
	^ 'Squeak.icns'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:12'!
CFBundleIdentifier
	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	^ 'org.squeakfoundation.Squeak'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2012 18:32'!
CFBundleName
	"An application name"
	^ self executableName", ' (Cocoa) 32bits'"! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/2/2011 09:11'!
CFBundleShortVersionString
	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 7/8/2011 13:41'!
CFBundleVersion
	"An application version"
	^ '6.0'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 1/10/2011 22:08'!
NSMainNibFile
	^'MainMenu'! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
SqueakDebug
	^self isGenerateForRelease 
		ifTrue: [ 0 ]
		ifFalse: [ 1 ]! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/30/2011 11:03'!
architecture 
	^'i386'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 5/3/2013 17:47'!
commonCompilerFlags
	"Common compiler flags"
	^{
	'-arch i386'. 
	'-mmacosx-version-min=10.5'. 
	'-DHAVE_UUID_GENERATE'. 
	'-DDEFAULT_IMAGE_NAME="', self executableName, '.image"'}! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 4/8/2012 11:27'!
compilerFlags 
	| releaseFlags |
	
	releaseFlags := self isGenerateForRelease 
		ifTrue: [ self compilerFlagsRelease ]
		ifFalse: [ self compilerFlagsDebug ].
		
	^String streamContents: [ :stream |
		(self commonCompilerFlags, releaseFlags) asSet
			do: [ :each | stream nextPutAll: each ]
			separatedBy: [ stream space ] ]! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 6/22/2012 13:04'!
compilerFlagsRelease 
	^#(
	"'-fobjc-direct-dispatch'" 
	'-msse3'
	"'-msse4.1'"
	"'-msse4.2'"
	"'-mdynamic-no-pic'" 
	"'-fwritable-strings'" 
	'-Os' 
	'-fvisibility=hidden'
	'-funroll-loops' 
	"'-fno-asm'" 
	'-fasm-blocks' 
	'-finline-functions' 
	'-mfpmath=sse' 
	'-fomit-frame-pointer' 
	'-march=pentium-m' 
	'-mtune=prescott' 
	'-falign-functions=16'  
	'-fno-gcse' 
	'-fno-cse-follow-jumps' 
	'-std=gnu99' 
	'-DBUILD_FOR_OSX' 
	"'-DUSE_INLINE_MEMORY_ACCESSORS'" 
	'-DLSB_FIRST' 
	'-DUSE_INLINE_MEMORY_ACCESSORS' 
	'-DHAVE_SYS_TIME_H' 
	'-DHAVE_NANOSLEEP' 
	'-DICC_DEBUG=0'
	'-DICC_OPTLEVEL="speedHLO"' 
	'-DICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION=1' 
	'-DICC_OPT_PARALLEL=0' 
	'-DICC_OPT_PREFETCH_INSERTION=1' 
	'-DICC_OPT_PROVIDE_FRAME_PTR=0' 
	'-DICC_OPT_USE_ARCH_IA32="SSE42"')! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/22/2011 09:42'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker. 
	maker addFrameworks: self frameworks.	 
	maker addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'MarianoMartinezPeck 4/23/2011 13:32'!
configureClipboardExtendedPlugin: maker
	
	maker addPlatformSources: #('sqMacExtendedClipboard.m' ) 
	! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2012 17:37'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker 
		addSources: #('sqMacHostWindow.m' ) 
		prefixed: '${platformsDir}/iOS/vm/OSX/plugins/HostWindowPlugin/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/26/2011 11:34'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 4/2/2012 18:20'!
configureLocalePlugin: maker
	maker addFrameworks: #('CoreFoundation').
	maker addPlatformSources: #( 'sqIOSLocale.c' )	.
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/17/2011 16:57'!
configureMacMenubarPlugin: maker
	maker includeDirectories: '${platformsDir}/iOS/plugins/MacMenubarPlugin'.
	maker 
		addSources: #('MacMenuOS9ToOSX.m') 
		prefixed: '${platformsDir}/iOS/plugins/MacMenubarPlugin/'
! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/20/2011 13:47'!
configureObjectiveCPlugin: maker 
	"extra rules for ObjectiveCPlugin"

	maker addDefinitions: ' -x objective-c'.
	maker addFrameworks: self frameworks.
	maker includeDirectories: '${platformsDir}/iOS/plugins/SqueakObjectiveC'.
	maker 
		addSources: #('squeakProxy.m' 'squeakSUnitTester.m') 
		prefixed: '${platformsDir}/iOS/plugins/SqueakObjectiveC/'.
	! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2011 19:48'!
configureSoundPlugin: maker
	super configureSoundPlugin: maker.
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/SoundPlugin ${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'.
	maker 
		addSources: #('sqSqueakSoundCoreAudio.m' 'sqSqueakSoundCoreAudioAPI.m' ) 
		prefixed: '${platformsDir}/iOS/plugins/SoundPlugin/'.
	maker 
		addSources: #('sqSqueakOSXSoundCoreAudio.m' ) 
		prefixed: '${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin/'! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/20/2011 14:31'!
configureUUIDPlugin: maker
	super configureUUIDPlugin: maker.
	maker addFrameworks: #(CoreFoundation).  
	maker addDefinitions: '-x objective-c'.  
	maker addPlatformSources: #('sqMacUUID.c' )! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/2/2011 08:40'!
coreSources
	^#('interp.c')! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 20:25'!
crossSources 
	^#(
		'sqNamedPrims.c'
		'sqVirtualMachine.c')! !

!CocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 1/2/2011 09:29'!
defaultExternalPlugins
	^#()! !

!CocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 3/26/2011 15:42'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin 
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFIPlugin
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		MacMenubarPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		RePlugin 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin 
		StarSqueakPlugin 
		SurfacePlugin)! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 14:37'!
executableType
	^ 'MACOSX_BUNDLE'! !

!CocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/5/2012 02:47'!
extraPluginSettings: maker	
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.
	
	maker 
		setTargetProperty: 'COMPILE_FLAGS' 
		to: '"-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'.  

	maker isExternal ifTrue: [
		"copy result to results dir "
		
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir.
		maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
		maker puts: 'list(APPEND linkFlags "-undefined dynamic_lookup")' ].
	
	"maker addXCodeProperty: 'GCC_VERSION' value: '4.3'."
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/' , self executableName , '_Prefix.pch'.
	
! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 9/19/2011 12:23'!
extraSources
	^'${buildDir}/', self prefixHeaderFileName, '
 ${resources} ', 
	'${buildDir}/', self prefixHeaderFileName, '
 ${resourcesLocaleEnglish}'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 12/30/2011 15:56'!
extraVMSettings: maker
	self architecture
		ifNotNil: [ :arch | maker set: 'CMAKE_OSX_ARCHITECTURES' toString: arch ].
	self setResourceProperties: maker.
! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 7/29/2011 14:38'!
frameworks
	^ #(
	Cocoa
	Foundation
	AudioToolbox
	CoreAudio
	SystemConfiguration
	ApplicationServices
	QuartzCore
	OpenGL
	AGL)! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/7/2012 14:01'!
freetypeLibClass 
	^CMOSXFreetype2! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
generateForDebug
	generateForRelease := false! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
generateForRelease
	generateForRelease := true! !

!CocoaIOSConfig methodsFor: 'initialization' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
initialize 
	super initialize.
	self generateForRelease! !

!CocoaIOSConfig methodsFor: 'testing' stamp: 'EstebanLorenzano 11/29/2011 16:18'!
isGenerateForRelease 
	^generateForRelease! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 07:50'!
platformName 
	^'iOS'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 6/26/2012 11:21'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/aio.c'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXCGView.m'
		'OSX/sqSqueakOSXOpenGLView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c')! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 2/15/2012 13:42'!
plistFile
	| plist |
	
	plist := self plistTemplate.	
	self plistKeys
		do: [:key | 
			plist := plist 
				copyReplaceAll: '@' , key , '@' 
				with: (self perform: key) asString ].

	^ self fixLineEndsOf: plist! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 9/19/2012 13:59'!
plistKeys 
	^#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier
	NSMainNibFile
	SqueakDebug)! !

!CocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/3/2011 15:37'!
plistTemplate 
^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakImage.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakSources.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakChanges.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>FAST</string>
	<key>CFBundleVersion</key>
	<string>21.0</string>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>LSMinimumSystemVersion</key>
	<string>${MACOSX_DEPLOYMENT_TARGET}</string>
	<key>NSMainNibFile</key>
	<string>@NSMainNibFile@</string>
	<key>NSPrincipalClass</key>
	<string>SqueakOSXApplication</string>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>@SqueakDebug@</integer>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakQuitOnQuitAppleEvent</key>
	<false/>
	<key>SqueakResourceDirectory</key>
	<string></string>
	<key>SqueakTrustedDirectory</key>
	<string>/foobar/tooBar/forSqueak/bogus/</string>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Squeak/Internet/My Squeak/</string>
	<key>SqueakUseFileMappedMMAP</key>
	<false/>
	<key>SqueakUIFadeForFullScreenInSeconds</key>
	<real>0.5</real>
	<key>UTExportedTypeDeclarations</key>
	<array>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Image File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.image</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STim</string>
				<key>public.filename-extension</key>
				<array>
					<string>image</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-image</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Sources File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.sources</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STso</string>
				<key>public.filename-extension</key>
				<array>
					<string>sources</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-sources</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.utf8-plain-text</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Changes File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.changes</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STch</string>
				<key>public.filename-extension</key>
				<array>
					<string>changes</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-changes</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Script File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.script</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>SOBJ</string>
				<key>public.filename-extension</key>
				<array>
					<string>sobj</string>
				</array>
				<key>public.mime-type</key>
				<string>application/squeak-script</string>
			</dict>
		</dict>
		<dict>
			<key>UTTypeConformsTo</key>
			<array>
				<string>public.data</string>
			</array>
			<key>UTTypeDescription</key>
			<string>Squeak Project File</string>
			<key>UTTypeIdentifier</key>
			<string>org.squeak.project</string>
			<key>UTTypeTagSpecification</key>
			<dict>
				<key>com.apple.ostype</key>
				<string>STpr</string>
				<key>public.filename-extension</key>
				<array>
					<string>pr</string>
				</array>
				<key>public.mime-type</key>
				<string>application/x-squeak-project</string>
			</dict>
		</dict>
	</array>
</dict>
</plist>
'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 12:08'!
pluginsDir 
	^'${srcDir}/vm/intplugins'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 10:29'!
precompiledHeaders 
	^
'//
// Prefix header for all source files of the ''', self executableName, ''' target in the ''', self executableName, ''' project
//

#ifdef __OBJC__
	', 
	(String streamContents: [ :stream | 
		self precompiledImports 
			do: [ :each | 
				stream 
					nextPutAll: '#import ';
					nextPut: $<;
					nextPutAll: each; 
					nextPut: $> ]
			separatedBy: [ 
				stream cr ] ]),  '
#endif
'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 10:25'!
precompiledImports 
	^#('Cocoa/Cocoa.h')! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:25'!
preferredIncludes
	^ #(
	'${buildDir}/'
	'${platformsDir}/iOS/vm/iPhone' "config.h is here. Why???"
	)
	! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/17/2011 18:40'!
prefixHeaderFileName 
	^self executableName, '_Prefix.pch'! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 12/3/2011 11:31'!
resources 
	^#('Squeak VM.r'
	'Cog.icns'
	'Squeak.icns'
	'SqueakChanges.icns'
	'SqueakPlugin.icns'
	'SqueakScript.icns'
	'SqueakGeneric.icns'
	'SqueakProject.icns'
	'SqueakSources.icns')

! !

!CocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 6/22/2012 13:05'!
setExtraTargetProperties: maker
	| plist precompiledHeaders |

	" generated and add Info.plist file "
	plist := self plistFile.	

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
			
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(maker buildDir forceNewFileNamed: precompiledHeaders) 
		nextPutAll: self precompiledHeaders;
		close.

	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.	

	"maker 
		addXCodeProperty: 'GCC_ENABLE_SSE3_EXTENSIONS' value: 'YES';  
		addXCodeProperty: 'GCC_ENABLE_SSE41_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_ENABLE_SSE42_EXTENSIONS' value: 'YES';
		addXCodeProperty: 'GCC_GENERATE_DEBUGGING_SYMBOLS' value: 'NO';  
		addXCodeProperty: 'GCC_INLINES_ARE_PRIVATE_EXTERN' value: 'YES';
		addXCodeProperty: 'GCC_UNROLL_LOOPS' value: 'YES'.	"
	
	"Extras"
	maker 
		addXCodeProperty: 'ICC_DEBUG' value: 'NO';
		addXCodeProperty: 'ICC_OPTLEVEL' value: 'speedHLO';
		addXCodeProperty: 'ICC_OPT_IPO_FOR_SINGLE_FILE_COMPILATION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PARALLEL' value: 'NO';
		addXCodeProperty: 'ICC_OPT_PREFETCH_INSERTION' value: 'YES';
		addXCodeProperty: 'ICC_OPT_PROVIDE_FRAME_PTR' value: 'NO';
		addXCodeProperty: 'ICC_OPT_USE_ARCH_IA32' value: 'SSE41';
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-finline-functions -mfpmath=sse -march=pentium-m -mtune=prescott -falign-functions=16  -fno-gcse -fno-cse-follow-jumps  -DLSB_FIRST';
		addXCodeProperty: 'PER_ARCH_CFLAGS_ppc' value: '-fast -mtune=7450 -mcpu=7450 -D_BSD_SOCKLEN_T_=int'! !

!CocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/2/2011 10:15'!
srcDir 
	^'${topDir}/platforms/iOS/vm/src'! !

!CocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/10/2011 21:25'!
standardIncludes
	^ #(
	'${crossDir}/plugins/SerialPlugin'   
	'${targetPlatform}/plugins/FilePlugin'
	'${crossDir}/plugins/FilePlugin'
	'${targetPlatform}/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' 
	'${crossDir}/plugins/HostWindowPlugin'
	'${crossDir}/plugins/DropPlugin'
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/vm/OSX'
)
	! !

CocoaIOSConfig subclass: #CogFamilyCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogFamilyCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is an abstract class for all Mac Cocoa Cog VMs family. That is, for all CogVMS (StackVM, CogVM, CogMTVM, etc). 

Fore more information, check the class comments of all the superclasses.
!

CogFamilyCocoaIOSConfig subclass: #CogCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a CogVM for Mac using the Cocoa library

Fore more information, check the class comments of all the superclasses.
!

!CogCocoaIOSConfig methodsFor: 'source generation' stamp: 'MarianoMartinezPeck 4/23/2011 19:34'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/15/2013 13:55'!
commonCompilerFlags
	^super commonCompilerFlags, #('-DCOGVM')! !

!CogCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 1/27/2011 18:13'!
coreSources 
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogCocoaIOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogCocoaIOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
interpreterClass
	^ CoInterpreter! !

!CogCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/23/2011 15:17'!
pluginsDir 
	^'${srcDir}/plugins'! !

!CogCocoaIOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!CogCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:51'!
srcDir 
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := (self topDir / self srcDirName) fullName ]! !

!CogCocoaIOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin
		with: #IA32ABIPlugin! !

CogCocoaIOSConfig subclass: #CogMTCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!CogMTCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Mac using the Cocoa library. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/20/2012 13:45'!
commonCompilerFlags
	^super commonCompilerFlags, #('-DCOGMTVM=1')! !

!CogMTCocoaIOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/18/2011 16:26'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTCocoaIOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!CogMTCocoaIOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 16:24'!
interpreterClass
	"answer an interpreter class for VM source code generation"
	^ CoInterpreterMT! !

!CogMTCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 7/2/2011 13:31'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin! !

!CogFamilyCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 3/18/2011 12:05'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!CogFamilyCocoaIOSConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 4/2/2011 11:54'!
CFBundleVersion
	"An application version"
	^ '6.0-pre'! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/13/2013 15:05'!
commonCompilerFlags
	^super commonCompilerFlags, 
		#(
	'-funroll-loops' 
	'-fasm-blocks' 
	'-fno-inline-functions' 
	'-mfpmath=sse' 
	'-march=pentium-m' 
	'-mtune=prescott' 
	'-falign-functions=16' 
	'-fno-gcse' 
	'-fno-cse-follow-jumps' 
	'-std=gnu99'
	'-fmessage-length=0' 
	'-fpascal-strings' 
	'-DBUILD_FOR_OSX' 
	"'-DUSE_INLINE_MEMORY_ACCESSORS=1' "
	'-DLSB_FIRST' 
	'-DHAVE_SYS_TIME_H' 
	'-DHAVE_NANOSLEEP' 
	'-DCOGMTVM=0' 
	'-DUSE_GLOBAL_STRUCT=0' 
	'-DBASE_HEADER_SIZE=4')! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/20/2013 13:58'!
compilerFlagsDebug
	^#('-g3' '-O0' '-DDEBUGVM=1')! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/13/2013 15:45'!
compilerFlagsRelease 
	^#('-g0' '-O3' '-fomit-frame-pointer' '-DNDEBUG' '-DDEBUGVM=0')! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/23/2011 12:23'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 2/5/2011 09:28'!
configureHostWindowPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/HostWindowPlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 7/14/2011 11:01'!
configureQuicktimePlugin: maker
	"extra rules for QuicktimePlugin"
	
	maker includeDirectories: '${platformsDir}/Cross/plugins/QuicktimePlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 5/1/2012 12:04'!
configureSqueakSSLPlugin: maker
	maker addPlatformSources: #('sqMacSSL.c').! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 10/31/2012 15:10'!
configureSystemInfoPlugin: maker
	maker includeDirectories: '${platformsDir}/Cross/plugins/SystemInfoPlugin'.
	maker addPlatformSources: #('sqSystemInfo.m' ).! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 5/1/2012 10:39'!
configureUnixAioPlugin: maker
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker includeDirectories: '${platformsDir}/Cross/plugins/SocketPlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 6/14/2011 12:55'!
configureUnixOSProcessPlugin: maker
	super configureHostWindowPlugin: maker.
	maker includeDirectories: '${platformsDir}/Cross/plugins/SocketPlugin'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:15'!
crossSources 
	^super crossSources, #(
	'sqExternalSemaphores.c'
	'sqHeapMap.c'
	'sqTicker.c')! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/19/2013 13:27'!
defaultExternalPlugins 
	^(self versionExternalPlugins),
		#(
		UUIDPlugin
		FloatMathPlugin
		AsynchFilePlugin
		SerialPlugin
		Mpeg3Plugin
		CroquetPlugin
		JoystickTabletPlugin
		MIDIPlugin
		B3DAcceleratorPlugin
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin
		RePlugin
		LocalePlugin
		ObjectiveCPlugin
		QuicktimePlugin
		TestOSAPlugin
		SqueakSSLPlugin
		"UnixOSProcessPlugin"
	)! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 4/19/2013 13:27'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		ClipboardExtendedPlugin
		DSAPlugin 
		DeflatePlugin 
		DropPlugin 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		GeniePlugin 
		HostWindowPlugin 
		"JPEGReadWriter2Plugin 
		JPEGReaderPlugin" 
		KlattSynthesizerPlugin 
		LargeIntegersPlugin 
		"MacMenubarPlugin" "This plugin is not yet ported"
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		"RePlugin" 
		SecurityPlugin 
		SocketPlugin 
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		StarSqueakPlugin 
		SurfacePlugin 
		UnixAioPlugin
		UnixOSProcessPlugin
		)! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/17/2011 17:20'!
extraSources
	" mac VM using some unix sources "
	
	^super extraSources,'
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/vm/sqUnixHeartbeat.c 
	${platformsDir}/unix/vm/sqUnixVMProfile.c 
	${platformsDir}/unix/vm/sqUnixThreads.c '! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 6/26/2012 11:21'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		"'Common/aio.c'"
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'Common/Classes/sqSqueakCursorAPI.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		'OSX/SqueakOSXAppDelegate.m'
		'OSX/sqMacV2Browser.m'
		'OSX/sqMacUnixExternalPrims.m'
		'OSX/sqSqueakOSXApplication.m'
		'OSX/sqSqueakOSXFileDirectoryInterface.m'
		'OSX/sqSqueakOSXApplication+attributes.m'
		'OSX/sqSqueakOSXInfoPlistInterface.m'
		'OSX/sqSqueakOSXApplication+imageReadWrite.m'
		'OSX/sqSqueakOSXScreenAndWindow.m'
		'OSX/sqSqueakOSXCGView.m'
		'OSX/sqSqueakOSXOpenGLView.m'
		'OSX/SqViewClut.m'
		'OSX/BitMapConversionLogicFromX11.c'
		'OSX/SqViewBitmapConversion.m'
		'OSX/macintoshosxextra.c'
		'OSX/sqSqueakOSXApplication+cursor.m'
		'OSX/sqSqueakOSXApplication+events.m'
		'OSX/keyBoardStrokeDetails.m'
		'OSX/SqueakOSXApplication.m'
		'OSX/sqSqueakOSXClipboardAPI.m'
		'OSX/sqSqueakOSXApplication+clipboard.m'
		'OSX/sqSqueakOSXDropAPI.m'
		'iPhone/sqMacV2Memory.c'
		'iPhone/osExports.c'
	  	'Common/Classes/sqSqueakScreenAPI.m')! !

!CogFamilyCocoaIOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/13/2013 16:06'!
sdkVersion 
	^'10.6'! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'IgorStasenko 6/5/2012 02:55'!
setExtraTargetProperties: maker
	| plist |

	maker addFrameworks: self frameworks.

	" generated and add Info.plist file "
	plist := self plistFile.

	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.  

	(maker buildDir forceNewFileNamed: self prefixHeaderFileName) 
		nextPutAll: self precompiledHeaders;
		close.
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', self prefixHeaderFileName.

	maker 
		addXCodeProperty: 'PER_ARCH_CFLAGS_i386' value: '-DLSB_FIRST -mfpmath=sse -finline-functions  -fno-cse-follow-jumps -fno-gcse -mtune=prescott -march=pentium-m -falign-functions=16'.
		
	"maker 
		addXCodeProperty: 'GCC_VERSION' value: '4.3'."

	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'. 
		
"	maker set: 'CMAKE_C_COMPILER' to: '/usr/bin/gcc-4.2'.
	maker set: 'CMAKE_CXX_COMPILER' to: '/usr/bin/g++-4.2'.		
"
	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	maker set: 'RUNTIME_OUTPUT_DIRECTORY' toString: self outputDir.! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/15/2013 17:25'!
setGlobalOptions: maker

	"set any CMake global options, before declaring a project in cmake file"
	
	maker set: 'CMAKE_C_COMPILER' to: '/usr/bin/gcc'.
	maker set: 'CMAKE_CXX_COMPILER' to: '/usr/bin/g++'.! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/13/2013 14:56'!
setGlobalOptionsAfterDetermineSystem:  maker
	maker set: 'CMAKE_OSX_DEPLOYMENT_TARGET' to: '10.5'.
	maker 
		set: 'CMAKE_OSX_SYSROOT' 
		to: '/Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX', self sdkVersion, '.sdk'! !

!CogFamilyCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 12/30/2011 12:22'!
setResourceProperties: maker
	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.

	maker 
		set: 'resources' 
		to: (String streamContents: [ :stream | 
			self  resources
				do: [ :each | 
					stream 
						nextPut: $";
						nextPutAll: '${resourceDir}/';
						nextPutAll: each;
						nextPut: $"]
				separatedBy: [ stream space ] ]).
		
	maker 
		set: 'resourcesLocaleEnglish' 
		to: '"${resourceDir}/English.lproj/InfoPlist.strings" "${resourceDir}/English.lproj/MainMenu.nib"'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resourcesLocaleEnglish} PROPERTIES MACOSX_PACKAGE_LOCATION Resources/English.lproj'.

! !

!CogFamilyCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 3/22/2011 17:31'!
standardIncludes
	^#(
	'${srcDir}/vm'
	'${platformsDir}/iOS/vm/OSX'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/HostWindowPlugin'
	'${platformsDir}/Cross/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin' "Sources are here :("
	'${crossDir}/plugins/FilePlugin'
	)	
! !

!CogFamilyCocoaIOSConfig methodsFor: 'plugins' stamp: 'EstebanLorenzano 7/2/2011 13:32'!
versionExternalPlugins 
	"Cog Version Specific Plugins. Some times you can't use same plugins in a version (for instance, CogMT uses a diferent FFI, and you can't build IA32ABIPlugin in MT for now)"
	^Array 
		with: #FFIPlugin
		with: #IA32ABIPlugin! !

CogFamilyCocoaIOSConfig subclass: #StackCocoaIOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackCocoaIOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Cocoa library

Fore more information, check the class comments of all the superclasses.
!

StackCocoaIOSConfig subclass: #StackCocoaIOSCLANGConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackCocoaIOSCLANGConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:35' prior: 0!
Experimental configuration for compiling using clang compiler

Fore more information, check the class comments of all the superclasses.
!

!StackCocoaIOSCLANGConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 18:30'!
coreSources 
" can't use GCC stuff "
	^ #(
		'interp.c'
		)! !

!StackCocoaIOSCLANGConfig methodsFor: 'as yet unclassified' stamp: 'IgorStasenko 3/18/2011 18:32'!
setExtraTargetProperties: maker


	maker set: 'CMAKE_C_COMPILER' to: 'clang'.
	
	super setExtraTargetProperties: maker! !

!StackCocoaIOSConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/15/2013 13:56'!
commonCompilerFlags 
	^super commonCompilerFlags, #('-DSTACKVM')! !

!StackCocoaIOSConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 2/5/2011 09:40'!
coreSources 
	^ #(
		'gcc3x-interp.c'
		)! !

!StackCocoaIOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/18/2011 15:36'!
executableName
	^ 'StackVM'! !

!StackCocoaIOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:47'!
interpreterClass
	^ StackInterpreter! !

!StackCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/23/2011 15:17'!
pluginsDir 
	^'${srcDir}/plugins'! !

!StackCocoaIOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

!StackCocoaIOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:52'!
srcDir 
	"Answer the value of srcDir"

	^ srcDir ifNil: [ srcDir := (self topDir / self srcDirName) fullName ]! !

!StackCocoaIOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
versionExternalPlugins 
	^Array 
		with: #ThreadedIA32FFIPlugin
		with: #IA32ABIPlugin! !

StackCocoaIOSConfig subclass: #StackIPhoneConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackIPhoneConfig class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/22/2012 16:48'!
deviceIPad 
	^#(2)! !

!StackIPhoneConfig class methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/22/2012 16:48'!
deviceIPhone 
	^#(1)! !

!StackIPhoneConfig class methodsFor: 'accessing' stamp: ''!
deviceUniversal 
	^#(1 2)! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 9/6/2012 08:59'!
CFBundleIconFile 
	"512 x512 icon"
	^'Cog.png'! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 9/6/2012 08:59'!
CFBundleIconFile1024
	"1024x1024 icon"
	^'Cog.png'! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 9/6/2012 09:00'!
CFBundleIconFile57 
	"57x57 icon"
	^'Cog.png'! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 9/6/2012 09:00'!
CFBundleIconFile72
	"72x72 icon"
	^'Cog.png'! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 4/1/2013 20:29'!
CFBundleVersion
	^'1.0.0'! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/23/2012 18:32'!
ImageIsScrollable
	^false! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/23/2012 18:32'!
ImageIsWritable
	^true! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 2/22/2012 16:19'!
UIDeviceFamily
	^self targetedDeviceFamilyAsTemplateString! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 6/17/2012 14:15'!
UIFileSharingEnabled
	^false! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/23/2012 18:32'!
VMMemorySize
	^1024 * 1024 * 64 "64M"! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/23/2012 18:32'!
WebViewAsUI
	^false! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 10/23/2012 18:27'!
WebViewUrl
	^'http://localhost:8080'! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/23/2012 11:33'!
architecture 
	^'armv7'! !

!StackIPhoneConfig methodsFor: 'build script' stamp: 'EstebanLorenzano 3/8/2013 14:13'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!bash

if [ !! -e vmVersionInfo.h ]; then
	../codegen-scripts/extract-commit-info.sh
fi
cmake -G Xcode .
xcodebuild -sdk {sdk} -configuration Release -target {name}

' nameFormat: {#name->self executableName. #sdk->self sdkTarget} asDictionary! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2012 12:46'!
codeSignIdentity 
	^'iPhone Developer'! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 10/23/2012 15:31'!
commonCompilerFlags
	"Common compiler flags"
	^{
	"'-miphoneos-version-min=4.3'. "
	'-isysroot /Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/SDKs/{target}{sdkVersion}.sdk' nameFormat: { 'target'-> self targetDevice. 'sdkVersion'->self sdkVersion} asDictionary.
	'-x objective-c'.
	'-std=gnu99'.
	'-falign-functions=16'.
	'-fno-gcse'.
	'-fno-cse-follow-jumps'.
	'-fvisibility=hidden'.
	'-funroll-loops'.
	'-finline-functions'.
	'-mno-thumb'.
	'-fwrapv'.
	'-DSTACKVM=1'.
	'-DCOGMTVM=0'. 
	'-DUSE_GLOBAL_STRUCT=0'. 
	'-DBASE_HEADER_SIZE=4'.
	'-DTARGET_OS_IS_IPHONE'.
	'-DHAVE_UUID_GENERATE'.
	"'-DUSE_INLINE_MEMORY_ACCESSORS'. "
	'-DHAVE_SYS_TIME_H'.
	'-DLSB_FIRST'.
	'-DHAVE_NANOSLEEP'.
	'-DISQUEAK_IMAGE=', self imageName.
	'-DISQUEAK_SOURCES=PharoV10'.
	'-DSTACKVM'}! !

!StackIPhoneConfig methodsFor: 'settings' stamp: ''!
compilerFlagsDebug
	^#('-g3' '-O0' '-DDEBUGVM=1')! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 10/23/2012 14:38'!
compilerFlagsRelease
	^#('-g0' '-O3' '-fomit-frame-pointer' '-DNDEBUG' '-DDEBUGVM=0')! !

!StackIPhoneConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 2/28/2013 13:05'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib devRoot sdkRoot |

	devRoot := '/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer'
		nameFormat: { 'target'->self targetDevice} asDictionary.
	sdkRoot := '{devRoot}/SDKs/{target}{sdkVersion}.sdk' 
		nameFormat: {
			'devRoot'->devRoot. 
			'target'->self targetDevice.
			'sdkVersion'->self sdkVersion} asDictionary.

	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.
	lib configurationFlags: ({
		'--without-zlib'.
		'--without-bzip2'.
 		'--host=arm-apple-darwin'.
		'--enable-static=yes'. 
		'--enable-shared=no'.
		'CC={devRoot}/usr/bin/gcc'.
		'CXX={devRoot}/usr/bin/g++'.
		'CFLAGS=\\"-arch {architecture} -std=c99 -Wno-trigraphs -O2 -fwrapv -Wreturn-type -Wunused-variable -fmessage-length=0 -miphoneos-version-min=4.0 -I{sdkRoot}/usr/include/libxml2 -isysroot {sdkRoot}\\"'.
		'LDFLAGS=\\"-arch {architecture} -isysroot {sdkRoot}\\"'}
		collect: [ :each | each nameFormat: {
			'architecture'->self architecture. 
			'sdkRoot'->sdkRoot. 
			'devRoot'->devRoot} asDictionary ]).

	"link plugin with freetype lib"
	maker addExternalLibrary: '${thirdpartyDir}/out/lib/', lib libraryFileName.
	maker includeDirectories: lib includeDir. ! !

!StackIPhoneConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/10/2012 17:38'!
configureHostWindowPlugin: maker
	maker includeDirectories: '${platformsDir}/Cross/plugins/HostWindowPlugin'.	
	maker 
		addSources: #('sqMacHostWindow.m' ) 
		prefixed: '${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin/'
! !

!StackIPhoneConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 3/6/2012 12:33'!
configureIOSPlugin: maker
	maker 
		addSources: #('sqTouch.m' ) 
		prefixed: '${platformsDir}/iOS/vm/iPhone/plugins/IOSPlugin/'
	 
! !

!StackIPhoneConfig methodsFor: 'plugin extra rules' stamp: ''!
configureSocketPlugin: maker
	super configureSocketPlugin: maker.
	maker includeDirectories: '${SDKROOT}/usr/include'.  "for tcp.h"! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/18/2011 15:07'!
defaultExternalPlugins 
	^#()! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 5/26/2012 14:04'!
defaultInternalPlugins
	^ #(
		ADPCMCodecPlugin
		BMPReadWriterPlugin 
		BalloonEnginePlugin 
		BitBltSimulation 
		DSAPlugin 
		DeflatePlugin 
		"DropPlugin"
		LocalePlugin 
		FFTPlugin 
		FilePlugin 
		FloatArrayPlugin 
		HostWindowPlugin 
		JPEGReadWriter2Plugin 
		JPEGReaderPlugin 
		LargeIntegersPlugin 
		Matrix2x3Plugin 
		MiscPrimitivePlugin 
		"RePlugin" 
		SecurityPlugin 
		SocketPlugin
		SoundCodecPlugin 
		SoundGenerationPlugin 
		SoundPlugin
		SurfacePlugin
		UUIDPlugin
		ObjectiveCPlugin 
		IOSPlugin)! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2012 12:26'!
deploymentTargetVersion 
	^'4.0'! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/18/2011 19:40'!
executableName
	^ 'iStackVM'! !

!StackIPhoneConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 12/30/2011 19:17'!
extraPluginSettings: maker	
	self architecture
		ifNotNil: [ :arch | maker set: 'CMAKE_OSX_ARCHITECTURES' toString: arch ].
		
	self setCommonProperties: maker.

	maker 
		setTargetProperty: 'COMPILE_FLAGS' 
		to: '"-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'.  

	maker isExternal ifTrue: [
		"copy result to results dir "
		maker set: 'LIBRARY_OUTPUT_PATH' toString: self outputDir.
		maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
		maker puts: 'list(APPEND linkFlags "-undefined dynamic_lookup")' ].
	
	"maker addXCodeProperty: 'GCC_VERSION' value: '4.3'."
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/' , self executableName , '_Prefix.pch'.
	
! !

!StackIPhoneConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 5/27/2012 15:45'!
extraSources
	" mac VM using some unix sources "
	
	^'${buildDir}/', self prefixHeaderFileName, ' 
${resources} ', 
'${buildDir}/', self prefixHeaderFileName, ' 
${resourcesLocaleEnglish} 
${platformsDir}/unix/vm/sqUnixHeartbeat.c  
${platformsDir}/unix/vm/sqUnixThreads.c 
${platformsDir}/unix/vm/aio.c
'! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 5/26/2012 14:20'!
frameworks
	^ #(
	CoreAudio
	CoreGraphics
	CoreLocation
	UIKit
	CoreFoundation
	Foundation
	QuartzCore
	OpenGLES
	AudioToolbox
	SystemConfiguration)! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/7/2012 14:02'!
freetypeLibClass 
	^CMIOSFreetype2! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 11/14/2012 14:27'!
imageName
	^'iOS'! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/14/2012 14:35'!
imageResources 
	^{
	self imageName, '.changes'.
	'PharoV10.sources' }! !

!StackIPhoneConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 7/31/2012 12:02'!
platformSources
	"files added from platform/iOS/vm dir "
	^ #(
		'Common/main.m'
		'Common/Classes/Queue.m'
		'Common/Classes/sqMacV2Time.c'
		'Common/Classes/sqSqueakAppDelegate.m'
		'Common/Classes/sqSqueakFileDirectoryAPI.m'
		'Common/Classes/sqSqueakFileDirectoryInterface.m'
		'Common/Classes/sqSqueakInfoPlistInterface.m'
		'Common/Classes/sqSqueakMainApplication.m'
		'Common/Classes/sqSqueakMainApplication+attributes.m'
		'Common/Classes/sqSqueakMainApplication+events.m'
		'Common/Classes/sqSqueakMainApplication+imageReadWrite.m'
		'Common/Classes/sqSqueakMainApplication+sound.m'
		'Common/Classes/sqSqueakMainApplication+vmAndImagePath.m'
		'Common/Classes/sqSqueakMainApplication+screen.m'
		'Common/Classes/sqSqueakMainApplication+cursor.m'
		"'Common/Classes/sqSqueakCursorAPI.m'"
		'Common/Classes/sqSqueakAttributesAPI.m'
		'Common/Classes/sqSqueakSoundAPI.m'
		'Common/Classes/sqSqueakVmAndImagePathAPI.m'
		'Common/Classes/sqSqueakMainApp.m'
		'Common/Classes/sqSqueakEventsAPI.m'
		'Common/Classes/sqSqueakScreenAPI.m'
		'Common/Classes/sqSqueakScreenAndWindow.m'
		'iPhone/Classes/SqueakNoOGLIPhoneAppDelegate.m'
		'iPhone/Classes/sqSqueakIPhoneApplication.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+attributes.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+clipboard.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+imageReadWrite.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+events.m'
		'iPhone/Classes/sqSqueakIPhoneApplication+Network.m'
		'iPhone/Classes/sqSqueakiPhoneApplication+sound.m'
		'iPhone/Classes/sqSqueakIPhoneFileDirectoryInterface.m'
		'iPhone/Classes/sqSqueakIPhoneInfoPlistInterface.m'
		'iPhone/Classes/sqiPhoneScreenAndWindow.m'
		'iPhone/Classes/SqueakUIView.m'
		'iPhone/Classes/SqueakUIViewCALayer.m'
		'iPhone/Classes/SqueakUIViewOpenGL.m'
		'iPhone/Classes/SqueakUIController.m'
		'iPhone/Classes/sqSqueakIPhoneClipboardAPI.m'
		'iPhone/macintoshextra.c'
		'iPhone/osExports.c'
		"'iPhone/sqDummyaio.c'" "I'm using real aio.c from unix (and seems to work)"
		'iPhone/sqMacV2Memory.c'
		'iPhone/sqMacUnixExternalPrims.m'
		)! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 4/1/2013 20:38'!
plistKeys 
	^super plistKeys, 
	#(CFBundleIconFile57 
	CFBundleIconFile72 
	CFBundleIconFile1024
	CFBundleVersion
	UIDeviceFamily 
	UIFileSharingEnabled
	VMMemorySize
	ImageIsWritable
	ImageIsScrollable
	WebViewAsUI
	WebViewUrl)
! !

!StackIPhoneConfig methodsFor: 'bundle strings' stamp: 'EstebanLorenzano 4/1/2013 20:45'!
plistTemplate 
	^'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>CFBundleDevelopmentRegion</key>
	<string>en</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CFBundleDisplayName</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIconFiles</key>
	<array>
		<string>@CFBundleIconFile@</string>
		<string>@CFBundleIconFile57@</string>
		<string>@CFBundleIconFile72@</string>
		<string>@CFBundleIconFile1024@</string>
	</array>	
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleResourceSpecification</key>
	<string>ResourceRules.plist</string>
	<key>CFBundleSignature</key>
	<string>FRAC</string>
	<key>CFBundleSupportedPlatforms</key>
	<array>
		<string>iPhoneOS</string>
	</array>
	<key>LSRequiresIPhoneOS</key>
	<true/>
	<key>MinimumOSVersion</key>
	<string>3.1.3</string>
	<key>NSMainNibFile</key>
	<string>MainWindow</string>
	<key>UIDeviceFamily</key>
	<array>
		@UIDeviceFamily@
	</array>
	<key>UIPrerenderedIcon</key>
	<false/>
	<key>UIStatusBarHidden</key>
	<true/>
	<key>UIFileSharingEnabled</key>
	<@UIFileSharingEnabled@/>
	<key>ImageIsWritable</key>
	<@ImageIsWritable@/>
	<key>ImageIsScrollable</key>
	<@ImageIsScrollable@/>
	<key>VMMemorySize</key>
	<integer>@VMMemorySize@</integer>
	<key>WebViewAsUI</key>
	<@WebViewAsUI@/>
	<key>WebViewUrl</key>
	<string>@WebViewUrl@</string>
</dict>
</plist>
'! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 11/29/2011 10:26'!
precompiledImports 
	^#(
	'Foundation/Foundation.h' 
	'UIKit/UIKit.h')! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 9/6/2012 19:05'!
resources 
	^{
	self CFBundleIconFile.
	self CFBundleIconFile57.
	self CFBundleIconFile72.
	self CFBundleIconFile1024.
	self imageName, '.image'}, 
	self imageResources
		! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/15/2012 16:45'!
resourcesDir 
	"Answer the value of resourcesDir"
	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'iosbuild' / 'resources') fullName ]! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/16/2013 10:20'!
sdkTarget 
	^'iphoneos', self sdkVersion! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/26/2013 12:49'!
sdkVersion 
	^'6.1'! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 10/23/2012 15:43'!
setCommonProperties: maker 
	maker set: 'CMAKE_CROSSCOMPILING' to: 'TRUE'.
	maker set: 'CMAKE_SYSTEM_NAME' to: 'Darwin'.
	maker set: 'CMAKE_SYSTEM_PROCESSOR' to: 'arm'.

	maker set: 'SDKVER' toString: self sdkVersion.
	maker set: 'DEVROOT' toString: ('/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer'
		nameFormat: {'target'->self targetDevice} asDictionary).
	maker set: 'SDKROOT' toString: '${DEVROOT}/SDKs/', self targetDevice,'${SDKVER}.sdk'.

	maker set: 'CMAKE_OSX_SYSROOT' to: 'iphoneos${SDKVER}'.
		
	maker set: 'CMAKE_FIND_ROOT_PATH' to: '"${SDKROOT}" "${DEVROOT}"'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_PROGRAM' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_LIBRARY' to: 'ONLY'.
	maker set: 'CMAKE_FIND_ROOT_PATH_MODE_INCLUDE' to: 'ONLY'.
	
	maker set: 'CMAKE_EXE_LINKER_FLAGS' toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.
	maker set: 'CMAKE_C_FLAGS' toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.
	maker set: 'CMAKE_CXX_FLAGS' toString: '--sysroot ${SDKROOT} -L${SDKROOT}/usr/lib -L${SDKROOT}/usr/lib/system'.

	maker addFrameworks: self frameworks.! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 5/10/2012 17:20'!
setExtraTargetProperties: maker
	"super setExtraTargetProperties: maker."

	| precompiledHeaders plist |
	
	precompiledHeaders := (self executableName, '_Prefix.pch').
	(maker buildDir forceNewFileNamed: precompiledHeaders) 
		nextPutAll: self precompiledHeaders;
		close.
	
	maker addXCodeProperty: 'GCC_PREFIX_HEADER' value: '${buildDir}/', precompiledHeaders.
	
	self setCommonProperties: maker.

	" generated and add Info.plist file "
	plist := self plistFile.
	(maker buildDir forceNewFileNamed: 'Info.plist') 
		nextPutAll: plist; 
		close.

	maker addProperty: 'MACOSX_BUNDLE_INFO_PLIST' value: '${buildDir}/Info.plist'.  
	maker 
		cmd: 'set_target_properties' 
		params: self executableName, ' PROPERTIES COMPILE_FLAGS "-include \"', (self buildDir / self prefixHeaderFileName) fullName, '\""'. 

	maker set: 'CMAKE_XCODE_ATTRIBUTE_CODE_SIGN_IDENTITY' 
		toString: self codeSignIdentity.
	maker set: 'CMAKE_XCODE_ATTRIBUTE_TARGETED_DEVICE_FAMILY' 
		toString: self targetedDeviceFamilyAsString.
	maker set: 'CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET' 
		to: self deploymentTargetVersion.
	maker set: 'CMAKE_XCODE_ATTRIBUTE_CONFIGURATION_BUILD_DIR' 
		toString: '$(BUILD_DIR)/$(CONFIGURATION)'.
	maker set: 'CMAKE_XCODE_ATTRIBUTE_CONFIGURATION_TEMP_DIR' 
		toString: '$(BUILD_DIR)/$(CONFIGURATION)'.

	maker set: 'EXECUTABLE_OUTPUT_PATH' toString: self outputDir.
	
	maker puts: 'set_source_files_properties(${srcVMDir}/gcc3x-cointerp.c PROPERTIES COMPILE_FLAGS -O0)'
! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 3/20/2013 16:29'!
setGlobalOptions: maker
	"set any CMake global options, before declaring a project in cmake file"
	
"	maker 
		set: 'CMAKE_C_COMPILER' 
		to: ('/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/usr/bin/gcc'
			nameFormat: {'target' -> self targetDevice} asDictionary).
	maker 
		set: 'CMAKE_CXX_COMPILER' 
		to: ('/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/usr/bin/g++'
			nameFormat: {'target' -> self targetDevice } asDictionary).	
	self architecture ifNotNil: [
		maker set: 'CMAKE_OSX_ARCHITECTURES' to: self architecture ]."
	! !

!StackIPhoneConfig methodsFor: 'utils' stamp: 'EstebanLorenzano 3/20/2013 16:25'!
setGlobalOptionsAfterDetermineSystem: maker
	self setGlobalOptions: maker.	
	maker 
		set: 'CMAKE_OSX_SYSROOT' 
		to: ('/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/SDKs/{target}{sdkVersion}.sdk'
			nameFormat: { 'target'->self targetDevice. 'sdkVersion'->self sdkVersion } asDictionary)! !

!StackIPhoneConfig methodsFor: 'settings' stamp: 'EstebanLorenzano 2/15/2012 16:39'!
setResourceProperties: maker
	maker set: 'resourceDir' toString: self resourcesDir.

	maker 
		set: 'resources' 
		to: (String streamContents: [ :stream | 
			self  resources
				do: [ :each | 
					stream 
						nextPut: $";
						nextPutAll: '${resourceDir}/';
						nextPutAll: each;
						nextPut: $"]
				separatedBy: [ stream space ] ]).
		
	maker 
		set: 'resourcesLocaleEnglish' 
		toString: '${resourceDir}/English.lproj/MainWindow.nib'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.

	maker 
		cmd: 'set_source_files_properties' 
		params: '${resourcesLocaleEnglish} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
! !

!StackIPhoneConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 12/19/2011 11:32'!
standardIncludes
	^#(
	'${srcDir}/vm'
	'${platformsDir}/iOS/vm/iPhone'
	'${platformsDir}/iOS/vm/iPhone/Classes'
	'${platformsDir}/iOS/vm/OSX'
	'${platformsDir}/unix/vm'
	'${platformsDir}/iOS/vm/Common/Classes'
	'${platformsDir}/iOS/plugins/SoundPlugin'
	'${platformsDir}/iOS/vm/OSX/plugins/SoundPlugin'
	'${crossDir}/plugins/SoundPlugin'
	'${crossDir}/plugins/HostWindowPlugin'
	'${platformsDir}/Cross/plugins/HostWindowPlugin'
	'${platformsDir}/iOS/vm/iPhone/plugins/HostWindowPlugin'
	'${crossDir}/plugins/FilePlugin'
	)	
! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/23/2012 15:31'!
targetDevice 
	^'iPhoneOS'! !

!StackIPhoneConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 2/22/2012 17:19'!
targetedDeviceFamily 
	^self class deviceUniversal ! !

!StackIPhoneConfig methodsFor: 'private' stamp: ''!
targetedDeviceFamilyAsString 
	^String streamContents: [ :stream | 
		self targetedDeviceFamily 
			do: [ :each | stream nextPutAll: each asString ]
			separatedBy: [ stream nextPut: $, ].
		stream nextPut: Character space ]! !

!StackIPhoneConfig methodsFor: 'private' stamp: ''!
targetedDeviceFamilyAsTemplateString 
	^String streamContents: [ :stream | 
		self targetedDeviceFamily do: [ :each | 
			stream 
				nextPutAll: '<integer>';
				nextPutAll: each asString;
				nextPutAll: '</integer>' ] ]! !

StackIPhoneConfig subclass: #StackSimulatorConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-IOS'!

!StackSimulatorConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/23/2012 15:18'!
architecture 
	^'i386'! !

!StackSimulatorConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/23/2012 17:59'!
executableName
	^'iStackVMSimulator'! !

!StackSimulatorConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 3/8/2013 13:39'!
sdkTarget 
	^'iphonesimulator', self sdkVersion! !

!StackSimulatorConfig methodsFor: 'source files' stamp: 'EstebanLorenzano 10/23/2012 15:32'!
standardIncludes 
	^super standardIncludes, {'/Applications/Xcode.app/Contents/Developer/Platforms/{target}.platform/Developer/SDKs/{target}{sdkVersion}.sdk/usr/include/'
	nameFormat: {'target'->self targetDevice. 'sdkVersion'->self sdkVersion} asDictionary}
		 ! !

!StackSimulatorConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 10/23/2012 15:31'!
targetDevice 
	^'iPhoneSimulator'! !

MacOSConfig subclass: #CogMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete configuration for building a CogVM 32 bit on Mac OS.

It is using a Carbon framework , which eventually will be replaced by Cocoa. (see CocoaIOSConfig and its subclasses).


Fore more information, check the class comments of all the superclasses.
!

CogMacOSConfig subclass: #CogMTMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMTMacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a thread-aware VM and threaded FFI CogVM for Mac using the Carbon library. This VM is normally known as CogMTVM.

Fore more information, check the class comments of all the superclasses.
!

!CogMTMacOSConfig methodsFor: 'compiler flags' stamp: 'IgorStasenko 3/19/2011 21:37'!
commonCompilerFlags

	"Common compiler flags"
	
	^ ' -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=1 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'	
	! !

!CogMTMacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 3/19/2011 21:32'!
configureReentrantIA32FFIPlugin: maker
	self error: 'use ThreadedIA32FFIPlugin instead'
! !

!CogMTMacOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 3/19/2011 21:32'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerpmt.c'
		)! !

!CogMTMacOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 3/19/2011 21:32'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		"UnixOSProcessPlugin ?? "
	)! !

!CogMTMacOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:24'!
executableName
	^ 'CogMTVM'! !

!CogMTMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/19/2011 21:30'!
interpreterClass
	^ CoInterpreterMT! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:14'!
CFBundleExecutable
	^ self executableName ! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:11'!
CFBundleGetInfoString

	^ self CFBundleShortVersionString
! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/25/2010 00:37'!
CFBundleIconFile

	"An application icon"
	^ 'Cog.icns'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:06'!
CFBundleIdentifier

	"A Java package style name (like 'com.myCompany.MyBundle') which is used to uniquely identify bundles."
	
	^ 'org.squeak.Cog'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/25/2010 01:36'!
CFBundleName

	"An application name"
	^ self executableName, ' (Carbon) 32bits'! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 19:46'!
CFBundleShortVersionString

	"An application version"
	^ self executableName, ' VM ' , self CFBundleVersion! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:09'!
CFBundleVersion

	"An application version"
	^ '4.0.0'! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:39'!
cogitClass
	"answer a class for machine code generation or nil"
	
	^ StackToRegisterMappingCogit ! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'EstebanLorenzano 4/11/2011 16:39'!
commonCompilerFlags

	"Common compiler flags"
	
	^ ' -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=0 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DBUILD_FOR_OSX -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'	
	
"	^ '-arch i386 -fmessage-length=0 -Wno-trigraphs -fpascal-strings -fasm-blocks -DCOGMTVM=0 -DUSE_GLOBAL_STRUCT=0 -DTARGET_API_MAC_CARBON -DHAVE_SYS_TIME_H -mmacosx-version-min=10.5'"! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:38'!
compilerFlags
	"depends on config ..."
	^ self compilerFlagsRelease! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/29/2011 11:10'!
compilerFlagsDebug

	^ self commonCompilerFlags , ' -g3 -O0 -Wmissing-prototypes -Wmissing-braces -Wparentheses -Wunused-function -Wunused-label -Wunused-parameter -Wunused-variable -Wunused-value -Wsign-compare -DDEBUGVM=1 -DEXTERNALPRIMSDEBUG=1 -gdwarf-2 '! !

!CogMacOSConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/26/2011 20:47'!
compilerFlagsRelease
" -mdynamic-no-pic "
	^ self commonCompilerFlags , ' -gdwarf-2 -O3 -funroll-loops -ftree-vectorize -msse3 -DDEBUGVM=0 -DNDEBUG -Wunused-value -Wuninitialized -falign-functions=16 -fno-gcse -mtune=prescott -march=pentium-m -mfpmath=sse -finline-functions -Wall -DUSE_INLINE_MEMORY_ACCESSORS'! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:10'!
configureDropPlugin: maker
	"extra rules for DropPlugin"
	super configureDropPlugin: maker.  
	maker addPlatformSources: #( 'sqMacDragDrop')
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 12/29/2010 15:19'!
configureFFIPlugin: maker
	"extra rules for FFIPlugin"

	
	"Never generate this plugin. Because it is a legacy code.
	For Cog FFI, use ReentrantFFIPlugin  (ReentrantIA32FFIPlugin for x86) "
	
	maker doNotGenerate: true.
	
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:12'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker includeDirectories: '${platformsDir}/unix/vm'.
	maker addPlatformSources: #( 'sqMacUnixFileInterface.c' 'sqMacDirectory.c')! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 17:01'!
configureHostWindowPlugin: maker
	"extra rules for HostWindowPlugin"

	super configureHostWindowPlugin: maker.  
	maker addPlatformSources: #( 'sqMacHostWindow.c' )
! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'MarianoMartinezPeck 4/10/2011 15:10'!
configureSoundPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/vm/'.
	maker addPlatformSources:
		#( 
			"This is commented because such file is not commited in the cog blessed commit hash f3fe94c828f66cd0e7c37cfa3434e384ff65915e. For more details see http://forum.world.st/Problem-generating-Mac-VM-td3438466.html "
			"'sqMacAudioDeviceList.c'"
			'sqMacUnixInterfaceSound.c' 
			'sqUnixSoundMacOSXJMM.c'
		)


! !

!CogMacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 12:17'!
configureUUIDPlugin: maker 
	"extra rules for UUIDPlugin"

	super configureUUIDPlugin: maker.    
	maker addPlatformSources:
		#( 'sqMacUUID.c')


! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/22/2010 15:12'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'cogit.c'
		'gcc3x-cointerp.c'
		)! !

!CogMacOSConfig methodsFor: 'plugins' stamp: 'IgorStasenko 8/8/2011 15:32'!
defaultExternalPlugins

	^ #(
		BochsIA32Plugin
		CroquetPlugin
		ThreadedIA32FFIPlugin "SqueakFFIPrims"
		FloatArrayPlugin
		FloatMathPlugin
		Mpeg3Plugin
		QuicktimePlugin
"		TestOSAPlugin  - not works"
		"UnixOSProcessPlugin ?? "
		)! !

!CogMacOSConfig methodsFor: 'plugins' stamp: 'Igor.Stasenko 12/22/2010 15:47'!
defaultInternalPlugins

	^ #(
		ADPCMCodecPlugin
		AsynchFilePlugin
		B3DAcceleratorPlugin
		BalloonEnginePlugin "B2DPlugin" 
		BitBltSimulation "BitBltPlugin"
		BMPReadWriterPlugin
		DeflatePlugin  "ZipPlugin"
		DropPlugin
		DSAPlugin "DSAPrims"
		FFTPlugin
		FilePlugin
		HostWindowPlugin
		IA32ABIPlugin "IA32ABI"
		InternetConfigPlugin
		JoystickTabletPlugin
		JPEGReaderPlugin
		JPEGReadWriter2Plugin
		KlattSynthesizerPlugin "Klatt"
		LargeIntegersPlugin "LargeIntegers"
		LocalePlugin
		MacMenubarPlugin
		Matrix2x3Plugin
		MIDIPlugin
		MiscPrimitivePlugin
		QVMProfileMacSupportPlugin
		RePlugin
		SecurityPlugin
		SerialPlugin
		SocketPlugin
		SoundCodecPlugin "SoundCodecPrims"
		SoundGenerationPlugin
		SoundPlugin
		StarSqueakPlugin
		SurfacePlugin
		UUIDPlugin
		)! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'IgorStasenko 3/23/2011 15:19'!
executableName
	^ 'CogVM'! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/23/2010 22:45'!
executableType
	^ 'MACOSX_BUNDLE'! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'Igor.Stasenko 12/23/2010 20:17'!
extraPluginSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/25/2010 01:03'!
extraSources
	" mac VM using some unix sources"
	
	^ 
	'${platformsDir}/unix/plugins/SocketPlugin/sqUnixSocket.c 
	${platformsDir}/unix/vm/aio.c 
	${platformsDir}/unix/plugins/AsynchFilePlugin/sqUnixAsynchFile.c
	${platformsDir}/unix/vm/sqUnixHeartbeat.c
	${platformsDir}/unix/vm/sqUnixVMProfile.c
	${platformsDir}/unix/vm/sqUnixThreads.c
	${resources}'! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'IgorStasenko 5/3/2011 15:52'!
extraVMSettings: maker
	
	"Cog currently runs only in 32 bit mode" 
	maker set: 'CMAKE_OSX_ARCHITECTURES' to: 'i386'.

	maker set: 'resourceDir' toString: self resourcesDir, '/ProjectBuilder'.
	maker set: 'resources' to: 
		'"${resourceDir}/Squeak VM.r"
		"${resourceDir}/Cog.icns"
		"${resourceDir}/Squeak.icns"
		"${resourceDir}/SqueakChanges.icns"
		"${resourceDir}/SqueakImage.icns"
		"${resourceDir}/SqueakPlugin.icns"
		"${resourceDir}/SqueakScript.icns"
		"${resourceDir}/SqueakGeneric.icns"
		"${resourceDir}/SqueakProject.icns"
		"${resourceDir}/SqueakSources.icns"'
! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/24/2010 19:39'!
frameworks

	^ #(
	Carbon
	AppKit
	IOKit
	CoreFoundation
	AudioToolbox
	CoreAudio
	OpenGL
	AGL
	QuickTime
	Foundation
	SystemConfiguration
	)! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'IgorStasenko 2/16/2011 10:50'!
generateSourceFiles

	^ CMakeGenScripts generateCogSources: self! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:30'!
interpreterClass
	^ CoInterpreter! !

!CogMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/22/2010 16:47'!
platformName
	^ 'Mac OS'! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/23/2010 20:00'!
platformSources
	"files added from platform/Mac OS/vm dir "
	^ #(
	'NSCursorWrappers.m'
	'nsPoolManagement.m'
	'osExports.c'
	'sqMacEncoding.c'
	'sqMacImageIO.c'
	'sqMacMain.c'
	'sqMacMemory.c'
	'sqMacNSPluginUILogic2.c'
	'sqMacTime.c'
	'sqMacUIAppleEvents.c'
	'sqMacUIClipBoard.c'
	'sqMacUIEventsUniversal.c'  " instead of: sqMacUIEvents.c "
	'sqMacUIMenuBarUniversal.c'
	'sqMacUnixCommandLineInterface.c'
	'sqMacUnixExternalPrims.c'
	'sqMacWindowUniversal.c'
	'version.c'	
	)! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:19'!
plistFile

	| plist |
	
	plist := self plistTemplate.
	
	#(
	CFBundleExecutable
	CFBundleGetInfoString
	CFBundleName
	CFBundleShortVersionString
	CFBundleVersion
	CFBundleIconFile
	CFBundleIdentifier ) do: [:key |
		plist := plist copyReplaceAll: '@' , key , '@' with: (self perform: key)
	].

	^ self fixLineEndsOf: plist! !

!CogMacOSConfig methodsFor: 'bundle strings' stamp: 'Igor.Stasenko 12/24/2010 16:12'!
plistTemplate
	^ 
	'<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
<plist version="1.0">
<dict>
	<key>LSMinimumSystemVersion</key>
	<string>10.5.0</string>
	<key>CFBundleDevelopmentRegion</key>
	<string>English</string>
	<key>CFBundleDocumentTypes</key>
	<array>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>image</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Image File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STim</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sources</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Sources File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STso</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>changes</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>Croquet.icns</string>
			<key>CFBundleTypeName</key>
			<string>Croquet Changes File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STch</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>sobj</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakScript.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Script File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SOBJ</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>pr</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakProject.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Project File</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>STpr</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>JPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>JPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TEXT</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TEXT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ttro</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ttro</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HTML</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HTML</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>RTF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>RTF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>TIFF </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>TIFF</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PICT </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PICT</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>URL  </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>URL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>ZIP </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>ZIP</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>zip </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>zip</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>BINA</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BINA</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>GIFf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>GIFf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>PNGf</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>PNGf</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3 </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MP3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MP3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPEG</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPEG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>mp3!!</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3!!</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG2</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG2</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>MPG </string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>MPG</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Mp3</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>mp3</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>M3U</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>M3U</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>SRCS</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>SRCS</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>Chng</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>Chng</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeName</key>
			<string>HPS5</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>HPS5</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Viewer</string>
		</dict>
		<dict>
			<key>CFBundleTypeExtensions</key>
			<array>
				<string>bundle</string>
			</array>
			<key>CFBundleTypeIconFile</key>
			<string>SqueakPlugin.icns</string>
			<key>CFBundleTypeName</key>
			<string>Squeak Plugin</string>
			<key>CFBundleTypeOSTypes</key>
			<array>
				<string>BNDL</string>
			</array>
			<key>CFBundleTypeRole</key>
			<string>Editor</string>
		</dict>
	</array>
	<key>CFBundleExecutable</key>
	<string>@CFBundleExecutable@</string>
	<key>CFBundleGetInfoString</key>
	<string>@CFBundleGetInfoString@</string>
	<key>CFBundleIconFile</key>
	<string>@CFBundleIconFile@</string>
	<key>CFBundleIdentifier</key>
	<string>@CFBundleIdentifier@</string>
	<key>CFBundleInfoDictionaryVersion</key>
	<string>6.0</string>
	<key>CFBundleName</key>
	<string>@CFBundleName@</string>
	<key>CFBundlePackageType</key>
	<string>APPL</string>
	<key>CFBundleShortVersionString</key>
	<string>@CFBundleShortVersionString@</string>
	<key>CFBundleSignature</key>
	<string>????</string>
	<key>CFBundleVersion</key>
	<string>@CFBundleVersion@</string>
	<key>CGDisableCoalescedUpdates</key>
	<true/>
	<key>LSBackgroundOnly</key>
	<false/>
	<key>NSServices</key>
	<array>
		<dict>
			<key>NSMenuItem</key>
			<dict>
				<key>default</key>
				<string>Squeak DoIt</string>
			</dict>
			<key>NSMessage</key>
			<string>doitandreturn</string>
			<key>NSPortName</key>
			<string>Squeak</string>
			<key>NSReturnTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
			<key>NSSendTypes</key>
			<array>
				<string>NSStringPboardType</string>
			</array>
		</dict>
	</array>
	<key>SqueakBrowserMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakBrowserMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakBrowserMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakBrowserMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakDebug</key>
	<integer>0</integer>
	<key>SqueakEncodingType</key>
	<string>UTF-8</string>
	<key>SqueakExplicitWindowOpenNeeded</key>
	<false/>
	<key>SqueakFloatingWindowGetsFocus</key>
	<true/>
	<key>SqueakHasQuitWithoutSaving</key>
	<false/>
	<key>SqueakImageName</key>
	<string>Squeak.image</string>
	<key>SqueakMaxHeapSize</key>
	<integer>536870912</integer>
	<key>SqueakMouseCmdButton1</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton2</key>
	<integer>3</integer>
	<key>SqueakMouseCmdButton3</key>
	<integer>2</integer>
	<key>SqueakMouseControlButton1</key>
	<integer>1</integer>
	<key>SqueakMouseControlButton2</key>
	<integer>3</integer>
	<key>SqueakMouseControlButton3</key>
	<integer>2</integer>
	<key>SqueakMouseNoneButton1</key>
	<integer>1</integer>
	<key>SqueakMouseNoneButton2</key>
	<integer>3</integer>
	<key>SqueakMouseNoneButton3</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton1</key>
	<integer>2</integer>
	<key>SqueakMouseOptionButton2</key>
	<integer>3</integer>
	<key>SqueakMouseOptionButton3</key>
	<integer>2</integer>
	<key>SqueakPluginsBuiltInOrLocalOnly</key>
	<false/>
	<key>SqueakUIFlushPrimaryDeferNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCheckForPossibleNeedEveryNMilliseconds</key>
	<integer>20</integer>
	<key>SqueakUIFlushSecondaryCleanupDelayMilliseconds</key>
	<integer>25</integer>
	<key>SqueakUIFlushUseHighPercisionClock</key>
	<true/>
	<key>SqueakUnTrustedDirectory</key>
	<string>~/Library/Preferences/Croquet/Internet/Untrusted/</string>
	<key>SqueakWindowAttribute</key>
	<data>ggAAHw==</data>
	<key>SqueakWindowHasTitle</key>
	<true/>
	<key>SqueakWindowType</key>
	<integer>6</integer>
</dict>
</plist>
'! !

!CogMacOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:50'!
prepareForGeneration
	^ self prepareForCogGeneration
! !

!CogMacOSConfig methodsFor: 'settings' stamp: 'IgorStasenko 7/5/2011 01:28'!
setExtraTargetProperties: maker

	super setExtraTargetProperties: maker.

	maker addFrameworks: self frameworks.	

	" generated and add Info.plist file "
	self write: self plistFile toFile: 'Info.plist'.
	maker 
		addProperty: 'MACOSX_BUNDLE_INFO_PLIST' 
		value: '${buildDir}/Info.plist'.

	maker cmd: 'set_source_files_properties' params: '${resources} PROPERTIES MACOSX_PACKAGE_LOCATION Resources'.
	
	maker set: 'EXECUTABLE_OUTPUT_PATH' to: '${outputDir}'.! !

!CogMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/23/2010 20:45'!
standardIncludes
	^ #(
	'SYSTEM /Developer/Headers/FlatCarbon'
	'${targetPlatform}/vm/Developer'  "for some unknown reason sqGnu.h is put there"
	
	'${crossDir}/plugins/SerialPlugin'   "for platforms/Mac OS/vm/osExports.c to work"
	'${targetPlatform}/plugins/FilePlugin'   "for sqMacFileLogic.h to work"
	'${targetPlatform}/plugins/HostWindowPlugin'  "for sqMacNSPluginUILogic2.c to work"
	'${crossDir}/plugins/HostWindowPlugin' "for same... "
	'${crossDir}/plugins/DropPlugin' "include DropPlugin.h"
	'${crossDir}/plugins/SocketPlugin'
	'${crossDir}/plugins/AsynchFilePlugin'
	'${platformsDir}/unix/vm'  "suppressing following:
		platforms/Mac OS/vm/sqMacMain.c:94:19: error: sqaio.h: No such file or directory
		platforms/Mac OS/vm/sqMacMain.c:96:28: error: sqUnixCharConv.h: No such file or directory"
	)
	! !

CogMacOSConfig subclass: #CogMacOSDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!CogMacOSDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a DEBUG CogVM for Mac using Carbon library. This VM is normally known as a debug CogVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

Fore more information, check the class comments of all the superclasses.
!

!CogMacOSDebugConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:37'!
compilerFlags

    ^  self compilerFlagsDebug! !

CogMacOSConfig subclass: #StackMacOSConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!StackMacOSConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a StackVM for Mac using the Carbon library.

This configuration generates sources/build files for building Stack-based interpreter on Mac OS X.
It is using a Carbon framework , which will be replaced by Cocoa soon. (see CocoaIOSConfig and its subclasses).

Fore more information, check the class comments of all the superclasses.
!

!StackMacOSConfig methodsFor: 'source files' stamp: 'Igor.Stasenko 12/30/2010 09:46'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackMacOSConfig methodsFor: 'accessing' stamp: 'Igor.Stasenko 12/30/2010 10:16'!
executableName
	^ 'StackVM'! !

!StackMacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 3/18/2011 02:06'!
interpreterClass
	^ StackInterpreter! !

!StackMacOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	^ self prepareForStackVMGeneration
! !

StackMacOSConfig subclass: #StackMacOSDebugConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-MacOS'!

!StackMacOSDebugConfig commentStamp: 'MarianoMartinezPeck 4/24/2011 15:34' prior: 0!
This is a concrete class which generates a DEBUG StackVM for Mac using Carbon library. This VM is normally known as a debug StackVM. The debug means that it is compiled with all the necessary symbolic symbols for debugging and can be debugged, for example, with GDB.

Fore more information, check the class comments of all the superclasses.
!

!StackMacOSDebugConfig methodsFor: 'compiler flags' stamp: 'MarianoMartinezPeck 4/1/2011 14:50'!
compilerFlags

    ^  self compilerFlagsDebug! !

!MacOSConfig methodsFor: 'build script' stamp: 'EstebanLorenzano 3/8/2013 14:13'!
buildScript
	"answer the build script for building everything"
	

	^ 
'#!!bash

if [ !! -e vmVersionInfo.h ]; then
	../codegen-scripts/extract-commit-info.sh
fi
cmake .
make
make install

'! !

!MacOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 1/3/2011 08:33'!
cMakeMacros 
	^'macro(add_framework appname fwname)
    find_library(FRAMEWORK_${fwname}
        NAMES ${fwname}
        PATHS ${CMAKE_OSX_SYSROOT}/System/Library
        PATH_SUFFIXES Frameworks
        NO_DEFAULT_PATH)
    if( ${FRAMEWORK_${fwname}} STREQUAL FRAMEWORK_${fwname}-NOTFOUND)
        message(ERROR ": Framework ${fwname} not found")
    else()
	  include_directories(SYSTEM /System/Library/Frameworks/${fwname}.framework/Headers)
	  target_link_libraries(${appname} ${FRAMEWORK_${fwname}})
    endif()
endmacro(add_framework)'  ! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 4/11/2011 14:14'!
configureB3DAcceleratorPlugin: maker
	"extra rules for B3DAcceleratorPlugin"
	
	super configureB3DAcceleratorPlugin: maker.  
	
	maker 
		includeDirectories: '/usr/X11/include';  "for GL.h"
		addPlatformSources: #( 'sqMacOpenGL.c' 'sqMacOpenGLInfo.c')
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'MarianoMartinezPeck 4/23/2011 13:30'!
configureClipboardExtendedPlugin: maker
	! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:16'!
configureCroquetPlugin: maker 
	"extra rules for CroquetPlugin"

	super configureCroquetPlugin: maker.  
	maker addPlatformSources: #('sqMacCroquet.c').
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:23'!
configureFFIPlugin: maker
	super configureFFIPlugin: maker.
	maker addPlatformSources: #( "'sqMacIntel-Win32.c'"
		'x86-sysv-MacIntel.c'
		'x86-sysv-asm-MacIntel.S'
	)! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/9/2012 03:40'!
configureFT2Plugin: maker
	"extra rules for Freetype plugin.
	a custom rule to build freetype library"
	| lib |
	
	maker isExternal ifFalse: [
		self error: 'building internal FT2Plugin is not supported yet'  	
	].

	"add freetype library into loop"
	lib := self addThirdpartyLibrary: 'freetype2'.

	"link plugin with freetype lib"
	maker addExternalLibrary: lib targetForLinking.
	maker includeDirectories: lib includeDir.
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureInternetConfigPlugin: maker
	"extra rules for InternetConfigPlugin"
	
	super configureInternetConfigPlugin: maker.  
	maker addPlatformSources: #( 'sqMacInternetConfiguration.c')
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:19'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 
			'HID_Error_Handler.c'
			'HID_Name_Lookup.c'
			'HID_Queue_Utilities.c'
			'HID_Utilities.c'
			'sqMacJoystickAndTablet.c'
			)
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureLocalePlugin: maker 
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	maker addPlatformSources: #( 'sqMacLocaleCarbon.c' )
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:20'!
configureMIDIPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureMIDIPlugin: maker.  
	maker addPlatformSources: #( 'sqMacMIDI.c')! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'Igor.Stasenko 1/15/2011 15:38'!
configureMpeg3Plugin: maker

	super configureMpeg3Plugin: maker.
	
	maker addPlatformSources: #(	
		'sqMacFileBits.c')
	! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 07:28'!
configureObjectiveCPlugin: maker
	maker doNotGenerate: true! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 6/7/2012 20:52'!
configurePlugin: aPlugin with: generator

	generator isExternal ifTrue: [
		" set output directory for dynamic library to Resources subdir in .app bundle location "
		generator 
			set: 'CMAKE_LIBRARY_OUTPUT_DIRECTORY' 
			toString: '${externalModulesDir}'
		].
	^ super configurePlugin: aPlugin with: generator
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/26/2011 23:12'!
configureQuicktimePlugin: maker
	
	maker includeDirectories: '${pluginPlatform}'.
	maker includeDirectories: '${crossDir}/plugins/SurfacePlugin'.
	
	" yes, this is not a typo , a file is named 'inteface' instead of 'interface' "

	maker addPlatformSources: #( 'sqMacQuicktimeInteface.c' ).
	
	maker addFrameworks: #( 'Carbon' 'QuickTime' ).! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/2/2011 11:21'!
configureSecurityPlugin: maker 
	"extra rules for SecurityPlugin"

	super configureSecurityPlugin: maker.  
	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
	maker addPlatformSources: #( 'sqMacSecurity.c' )! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 11/2/2012 11:37'!
configureSerialPlugin: maker 
	"extra rules for SerialPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SerialPlugin'.
	maker 
		addSources: #('sqUnixSerial.c') 
		prefixed: '${platformsDir}/unix/plugins/SerialPlugin/'


! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'EstebanLorenzano 1/3/2011 14:22'!
configureSocketPlugin: maker 
	"extra rules for SoundPlugin"

	super configureSoundPlugin: maker.  
	maker includeDirectories: '${platformsDir}/unix/plugins/SocketPlugin'.
	maker 
		addSources: #('sqUnixSocket.c') 
		prefixed: '${platformsDir}/unix/plugins/SocketPlugin/'


! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 8/9/2011 14:15'!
configureSoundGenerationPlugin: maker 
	"extra rules for SoundPlugin"

	maker doNotGenerate: true. 
	" The sources in platforms/Cross/plugins/SoundGenerationPlugin/sqOldSoundPrims.c 
	are out of date and need to be fixed before it can be built 
	
	
	maker 
		addCrossSources: #('sqOldSoundPrims.c') 

	"
! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/26/2011 23:11'!
configureTestOSAPlugin: maker
		
	maker addFrameworks: #( 'Carbon'  'ApplicationServices' ).! !

!MacOSConfig methodsFor: 'plugin extra rules' stamp: 'IgorStasenko 7/6/2011 05:21'!
configureUnixOSProcessPlugin: maker 
	"extra rules for UnixOSProcessPlugin"

	maker includeDirectories: '${crossDir}/plugins/FilePlugin'.
! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 22:17'!
defaultDirectoriesFromGitDir: gitRepository
	"Set the default values for all necessary directories taking into account the Git repostiory. An example to use this method is:
	MTCocoaIOSCogJitDebugConfig new
	defaultDirectoriesFromGitDir: '/Users/mariano/Pharo/vm/git/cogVM/blessed';
	generateSources; 
	generate.
	"
	| gitRepositoryString |
	gitRepositoryString :=  gitRepository, '/'.
	self srcDir: gitRepositoryString, self srcDirName.
    	self platformsDir: gitRepositoryString, self platformsDirName.
    	self buildDir: gitRepositoryString, self buildDirName.
	self resourcesDir: gitRepositoryString, self resourcesDirName.
	self outputDir: gitRepositoryString, self outputDirName.
	
	
	! !

!MacOSConfig methodsFor: 'accessing' stamp: 'EstebanLorenzano 7/3/2012 15:58'!
externalModulesDir
	"answer the location in VM bundle, where plugins and rest of dynamic libs will be copied,
	by default, it is Framerowks subdir. i.e: 
	
		Cog.app/Contents/Frameworks
		
	"
	
	^ '${outputDir}/', self executableName, '.app/Contents/MacOS/Plugins'! !

!MacOSConfig methodsFor: 'utils' stamp: 'IgorStasenko 6/9/2012 21:45'!
fixLibsTemplate

^
'include(GetPrerequisites)

message("Fixing library references in: ${externalModulesDir}")

FILE(GLOB libs  "${externalModulesDir}/*.dylib")

set(all_imports "")

foreach(lib ${libs})
	get_filename_component(libName "${lib}" NAME)
	list(APPEND libNames "${libName}")
	
	set(prereq "")
	get_prerequisites(${lib} prereq 1 0 "${bundlePath}" "")


	list(APPEND all_imports ${prereq})

endforeach(lib)

list(REMOVE_DUPLICATES all_imports)
set(replacements "")
message ( "Found imports: ${all_imports} " )

foreach(import ${all_imports})
	foreach(lib ${libNames})
		set(match "^.*${lib}$")
		if(import MATCHES ${match})
			set(replacement "${pluginsRelPath}/${lib}")
			message("Will replace: ${import} with: ${replacement}")
			set(replacements ${replacements} "-change" "${import}" "${replacement}")
		endif(import MATCHES ${match})
	endforeach(lib)
endforeach(import)

foreach(lib ${libs})
	get_filename_component(name ${lib} NAME)
	set(fixedName "${pluginsRelPath}/${name}")
	message("Fixing up: ${name}")

 	execute_process(COMMAND install_name_tool -id "${fixedName}" "${lib}" )

 	execute_process(COMMAND install_name_tool  ${replacements} ${lib} )

endforeach(lib)
'

! !

!MacOSConfig methodsFor: 'utils' stamp: 'EstebanLorenzano 1/3/2011 08:16'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 22:00'!
outputDir

	"the directory where built binaries will be stored"
	^ outputDir ifNil: [ outputDir := (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!MacOSConfig methodsFor: 'utils' stamp: 'EstebanLorenzano 7/3/2012 16:07'!
postBuildActions: gen

	" override to add custom rules after all targets is defined "
	
	self write: self fixLibsTemplate toFile: 'fix_libs.cmake'.
	
	
	gen
		set: #bundlePath toString: '${outputDir}/', self executableName, '.app';
		set: #pluginsRelPath toString: '@executable_path/Plugins'.

	gen
		puts: '
		INSTALL(CODE "
			set(externalModulesDir \"${externalModulesDir}\")
			set(bundlePath \"${bundlePath}\")
			set(pluginsRelPath \"${pluginsRelPath}\")
			
			include(fix_libs.cmake)
		")'
			
"					FILE(GLOB_RECURSE bLibs /${externalModulesDir}/*.*)
"! !

!MacOSConfig methodsFor: 'source generation' stamp: 'EstebanLorenzano 9/12/2011 09:51'!
prepareForGeneration
	! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:04'!
resourcesDir 
	"Answer the value of resourcesDir"

	^ resourcesDir ifNil: [ resourcesDir := (self topDir / 'macbuild/resources') fullName ]
	! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:03'!
resourcesDir: anObject
	"Set the value of platformsDir"

	resourcesDir := anObject! !

!MacOSConfig methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/12/2011 21:57'!
resourcesDirName
	^ 'macbuild/resources'! !

!MacOSConfig methodsFor: 'source generation' stamp: 'IgorStasenko 6/8/2012 03:04'!
setupDirectories: gen

	super setupDirectories: gen.
	
	gen set: #externalModulesDir toString: self externalModulesDir.
! !

CPlatformConfig subclass: #StackEvtAndroidConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CMakeVMMaker-Android'!

!StackEvtAndroidConfig commentStamp: 'golubovsky 7/24/2011 22:47' prior: 0!
A class to configure the Event-driven Stack Cog for Android. This configuration does not lead to building an executable; rather it prepares the source tree to be plugged into the jni subdirectory of an Android project.!

!StackEvtAndroidConfig methodsFor: 'source generation' stamp: 'golubovsky 7/28/2011 21:49'!
compilerFlags
	"Compiler flags for Android. Leave empty for now"
	^  ' -DDEBUG=22 '! !

!StackEvtAndroidConfig methodsFor: 'source files' stamp: 'golubovsky 7/31/2011 00:12'!
configH
	" right now its borrowed directly from unix, but likely will change"
	^ '
#ifndef __sq_config_h
#define __sq_config_h

/* explicit image width */

#define	HAVE_INTERP_H 1

/* package options */

#define	USE_X11 1
#define	USE_X11_GLX 1
/* #undef	USE_QUARTZ */
/* #undef	USE_QUARTZ_CGL */
/* #undef	USE_RFB */

/* libraries */

/* #undef	HAVE_LIBX11 */
/* #undef	HAVE_LIBXEXT */
#define	HAVE_LIBDL 1
/* #undef	HAVE_DYLD */
/* #undef	HAVE_LIBFFI */
/* #undef	HAVE_ICONV */

/* #undef	USE_AUDIO_NONE */
/* #undef	USE_AUDIO_SUN */
/* #undef	USE_AUDIO_NAS */
/* #undef	USE_AUDIO_OSS */
/* #undef	USE_AUDIO_MACOSX */
/* #undef	OSS_DEVICE */

/* header files */

#define	HAVE_UNISTD_H 1
/* #undef	NEED_GETHOSTNAME_P */

#define	HAVE_DIRENT_H 1
/* #undef	HAVE_SYS_NDIR_H */
/* #undef	HAVE_SYS_DIR_H */
/* #undef	HAVE_NDIR_H */

#define	HAVE_SYS_TIME_H 1
#define	TIME_WITH_SYS_TIME 1

/* #undef	HAVE_SYS_FILIO_H */

/* #undef	HAVE_SYS_AUDIOIO_H */
/* #undef	HAVE_SUN_AUDIOIO_H */

#define	HAVE_PTY_H 1
/* #undef	HAVE_UTIL_H */
/* #undef	HAVE_LIBUTIL_H */
#define	HAVE_STROPTS_H 1

#define	HAVE_GL_GL_H 1
/* #undef	HAVE_OPENGL_GL_H */

/* #undef	NEED_SUNOS_H */

/* system calls/library functions */

#define	AT_EXIT atexit

#define	HAVE_TZSET 1

#define	HAVE_OPENPTY 1
/* #undef	HAVE_UNIX98_PTYS */

#define	HAVE_SNPRINTF 1
/* #undef	HAVE___SNPRINTF */

#define	HAVE_MMAP 1

/* #undef	HAVE_DYLD */

#define	HAVE_LANGINFO_CODESET 1

#define	HAVE_ALLOCA 1
#define	HAVE_ALLOCA_H 1

#define	HAVE_UNSETENV 1

#define	HAVE_NANOSLEEP 1

/* widths of primitive types */

#define	SIZEOF_INT 4
#define	SIZEOF_LONG 4
#define	SIZEOF_LONG_LONG 8
#define	SIZEOF_VOID_P 4

/* structures */

#define	HAVE_TM_GMTOFF 1
#define	HAVE_TIMEZONE 1

/* typedefs */

/* #undef	size_t */
/* #undef	socklen_t */

#define	squeakInt64 long long

/* architecture */

#define	OS_TYPE "unix"

#define	VM_HOST "i686-pc-linux-gnu"
#define	VM_HOST_CPU "i686"
/* #undef	VM_HOST_VENDOR */
#define	VM_HOST_OS "linux-gnu"
#define	VM_BUILD_STRING "Unix built on "__DATE__ " "__TIME__" Compiler: "__VERSION__

/* #undef	WORDS_BIGENDIAN */
/* #undef	DOUBLE_WORD_ALIGNMENT */

/* damage containment */

/* #undef	DARWIN */

#ifdef NEED_SUNOS_H
# include "sunos.h"
#endif

/* other configured variables */

#define SQ_VERSION "3.9a-7024"
#define VM_VERSION "3.9-7"
#define VM_MODULE_PREFIX ""
/* #undef VM_DLSYM_PREFIX */
#define VM_X11DIR ""

/* avoid dependencies on glibc2.3 */

#define HAVE_FEATURES_H 1

#if defined(HAVE_FEATURES_H)
# include "glibc.h"
#endif


/* used by UUID plugin: */

#define HAVE_UUID_H 1

#endif /* __sq_config_h */
																																																																					
																																																																				'! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 8/1/2011 23:04'!
configureFileCopyPlugin: maker
	"extra rules for DropPlugin"

	maker addPlatformSources: #( 'sqAndroidFileCopyPlugin.c')
! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 8/1/2011 23:17'!
configureFilePlugin: maker
	"extra rules for FilePlugin"

	super configureFilePlugin: maker.  
	
	maker addPlatformSources: #( 'sqAndroidFile.c')! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 7/29/2011 23:00'!
configureFloatMathPlugin: maker
	"extra rules for FloatMathPlugin"

	maker addCrossSources: #(
		'acos.c' 'acosh.c' 'asin.c' 'asinh.c' 'atan.c' 'atan2.c' 'atanh.c'
		'copysign.c' 'cos.c' 'cosh.c' 'exp.c' 'expm1.c' 'finite.c' 'fmod.c'
		'hypot.c' 'isnan.c' 'k_cos.c' 'k_rem_pio2.c' 'k_sin.c' 'k_tan.c' 'ldexp.c'
		'log.c' 'log10.c' 'log1p.c' 'modf.c' 'pow.c' 'rem_pio2.c' 'rint.c'
		'scalb.c' 'scalbn.c' 'sin.c' 'sinh.c' 'sqrt.c' 'tan.c' 'tanh.c' ).

	
	"according to http://www.netlib.org/fdlibm/readme
	it should be compiled with no optimizations"
	maker addDefinitions: '-O0'.
	
	" compile with -D__LITTLE_ENDIAN
		This macro is set automatically in fdlibm.h when compiled ith -m32 but
		not when compiled with -m64 (Nicolas Cellier)
	"
	self isLittleEndian ifTrue: [
		maker addDefinitions: '-D__LITTLE_ENDIAN=1' ].

	maker addDefinitions: '-DNO_ISNAN'.
	

! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 8/1/2011 23:31'!
configureJoystickTabletPlugin: maker 
	"extra rules for JoystickTabletPlugin"
	
	super configureJoystickTabletPlugin: maker.  
	maker addPlatformSources:
		#( 'sqAndroidJoystickTablet.c' )
! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 1/4/2012 21:50'!
configureLocalePlugin: maker
	"extra rules for LocalePlugin"

	super configureLocalePlugin: maker.  
	
	maker addPlatformSources: #( 'sqAndroidLocale.c')! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 8/12/2011 00:22'!
configureSecurityPlugin: maker 
	"extra rules for MIDIPlugin"

	super configureSecurityPlugin: maker.
	
	maker addPlatformSources: #( 'sqAndroidSecurity.c')! !

!StackEvtAndroidConfig methodsFor: 'plugin extra rules' stamp: 'golubovsky 8/1/2011 23:04'!
configureSocketPlugin: maker 
	"extra rules for SocketPlugin"
	
	maker addPlatformSources: #( 'sqAndroidSocket.c')! !

!StackEvtAndroidConfig methodsFor: 'source files' stamp: 'golubovsky 7/26/2011 21:40'!
coreSources
	"files to include from src/vm dir"
	
	^ #(
		'gcc3x-interp.c'
		)! !

!StackEvtAndroidConfig methodsFor: 'source files' stamp: 'golubovsky 8/1/2011 21:19'!
crossSources 
	^#(
			'sqHeapMap.c'
			'sqNamedPrims.c'
			'sqVirtualMachine.c'
		)! !

!StackEvtAndroidConfig methodsFor: 'plugins' stamp: 'golubovsky 7/24/2011 23:08'!
defaultExternalPlugins
	^ #(
	)! !

!StackEvtAndroidConfig methodsFor: 'plugins' stamp: 'golubovsky 1/4/2012 21:43'!
defaultInternalPlugins
" took from unixbuild/bld/plugins.int"
	^ #(
		AndroidPlugin
		BitBltSimulation "BitBltPlugin"
		BalloonEnginePlugin "B2DPlugin" 
		BMPReadWriterPlugin 
		CroquetPlugin 
		DSAPlugin "DSAPrims" 
		FFTPlugin 
		FileCopyPlugin 
		FilePlugin 
		FloatArrayPlugin 
		FloatMathPlugin 
		JoystickTabletPlugin 
		JPEGReaderPlugin 
		LargeIntegersPlugin "LargeIntegers"
		Matrix2x3Plugin 
		LocalePlugin
		RePlugin 	
		SecurityPlugin 
		JPEGReadWriter2Plugin 
		SocketPlugin 
		MiscPrimitivePlugin 
		DeflatePlugin  "ZipPlugin"
		)! !

!StackEvtAndroidConfig methodsFor: 'source generation' stamp: 'golubovsky 7/30/2011 09:17'!
extraVMSettings: maker
	| versionC |
	self generateConfigH.
	
	"add a generated version.c"
	
	versionC := 'version.c'.

	maker 
		puts: '$(buildDir)/',versionC, ':' ;
		puts: ({Character tab}, '$(platformsDir)/android/config/verstamp ', '$(buildDir)/', versionC,' gcc');
		puts: {Character cr};
		puts: ('LOCAL_SRC_FILES += $(buildDir)/', versionC);
		puts: {Character cr}.
	.
	! !

!StackEvtAndroidConfig methodsFor: 'utils' stamp: 'golubovsky 7/25/2011 06:14'!
fixLineEndsOf: string
	^ string copyReplaceAll: String cr with: String lf! !

!StackEvtAndroidConfig methodsFor: 'source generation' stamp: 'golubovsky 7/27/2011 22:49'!
generate
	^ CMakeAndroidGenerator generate: self 	

! !

!StackEvtAndroidConfig methodsFor: 'source files' stamp: 'golubovsky 7/25/2011 05:49'!
generateConfigH
	"will fix that later"
	self write: self configH toFile: 'config.h'! !

!StackEvtAndroidConfig methodsFor: 'source generation' stamp: 'golubovsky 7/31/2011 13:25'!
interpreterClass
	^ StackEvtAndroidInterpreter! !

!StackEvtAndroidConfig methodsFor: 'utils' stamp: 'golubovsky 7/26/2011 21:16'!
mkFileList: anArray baseDir: aDir
	"answer the concatenated contents of the array interspersed with backslash-newline sequences"
	^ (anArray collect: [ :s | aDir, s]) inject: '' into: [ :s :n | s , #($\), {Character cr}, n ].! !

!StackEvtAndroidConfig methodsFor: 'directories' stamp: 'golubovsky 7/24/2011 23:16'!
outputDir

	"the directory where built binaries will be stored - for now it is copied from CogFamilyUnixConfig"
	^ outputDir ifNil: [ outputDir := (self buildDir containingDirectory fullName , '/', self outputDirName) ]
	! !

!StackEvtAndroidConfig methodsFor: 'source generation' stamp: 'golubovsky 7/24/2011 22:53'!
platformName
	^ 'android'! !

!StackEvtAndroidConfig methodsFor: 'source files' stamp: 'golubovsky 8/2/2011 21:34'!
platformSources
	"files added from platform/android/vm dir "
	^ #(
	'aio.c'
	'debug.c'
	'osExports.c'
	'sqAndroidCharConv.c'
	'sqAndroidExternalPrims.c'
	'sqAndroidEvtBeat.c'
	'sqAndroidEvtMain.c'
	'sqAndroidMemory.c'
	'sqAndroidVMProfile.c'
	'sqAndroidSemaphores.c'
	'sqAndroidSoundNull.c'
	'sqAndroidDisplay.c'
	)! !

!StackEvtAndroidConfig methodsFor: 'source generation' stamp: 'golubovsky 7/24/2011 22:55'!
prepareForGeneration

	"force using LF on Macs"
	CrLfFileStream defaultToLF.

	^ self prepareForStackVMGeneration
! !

!StackEvtAndroidConfig methodsFor: 'directories' stamp: 'golubovsky 7/30/2011 23:19'!
setupDirectories: gen
	"same logic as the super has, but use gmake syntax instead of cmake"
	| dirsInclude |

	" write the directories in separate include file"
	dirsInclude := gen captureOutputDuring: [
		gen
			set: #topDir to: ('$(ROOT)/', self topDir fullName); 
			set: #buildDir to: (self buildDir ifNil: ['$(topDir)/build'] ifNotNil: ['$(ROOT)/', self buildDir fullName] );
			set: #platformsDir to: ('$(ROOT)/', self platformsDir);
			set: #srcDir to: ('$(ROOT)/', self srcDir);
			set: #srcPluginsDir to: (pluginsDir ifNil: [ '$(srcDir)/plugins' ]);
			set: #srcVMDir to: '$(srcDir)/vm';
			set: #platformName to: self platformName;
			set: #targetPlatform to: '$(platformsDir)/$(platformName)';
			set: #crossDir to: '$(platformsDir)/Cross';
			set: #platformVMDir to: '$(targetPlatform)/vm'.
	].

	self write: dirsInclude toFile: 'cogdirs.mk'
! !
